/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 6;

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 7;

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 8;

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode))
        return -1;
      return 9;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 10;

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 11;

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 12;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 13;

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 14;

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode))
        return -1;
      return 15;

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode))
        return -1;
      return 16;

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 17;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode))
        return -1;
      return 18;

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode))
        return -1;
      return 19;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 20;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 21;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode))
        return -1;
      return 22;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode))
        return -1;
      return 23;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 24;

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode))
        return -1;
      return 25;

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode))
        return -1;
      return 26;

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode))
        return -1;
      return 27;

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 28;

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode))
        return -1;
      return 29;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 30;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 31;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 32;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 33;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      return 34;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode))
        return -1;
      return 35;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 36;

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode))
        return -1;
      return 37;

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode))
        return -1;
      return 38;

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode))
        return -1;
      return 39;

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode))
        return -1;
      return 40;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 41;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 42;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 43;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode))
        return -1;
      return 44;

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode))
        return -1;
      return 45;

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode))
        return -1;
      return 46;

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 47;

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode))
        return -1;
      return 48;

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode))
        return -1;
      return 49;

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode))
        return -1;
      return 50;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 5
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 6
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 7
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 10
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 11
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x16) != i1)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 12
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 13
      || GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 14
      || GET_MODE (x21) != E_SImode)
    return -1;
  x22 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x22) != i1)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 15
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 16
      || GET_MODE (x25) != E_SImode)
    return -1;
  x26 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x26) != i1)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 17
      || GET_MODE (x27) != E_SImode)
    return -1;
  x28 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 28
      || GET_MODE (x29) != E_SImode)
    return -1;
  x30 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x30) != i1)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 29
      || GET_MODE (x31) != E_SImode)
    return -1;
  x32 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 30
      || GET_MODE (x33) != E_SImode)
    return -1;
  x34 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != 31
      || GET_MODE (x35) != E_SImode)
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern0 (x1, 
E_RVVM8QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern0 (x1, 
E_RVVM4QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern0 (x1, 
E_RVVM2QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern0 (x1, 
E_RVVM1QImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern0 (x1, 
E_RVVM8HImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern0 (x1, 
E_RVVM4HImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern0 (x1, 
E_RVVM2HImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern0 (x1, 
E_RVVM1HImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern0 (x1, 
E_RVVM8SImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern0 (x1, 
E_RVVM4SImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern0 (x1, 
E_RVVM2SImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern0 (x1, 
E_RVVM1SImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern0 (x1, 
E_RVVM8DImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern0 (x1, 
E_RVVM4DImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern0 (x1, 
E_RVVM2DImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern0 (x1, 
E_RVVM1DImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern0 (x1, 
E_RVVMF2QImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern0 (x1, 
E_RVVMF4QImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern0 (x1, 
E_RVVMF8QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern0 (x1, 
E_RVVMF2HImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern0 (x1, 
E_RVVMF4HImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern0 (x1, 
E_RVVMF2SImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern0 (x1, 
E_V1QImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern0 (x1, 
E_V32QImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern0 (x1, 
E_V64QImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern0 (x1, 
E_V128QImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern0 (x1, 
E_V256QImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern0 (x1, 
E_V512QImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern0 (x1, 
E_V1024QImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern0 (x1, 
E_V2048QImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern0 (x1, 
E_V4096QImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern0 (x1, 
E_V16HImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern0 (x1, 
E_V32HImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern0 (x1, 
E_V64HImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern0 (x1, 
E_V128HImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern0 (x1, 
E_V256HImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern0 (x1, 
E_V512HImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern0 (x1, 
E_V1024HImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern0 (x1, 
E_V2048HImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern0 (x1, 
E_V8SImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern0 (x1, 
E_V16SImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern0 (x1, 
E_V32SImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern0 (x1, 
E_V64SImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern0 (x1, 
E_V128SImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern0 (x1, 
E_V256SImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern0 (x1, 
E_V512SImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern0 (x1, 
E_V1024SImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern0 (x1, 
E_V4DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern0 (x1, 
E_V8DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern0 (x1, 
E_V16DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern0 (x1, 
E_V32DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern0 (x1, 
E_V64DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern0 (x1, 
E_V128DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern0 (x1, 
E_V256DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern0 (x1, 
E_V512DImode) != 0)
        return -1;
      return 67;

    case E_RVVM8HFmode:
      if (pattern0 (x1, 
E_RVVM8HFmode) != 0)
        return -1;
      return 68;

    case E_RVVM4HFmode:
      if (pattern0 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 69;

    case E_RVVM2HFmode:
      if (pattern0 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 70;

    case E_RVVM1HFmode:
      if (pattern0 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 71;

    case E_RVVMF2HFmode:
      if (pattern0 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 72;

    case E_RVVMF4HFmode:
      if (pattern0 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM8SFmode:
      if (pattern0 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 74;

    case E_RVVM4SFmode:
      if (pattern0 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 75;

    case E_RVVM2SFmode:
      if (pattern0 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 76;

    case E_RVVM1SFmode:
      if (pattern0 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF2SFmode:
      if (pattern0 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8DFmode:
      if (pattern0 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4DFmode:
      if (pattern0 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2DFmode:
      if (pattern0 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1DFmode:
      if (pattern0 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 82;

    case E_V1HFmode:
      if (pattern0 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 83;

    case E_V2HFmode:
      if (pattern0 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 84;

    case E_V4HFmode:
      if (pattern0 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 85;

    case E_V8HFmode:
      if (pattern0 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 86;

    case E_V16HFmode:
      if (pattern0 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 87;

    case E_V32HFmode:
      if (pattern0 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 88;

    case E_V64HFmode:
      if (pattern0 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 89;

    case E_V128HFmode:
      if (pattern0 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 90;

    case E_V256HFmode:
      if (pattern0 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 91;

    case E_V512HFmode:
      if (pattern0 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 92;

    case E_V1024HFmode:
      if (pattern0 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 93;

    case E_V2048HFmode:
      if (pattern0 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 94;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 95;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 96;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 97;

    case E_V8SFmode:
      if (pattern0 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 98;

    case E_V16SFmode:
      if (pattern0 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 99;

    case E_V32SFmode:
      if (pattern0 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 100;

    case E_V64SFmode:
      if (pattern0 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 101;

    case E_V128SFmode:
      if (pattern0 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 102;

    case E_V256SFmode:
      if (pattern0 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 103;

    case E_V512SFmode:
      if (pattern0 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 104;

    case E_V1024SFmode:
      if (pattern0 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 105;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 106;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 107;

    case E_V4DFmode:
      if (pattern0 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 108;

    case E_V8DFmode:
      if (pattern0 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 109;

    case E_V16DFmode:
      if (pattern0 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 110;

    case E_V32DFmode:
      if (pattern0 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 111;

    case E_V64DFmode:
      if (pattern0 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 112;

    case E_V128DFmode:
      if (pattern0 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 113;

    case E_V256DFmode:
      if (pattern0 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 114;

    case E_V512DFmode:
      if (pattern0 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 115;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode)
          || GET_MODE (x1) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode)
          || GET_MODE (x1) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode)
          || GET_MODE (x1) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || GET_MODE (x1) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 3;

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || GET_MODE (x1) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 4;

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode)
          || GET_MODE (x1) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 5;

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 6;

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 7;

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 8;

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 9;

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 13;

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 14;

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 15;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 16;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 17;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 18;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 19;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 20;

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 21;

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode)
          || GET_MODE (x1) != E_V128QImode
          || !register_operand (operands[1], E_V128HImode))
        return -1;
      return 22;

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode)
          || GET_MODE (x1) != E_V256QImode
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 23;

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode)
          || GET_MODE (x1) != E_V512QImode
          || !register_operand (operands[1], E_V512HImode))
        return -1;
      return 24;

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode)
          || GET_MODE (x1) != E_V1024QImode
          || !register_operand (operands[1], E_V1024HImode))
        return -1;
      return 25;

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode)
          || GET_MODE (x1) != E_V2048QImode
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 26;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 27;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 28;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 29;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 30;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 31;

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 32;

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 33;

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128SImode))
        return -1;
      return 34;

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 35;

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512SImode))
        return -1;
      return 36;

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024SImode))
        return -1;
      return 37;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 38;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 39;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 40;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 41;

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16DImode))
        return -1;
      return 42;

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32DImode))
        return -1;
      return 43;

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64DImode))
        return -1;
      return 44;

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128DImode))
        return -1;
      return 45;

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256DImode))
        return -1;
      return 46;

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512DImode))
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern192 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern192 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern192 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern192 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern192 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern192 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern192 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern192 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern192 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern192 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern192 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern192 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern192 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern192 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern192 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern192 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern192 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern192 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern192 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern192 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern192 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern192 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM8BFmode:
      if (pattern192 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 22;

    case E_RVVM4BFmode:
      if (pattern192 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 23;

    case E_RVVM2BFmode:
      if (pattern192 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1BFmode:
      if (pattern192 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2BFmode:
      if (pattern192 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 26;

    case E_RVVMF4BFmode:
      if (pattern192 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVM8HFmode:
      if (pattern192 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 28;

    case E_RVVM4HFmode:
      if (pattern192 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 29;

    case E_RVVM2HFmode:
      if (pattern192 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 30;

    case E_RVVM1HFmode:
      if (pattern192 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF2HFmode:
      if (pattern192 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4HFmode:
      if (pattern192 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVM8SFmode:
      if (pattern192 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 34;

    case E_RVVM4SFmode:
      if (pattern192 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 35;

    case E_RVVM2SFmode:
      if (pattern192 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 36;

    case E_RVVM1SFmode:
      if (pattern192 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF2SFmode:
      if (pattern192 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVM8DFmode:
      if (pattern192 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 39;

    case E_RVVM4DFmode:
      if (pattern192 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 40;

    case E_RVVM2DFmode:
      if (pattern192 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 41;

    case E_RVVM1DFmode:
      if (pattern192 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_V1QImode:
      if (pattern192 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 43;

    case E_V2QImode:
      if (pattern192 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 44;

    case E_V4QImode:
      if (pattern192 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 45;

    case E_V8QImode:
      if (pattern192 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 46;

    case E_V16QImode:
      if (pattern192 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 47;

    case E_V32QImode:
      if (pattern192 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 48;

    case E_V64QImode:
      if (pattern192 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 49;

    case E_V128QImode:
      if (pattern192 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 50;

    case E_V256QImode:
      if (pattern192 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 51;

    case E_V512QImode:
      if (pattern192 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 52;

    case E_V1024QImode:
      if (pattern192 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 53;

    case E_V2048QImode:
      if (pattern192 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 54;

    case E_V4096QImode:
      if (pattern192 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 55;

    case E_V1HImode:
      if (pattern192 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 56;

    case E_V2HImode:
      if (pattern192 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 57;

    case E_V4HImode:
      if (pattern192 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 58;

    case E_V8HImode:
      if (pattern192 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 59;

    case E_V16HImode:
      if (pattern192 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 60;

    case E_V32HImode:
      if (pattern192 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 61;

    case E_V64HImode:
      if (pattern192 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 62;

    case E_V128HImode:
      if (pattern192 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 63;

    case E_V256HImode:
      if (pattern192 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 64;

    case E_V512HImode:
      if (pattern192 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 65;

    case E_V1024HImode:
      if (pattern192 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 66;

    case E_V2048HImode:
      if (pattern192 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 67;

    case E_V1SImode:
      if (pattern192 (x2, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2SImode:
      if (pattern192 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4SImode:
      if (pattern192 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8SImode:
      if (pattern192 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16SImode:
      if (pattern192 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32SImode:
      if (pattern192 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64SImode:
      if (pattern192 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128SImode:
      if (pattern192 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256SImode:
      if (pattern192 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512SImode:
      if (pattern192 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    case E_V1024SImode:
      if (pattern192 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 78;

    case E_V1DImode:
      if (pattern192 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 79;

    case E_V2DImode:
      if (pattern192 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 80;

    case E_V4DImode:
      if (pattern192 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 81;

    case E_V8DImode:
      if (pattern192 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 82;

    case E_V16DImode:
      if (pattern192 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 83;

    case E_V32DImode:
      if (pattern192 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 84;

    case E_V64DImode:
      if (pattern192 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 85;

    case E_V128DImode:
      if (pattern192 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 86;

    case E_V256DImode:
      if (pattern192 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 87;

    case E_V512DImode:
      if (pattern192 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 88;

    case E_V1HFmode:
      if (pattern192 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 89;

    case E_V2HFmode:
      if (pattern192 (x2, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 90;

    case E_V4HFmode:
      if (pattern192 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 91;

    case E_V8HFmode:
      if (pattern192 (x2, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 92;

    case E_V16HFmode:
      if (pattern192 (x2, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 93;

    case E_V32HFmode:
      if (pattern192 (x2, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 94;

    case E_V64HFmode:
      if (pattern192 (x2, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 95;

    case E_V128HFmode:
      if (pattern192 (x2, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 96;

    case E_V256HFmode:
      if (pattern192 (x2, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 97;

    case E_V512HFmode:
      if (pattern192 (x2, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 98;

    case E_V1024HFmode:
      if (pattern192 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 99;

    case E_V2048HFmode:
      if (pattern192 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 100;

    case E_V1SFmode:
      if (pattern192 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 101;

    case E_V2SFmode:
      if (pattern192 (x2, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 102;

    case E_V4SFmode:
      if (pattern192 (x2, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 103;

    case E_V8SFmode:
      if (pattern192 (x2, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 104;

    case E_V16SFmode:
      if (pattern192 (x2, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 105;

    case E_V32SFmode:
      if (pattern192 (x2, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 106;

    case E_V64SFmode:
      if (pattern192 (x2, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 107;

    case E_V128SFmode:
      if (pattern192 (x2, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 108;

    case E_V256SFmode:
      if (pattern192 (x2, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 109;

    case E_V512SFmode:
      if (pattern192 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 110;

    case E_V1024SFmode:
      if (pattern192 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 111;

    case E_V1DFmode:
      if (pattern192 (x2, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 112;

    case E_V2DFmode:
      if (pattern192 (x2, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 113;

    case E_V4DFmode:
      if (pattern192 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 114;

    case E_V8DFmode:
      if (pattern192 (x2, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 115;

    case E_V16DFmode:
      if (pattern192 (x2, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 116;

    case E_V32DFmode:
      if (pattern192 (x2, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 117;

    case E_V64DFmode:
      if (pattern192 (x2, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 118;

    case E_V128DFmode:
      if (pattern192 (x2, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 119;

    case E_V256DFmode:
      if (pattern192 (x2, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 120;

    case E_V512DFmode:
      if (pattern192 (x2, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 121;

    default:
      return -1;
    }
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern168 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern168 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern168 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern168 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern168 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern168 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern168 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern168 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern168 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern168 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern168 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern168 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern168 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern168 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern168 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern168 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern168 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern168 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern168 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern168 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern168 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern168 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern168 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern168 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern168 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern168 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern168 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern168 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern168 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern168 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern168 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern168 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern168 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern168 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern168 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern168 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern168 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern168 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern168 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern168 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern168 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern168 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern168 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern168 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern168 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern168 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern168 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern168 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern246 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_all_trues_mask_operand (operands[3], i2)
      || !vector_const_0_operand (operands[5], i1)
      || !vector_merge_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vector_all_trues_mask_operand (operands[4], i1)
      || !vector_const_0_operand (operands[9], i2)
      || !vector_merge_operand (operands[10], i2)
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x1, 2);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8HImode:
          return pattern248 (x2, 
E_RVVMF2BImode, 
E_RVVM8HImode, 
E_RVVM4QImode); /* [-1, 0] */

        case E_RVVM4HImode:
          if (pattern248 (x2, 
E_RVVMF4BImode, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0)
            return -1;
          return 5;

        case E_V1HImode:
          if (pattern248 (x2, 
E_V1BImode, 
E_V1HImode, 
E_V1QImode) != 0)
            return -1;
          return 6;

        case E_V2HImode:
          if (pattern248 (x2, 
E_V2BImode, 
E_V2HImode, 
E_V2QImode) != 0)
            return -1;
          return 7;

        case E_V4HImode:
          if (pattern248 (x2, 
E_V4BImode, 
E_V4HImode, 
E_V4QImode) != 0)
            return -1;
          return 8;

        case E_V8HImode:
          if (pattern248 (x2, 
E_V8BImode, 
E_V8HImode, 
E_V8QImode) != 0)
            return -1;
          return 9;

        case E_V16HImode:
          if (pattern248 (x2, 
E_V16BImode, 
E_V16HImode, 
E_V16QImode) != 0)
            return -1;
          return 10;

        case E_V32HImode:
          if (pattern248 (x2, 
E_V32BImode, 
E_V32HImode, 
E_V32QImode) != 0)
            return -1;
          return 11;

        case E_V64HImode:
          if (pattern248 (x2, 
E_V64BImode, 
E_V64HImode, 
E_V64QImode) != 0)
            return -1;
          return 12;

        case E_V128HImode:
          if (pattern248 (x2, 
E_V128BImode, 
E_V128HImode, 
E_V128QImode) != 0)
            return -1;
          return 13;

        case E_V256HImode:
          if (pattern248 (x2, 
E_V256BImode, 
E_V256HImode, 
E_V256QImode) != 0)
            return -1;
          return 14;

        case E_V512HImode:
          if (pattern248 (x2, 
E_V512BImode, 
E_V512HImode, 
E_V512QImode) != 0)
            return -1;
          return 15;

        case E_V1024HImode:
          if (pattern248 (x2, 
E_V1024BImode, 
E_V1024HImode, 
E_V1024QImode) != 0)
            return -1;
          return 16;

        case E_V2048HImode:
          if (pattern248 (x2, 
E_V2048BImode, 
E_V2048HImode, 
E_V2048QImode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8SImode:
          if (pattern248 (x2, 
E_RVVMF4BImode, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 18;

        case E_RVVM4SImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 19;

        case E_RVVM2SImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 20;

        case E_RVVM1SImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 21;

        case E_RVVMF2SImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 22;

        case E_V1SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V1BImode
              || GET_MODE (x3) != E_V1SImode
              || GET_MODE (x4) != E_V1SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V1SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V1BImode
              || !vector_all_trues_mask_operand (operands[4], E_V1BImode)
              || !vector_const_0_operand (operands[9], E_V1SImode)
              || !vector_merge_operand (operands[10], E_V1SImode)
              || !register_operand (operands[1], E_V1BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V1SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V1BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V1HImode:
              if (!register_operand (operands[3], E_V1HImode))
                return -1;
              return 23;

            case E_V1SImode:
              if (!register_operand (operands[3], E_V1SImode))
                return -1;
              return 24;

            default:
              return -1;
            }

        case E_V2SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V2BImode
              || GET_MODE (x3) != E_V2SImode
              || GET_MODE (x4) != E_V2SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V2SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V2BImode
              || !vector_all_trues_mask_operand (operands[4], E_V2BImode)
              || !vector_const_0_operand (operands[9], E_V2SImode)
              || !vector_merge_operand (operands[10], E_V2SImode)
              || !register_operand (operands[1], E_V2BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V2SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V2BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2HImode:
              if (!register_operand (operands[3], E_V2HImode))
                return -1;
              return 25;

            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 26;

            default:
              return -1;
            }

        case E_V4SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V4BImode
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_V4SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V4SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V4BImode
              || !vector_all_trues_mask_operand (operands[4], E_V4BImode)
              || !vector_const_0_operand (operands[9], E_V4SImode)
              || !vector_merge_operand (operands[10], E_V4SImode)
              || !register_operand (operands[1], E_V4BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V4SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V4BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 27;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 28;

            default:
              return -1;
            }

        case E_V8SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V8BImode
              || GET_MODE (x3) != E_V8SImode
              || GET_MODE (x4) != E_V8SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V8SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V8BImode
              || !vector_all_trues_mask_operand (operands[4], E_V8BImode)
              || !vector_const_0_operand (operands[9], E_V8SImode)
              || !vector_merge_operand (operands[10], E_V8SImode)
              || !register_operand (operands[1], E_V8BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V8SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V8BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 29;

            case E_V8SImode:
              if (!register_operand (operands[3], E_V8SImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        case E_V16SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V16BImode
              || GET_MODE (x3) != E_V16SImode
              || GET_MODE (x4) != E_V16SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V16SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V16BImode
              || !vector_all_trues_mask_operand (operands[4], E_V16BImode)
              || !vector_const_0_operand (operands[9], E_V16SImode)
              || !vector_merge_operand (operands[10], E_V16SImode)
              || !register_operand (operands[1], E_V16BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V16SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V16BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V16HImode:
              if (!register_operand (operands[3], E_V16HImode))
                return -1;
              return 31;

            case E_V16SImode:
              if (!register_operand (operands[3], E_V16SImode))
                return -1;
              return 32;

            default:
              return -1;
            }

        case E_V32SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V32BImode
              || GET_MODE (x3) != E_V32SImode
              || GET_MODE (x4) != E_V32SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V32SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V32BImode
              || !vector_all_trues_mask_operand (operands[4], E_V32BImode)
              || !vector_const_0_operand (operands[9], E_V32SImode)
              || !vector_merge_operand (operands[10], E_V32SImode)
              || !register_operand (operands[1], E_V32BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V32SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V32BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V32HImode:
              if (!register_operand (operands[3], E_V32HImode))
                return -1;
              return 33;

            case E_V32SImode:
              if (!register_operand (operands[3], E_V32SImode))
                return -1;
              return 34;

            default:
              return -1;
            }

        case E_V64SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V64BImode
              || GET_MODE (x3) != E_V64SImode
              || GET_MODE (x4) != E_V64SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V64SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V64BImode
              || !vector_all_trues_mask_operand (operands[4], E_V64BImode)
              || !vector_const_0_operand (operands[9], E_V64SImode)
              || !vector_merge_operand (operands[10], E_V64SImode)
              || !register_operand (operands[1], E_V64BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V64SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V64BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V64HImode:
              if (!register_operand (operands[3], E_V64HImode))
                return -1;
              return 35;

            case E_V64SImode:
              if (!register_operand (operands[3], E_V64SImode))
                return -1;
              return 36;

            default:
              return -1;
            }

        case E_V128SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V128BImode
              || GET_MODE (x3) != E_V128SImode
              || GET_MODE (x4) != E_V128SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V128SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V128BImode
              || !vector_all_trues_mask_operand (operands[4], E_V128BImode)
              || !vector_const_0_operand (operands[9], E_V128SImode)
              || !vector_merge_operand (operands[10], E_V128SImode)
              || !register_operand (operands[1], E_V128BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V128SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V128BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V128HImode:
              if (!register_operand (operands[3], E_V128HImode))
                return -1;
              return 37;

            case E_V128SImode:
              if (!register_operand (operands[3], E_V128SImode))
                return -1;
              return 38;

            default:
              return -1;
            }

        case E_V256SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V256BImode
              || GET_MODE (x3) != E_V256SImode
              || GET_MODE (x4) != E_V256SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V256SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V256BImode
              || !vector_all_trues_mask_operand (operands[4], E_V256BImode)
              || !vector_const_0_operand (operands[9], E_V256SImode)
              || !vector_merge_operand (operands[10], E_V256SImode)
              || !register_operand (operands[1], E_V256BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V256SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V256BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V256HImode:
              if (!register_operand (operands[3], E_V256HImode))
                return -1;
              return 39;

            case E_V256SImode:
              if (!register_operand (operands[3], E_V256SImode))
                return -1;
              return 40;

            default:
              return -1;
            }

        case E_V512SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V512BImode
              || GET_MODE (x3) != E_V512SImode
              || GET_MODE (x4) != E_V512SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V512SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V512BImode
              || !vector_all_trues_mask_operand (operands[4], E_V512BImode)
              || !vector_const_0_operand (operands[9], E_V512SImode)
              || !vector_merge_operand (operands[10], E_V512SImode)
              || !register_operand (operands[1], E_V512BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V512SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V512BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V512HImode:
              if (!register_operand (operands[3], E_V512HImode))
                return -1;
              return 41;

            case E_V512SImode:
              if (!register_operand (operands[3], E_V512SImode))
                return -1;
              return 42;

            default:
              return -1;
            }

        case E_V1024SImode:
          if (pattern248 (x2, 
E_V1024BImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8DImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 44;

        case E_RVVM4DImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 45;

        case E_RVVM2DImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 46;

        case E_RVVM1DImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1SImode)
      || GET_MODE (x1) != E_RVVM1SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 0;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 0;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern319 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8DImode)
      || GET_MODE (x1) != E_V8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SImode:
      if (!register_operand (operands[1], E_V512SImode))
        return -1;
      return 0;

    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 1;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern332 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x1, 1);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern339 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !fp_native_comparison (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[2], E_HFmode)
          || !register_operand (operands[3], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ASHIFT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != AND
      || GET_MODE (x8) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  x13 = XEXP (x8, 0);
  return pattern341 (x13); /* [-1, 3] */
}

int
pattern348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern350 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern350 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern354 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern354 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  operands[5] = x3;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      return pattern362 (x1, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF32BImode:
      if (pattern362 (x1, 
E_RVVMF32BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF16BImode:
      if (pattern362 (x1, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8BImode:
      if (pattern362 (x1, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4BImode:
      if (pattern362 (x1, 
E_RVVMF4BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF2BImode:
      if (pattern362 (x1, 
E_RVVMF2BImode) != 0)
        return -1;
      return 5;

    case E_RVVM1BImode:
      if (pattern362 (x1, 
E_RVVM1BImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern370 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != SUBREG
      || maybe_ne (SUBREG_BYTE (x6), 0)
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != AND
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != NOT
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x8, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x11 = XEXP (x7, 1);
  operands[2] = x11;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x12 = XEXP (x9, 0);
  operands[3] = x12;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern375 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || XVECLEN (x1, 0) != i2
      || XINT (x1, 1) != i1
      || GET_MODE (x1) != E_SImode)
    return -1;
  return 0;
}

int
pattern377 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_two_s12 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_CODE (x8) != SUBREG
      || maybe_ne (SUBREG_BYTE (x8), 0)
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != AND
      || GET_MODE (x9) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x10 = XEXP (x9, 1);
  operands[2] = x10;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x12 = XVECEXP (x1, 0, 1);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  x14 = XEXP (x9, 0);
  return pattern378 (x14); /* [-1, 1] */
}

int
pattern387 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern394 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  return 0;
}

int
pattern397 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT
      || GET_MODE (x5) != E_DImode)
    return -1;
  return 0;
}

int
pattern401 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != AND)
    return -1;
  return pattern227 (x2); /* [-1, 1] */
}

int
pattern405 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern414 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern419 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x1, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (GET_MODE (x4))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      return 4;

    default:
      return -1;
    }
}

int
pattern436 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern441 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4DImode:
      if (!register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 1;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 3;

    case E_V1DImode:
      if (!register_operand (operands[1], E_V1DImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 6;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 7;

    case E_V16DImode:
      if (!register_operand (operands[1], E_V16DImode))
        return -1;
      return 8;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 9;

    case E_V64DImode:
      if (!register_operand (operands[1], E_V64DImode))
        return -1;
      return 10;

    case E_V128DImode:
      if (!register_operand (operands[1], E_V128DImode))
        return -1;
      return 11;

    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 12;

    case E_V512DImode:
      if (!register_operand (operands[1], E_V512DImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern453 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern460 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern465 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 2);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[3] = x4;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      operands[0] = x2;
      return pattern464 (x1); /* [-1, 1] */

    case ZERO_EXTEND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x1, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !scratch_operand (operands[4], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern476 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XVECEXP (x2, 0, 0);
  operands[3] = x8;
  x9 = XVECEXP (x2, 0, 1);
  operands[4] = x9;
  if (!pmode_reg_or_0_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern475 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern475 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern475 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern475 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern475 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern475 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern475 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern475 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern475 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern475 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern475 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern475 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern475 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern475 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern475 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern475 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF8QImode:
      if (pattern475 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4HImode:
      if (pattern475 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2SImode:
      if (pattern475 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern489 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern488 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern488 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern488 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern488 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern488 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern488 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern488 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern488 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern488 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern488 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern488 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern488 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern488 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern488 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern488 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern488 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern488 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern488 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 17;

    case E_V1QImode:
      if (pattern488 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V2QImode:
      if (pattern488 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4QImode:
      if (pattern488 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8QImode:
      if (pattern488 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V16QImode:
      if (pattern488 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V32QImode:
      if (pattern488 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V64QImode:
      if (pattern488 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V128QImode:
      if (pattern488 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V256QImode:
      if (pattern488 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V512QImode:
      if (pattern488 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 27;

    case E_V1024QImode:
      if (pattern488 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 28;

    case E_V2048QImode:
      if (pattern488 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 29;

    case E_V4096QImode:
      if (pattern488 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      return 30;

    case E_V1HImode:
      if (pattern488 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V2HImode:
      if (pattern488 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V4HImode:
      if (pattern488 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V8HImode:
      if (pattern488 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V16HImode:
      if (pattern488 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V32HImode:
      if (pattern488 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V64HImode:
      if (pattern488 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V128HImode:
      if (pattern488 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 38;

    case E_V256HImode:
      if (pattern488 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 39;

    case E_V512HImode:
      if (pattern488 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 40;

    case E_V1024HImode:
      if (pattern488 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 41;

    case E_V2048HImode:
      if (pattern488 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
        return -1;
      return 42;

    case E_V1SImode:
      if (pattern488 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V2SImode:
      if (pattern488 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V4SImode:
      if (pattern488 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V8SImode:
      if (pattern488 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V16SImode:
      if (pattern488 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    case E_V32SImode:
      if (pattern488 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 48;

    case E_V64SImode:
      if (pattern488 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 49;

    case E_V128SImode:
      if (pattern488 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 50;

    case E_V256SImode:
      if (pattern488 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 51;

    case E_V512SImode:
      if (pattern488 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 52;

    case E_V1024SImode:
      if (pattern488 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
        return -1;
      return 53;

    case E_RVVM8DImode:
      if (pattern488 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      return 54;

    case E_RVVM4DImode:
      if (pattern488 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      return 55;

    case E_RVVM2DImode:
      if (pattern488 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      return 56;

    case E_RVVM1DImode:
      if (pattern488 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern488 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern488 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern488 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern488 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern488 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern488 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern488 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern488 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern488 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern488 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern504 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern505 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern504 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern504 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern504 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern504 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern504 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern504 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x7) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM2QImode:
          if (!register_operand (operands[3], E_RVVM2QImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 8;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 10;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 12;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 16;

        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 17;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 19;

        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 22;

        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 23;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 25;

        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 26;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V1HImode:
      if (pattern504 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 28;

    case E_V2HImode:
      if (pattern504 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 29;

    case E_V4HImode:
      if (pattern504 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 30;

    case E_V8HImode:
      if (pattern504 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 31;

    case E_V16HImode:
      if (pattern504 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 32;

    case E_V32HImode:
      if (pattern504 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 33;

    case E_V64HImode:
      if (pattern504 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 34;

    case E_V128HImode:
      if (pattern504 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 35;

    case E_V256HImode:
      if (pattern504 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 36;

    case E_V512HImode:
      if (pattern504 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 37;

    case E_V1024HImode:
      if (pattern504 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 38;

    case E_V2048HImode:
      if (pattern504 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 39;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 40;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 44;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 46;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 48;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 49;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 50;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 51;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 52;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 54;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 55;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 56;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 57;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 58;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x7) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[3], E_V1024HImode))
            return -1;
          return 60;

        case E_V1024QImode:
          if (!register_operand (operands[3], E_V1024QImode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 62;

        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 63;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 65;

        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 66;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 68;

        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 69;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 71;

        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 72;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 74;

        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 75;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 77;

        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 78;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 80;

        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 81;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 83;

        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 84;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 86;

        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 87;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 89;

        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 90;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern570 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!register_operand (x5, i1))
    return -1;
  return 0;
}

int
pattern572 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF64BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[2], E_RVVMF64BImode))
        return -1;
      return 0;

    case E_RVVMF32BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[2], E_RVVMF32BImode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[2], E_RVVMF16BImode))
        return -1;
      return 2;

    case E_RVVMF8BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[2], E_RVVMF8BImode))
        return -1;
      return 3;

    case E_RVVMF4BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[2], E_RVVMF4BImode))
        return -1;
      return 4;

    case E_RVVMF2BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF2BImode
          || !vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[2], E_RVVMF2BImode))
        return -1;
      return 5;

    case E_RVVM1BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVM1BImode
          || !vector_mask_operand (operands[1], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM1BImode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern578 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1)
      || !vector_move_operand (operands[3], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern579 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1BImode)
      || GET_MODE (x1) != E_RVVM1BImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_RVVM8QImode
      || !register_operand (operands[1], E_RVVM8QImode)
      || !vector_arith_operand (operands[2], E_RVVM8QImode))
    return -1;
  return 0;
}

int
pattern581 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XVECEXP (x2, 0, 5);
  operands[9] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x8, 1);
  operands[3] = x11;
  x12 = XEXP (x1, 2);
  operands[2] = x12;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern496 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern496 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern496 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern496 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern496 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern496 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern496 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern496 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern496 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern496 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern496 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern496 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern496 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern496 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern496 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern586 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern589 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern593 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!vector_neg_arith_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern596 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], E_QImode)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern600 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      return pattern480 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode); /* [-1, 0] */

    case E_RVVM4SImode:
      if (pattern480 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (pattern480 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (pattern480 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (pattern480 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern607 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!register_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern609 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[4], E_RVVM4HFmode)
          || !register_operand (operands[5], E_RVVM4HFmode))
        return -1;
      return 0;

    case E_RVVM8SFmode:
      if (!register_operand (operands[4], E_RVVM8SFmode)
          || !register_operand (operands[5], E_RVVM8SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern611 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM1HFmode:
      if (!register_operand (operands[4], E_RVVM1HFmode)
          || !register_operand (operands[5], E_RVVM1HFmode))
        return -1;
      return 0;

    case E_RVVM2SFmode:
      if (!register_operand (operands[4], E_RVVM2SFmode)
          || !register_operand (operands[5], E_RVVM2SFmode))
        return -1;
      return 1;

    case E_RVVM4DFmode:
      if (!register_operand (operands[4], E_RVVM4DFmode)
          || !register_operand (operands[5], E_RVVM4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1HFmode:
      if (!register_operand (operands[4], E_V1HFmode)
          || !register_operand (operands[5], E_V1HFmode))
        return -1;
      return 0;

    case E_V1SFmode:
      if (!register_operand (operands[4], E_V1SFmode)
          || !register_operand (operands[5], E_V1SFmode))
        return -1;
      return 1;

    case E_V1DFmode:
      if (!register_operand (operands[4], E_V1DFmode)
          || !register_operand (operands[5], E_V1DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern617 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[4], E_V8HFmode)
          || !register_operand (operands[5], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[4], E_V8SFmode)
          || !register_operand (operands[5], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!register_operand (operands[4], E_V8DFmode)
          || !register_operand (operands[5], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern620 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V64BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[4], E_V64HFmode)
          || !register_operand (operands[5], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[4], E_V64SFmode)
          || !register_operand (operands[5], E_V64SFmode))
        return -1;
      return 1;

    case E_V64DFmode:
      if (!register_operand (operands[4], E_V64DFmode)
          || !register_operand (operands[5], E_V64DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern624 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1024BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1024BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1024HFmode:
      if (!register_operand (operands[4], E_V1024HFmode)
          || !register_operand (operands[5], E_V1024HFmode))
        return -1;
      return 0;

    case E_V1024SFmode:
      if (!register_operand (operands[4], E_V1024SFmode)
          || !register_operand (operands[5], E_V1024SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern628 (rtx x1, machine_mode i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 18:
      if (REGNO (x12) != 9)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != SET)
        return -1;
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != MEM
          || GET_MODE (x17) != i1)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 2
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x18, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x21 = XEXP (x16, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 8
          || GET_MODE (x21) != i1)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != SET)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != i1)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x24, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != i1
          || !stack_pop_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 8:
      if (REGNO (x12) != 1)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != RETURN)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != USE)
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != E_SImode
          || !stack_pop_up_to_s0_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern648 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern654 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern660 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern666 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 1;

    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 2;

    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern674 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern681 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[3], E_RVVM8HFmode))
        return -1;
      return 0;

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      return 1;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      return 2;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM1HFmode))
        return -1;
      return 3;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVMF2HFmode))
        return -1;
      return 4;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF4HFmode))
        return -1;
      return 5;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1HFmode))
        return -1;
      return 6;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2HFmode))
        return -1;
      return 7;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      return 8;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8HFmode))
        return -1;
      return 9;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16HFmode))
        return -1;
      return 10;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32HFmode))
        return -1;
      return 11;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64HFmode))
        return -1;
      return 12;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128HFmode))
        return -1;
      return 13;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256HFmode))
        return -1;
      return 14;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512HFmode))
        return -1;
      return 15;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024HFmode))
        return -1;
      return 16;

    case E_V2048BImode:
      if (!vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[3], E_V2048HFmode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern690 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i4
      || !reg_or_0_operand (operands[4], i3)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern698 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[3], E_DImode)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern703 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern702 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern702 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern702 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern702 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern702 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern702 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x2) != E_RVVM8SImode
          || GET_MODE (x3) != E_RVVM8SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM8SImode
          || GET_MODE (x4) != E_RVVM8SImode
          || !register_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode)
              || !register_operand (operands[4], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 7;

            case E_RVVM8QImode:
              if (!register_operand (operands[4], E_RVVM8QImode))
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x2) != E_RVVM4SImode
          || GET_MODE (x3) != E_RVVM4SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM4SImode
          || GET_MODE (x4) != E_RVVM4SImode
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode)
              || !register_operand (operands[4], E_RVVM2HImode))
            return -1;
          return 9;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 10;

            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x2) != E_RVVM2SImode
          || GET_MODE (x3) != E_RVVM2SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM2SImode
          || GET_MODE (x4) != E_RVVM2SImode
          || !register_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode)
              || !register_operand (operands[4], E_RVVM1HImode))
            return -1;
          return 12;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 13;

            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x2) != E_RVVM1SImode
          || GET_MODE (x3) != E_RVVM1SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM1SImode
          || GET_MODE (x4) != E_RVVM1SImode
          || !register_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode)
              || !register_operand (operands[4], E_RVVMF2HImode))
            return -1;
          return 15;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVMF2QImode:
              if (!register_operand (operands[4], E_RVVMF2QImode))
                return -1;
              return 16;

            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 17;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (pattern702 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVM8DImode:
      if (pattern702 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 19;

    case E_RVVM4DImode:
      if (pattern702 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 20;

    case E_RVVM2DImode:
      if (pattern702 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 21;

    case E_RVVM1DImode:
      if (pattern702 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 22;

    case E_V1HImode:
      if (pattern702 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 23;

    case E_V2HImode:
      if (pattern702 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 24;

    case E_V4HImode:
      if (pattern702 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 25;

    case E_V8HImode:
      if (pattern702 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 26;

    case E_V16HImode:
      if (pattern702 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 27;

    case E_V32HImode:
      if (pattern702 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 28;

    case E_V64HImode:
      if (pattern702 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 29;

    case E_V128HImode:
      if (pattern702 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 30;

    case E_V256HImode:
      if (pattern702 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 31;

    case E_V512HImode:
      if (pattern702 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 32;

    case E_V1024HImode:
      if (pattern702 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 33;

    case E_V2048HImode:
      if (pattern702 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 34;

    case E_V1SImode:
      if (pattern702 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2SImode:
      if (pattern702 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4SImode:
      if (pattern702 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8SImode:
      if (pattern702 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16SImode:
      if (pattern702 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32SImode:
      if (pattern702 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64SImode:
      if (pattern702 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128SImode:
      if (pattern702 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256SImode:
      if (pattern702 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512SImode:
      if (pattern702 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024SImode:
      if (pattern702 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V1DImode:
      if (pattern702 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 46;

    case E_V2DImode:
      if (pattern702 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 47;

    case E_V4DImode:
      if (pattern702 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 48;

    case E_V8DImode:
      if (pattern702 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 49;

    case E_V16DImode:
      if (pattern702 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 50;

    case E_V32DImode:
      if (pattern702 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 51;

    case E_V64DImode:
      if (pattern702 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 52;

    case E_V128DImode:
      if (pattern702 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 53;

    case E_V256DImode:
      if (pattern702 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 54;

    case E_V512DImode:
      if (pattern702 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 55;

    default:
      return -1;
    }
}

int
pattern741 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern744 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x22, 1);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  return 0;
}

int
pattern749 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x27, 1);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  return 0;
}

int
pattern756 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  switch (XWINT (x8, 0))
    {
    case -4L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -8L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -12L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -16L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -20L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -24L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -28L)
        return -1;
      return 0;

    case -8L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -16L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -24L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -32L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -40L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -48L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -56L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern764 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 25:
      if (REGNO (x12) != 24
          || REGNO (x17) != 23)
        return -1;
      return 0;

    case 23:
      if (REGNO (x12) != 22
          || REGNO (x17) != 21)
        return -1;
      return 1;

    case 21:
      if (REGNO (x12) != 20
          || REGNO (x17) != 19
          || REGNO (x22) != 18
          || REGNO (x27) != 9
          || REGNO (x32) != 8
          || REGNO (x37) != 1)
        return -1;
      x43 = XEXP (x41, 1);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x42) != 10)
        return -1;
      x44 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x44) != USE)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 10
          || GET_MODE (x45) != i1)
        return -1;
      x46 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x46) != RETURN)
        return -1;
      x47 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x47) != USE)
        return -1;
      x48 = XEXP (x47, 0);
      if (GET_CODE (x48) != REG
          || REGNO (x48) != 1
          || GET_MODE (x48) != E_SImode
          || !stack_pop_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern777 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XEXP (x32, 1);
  if (GET_MODE (x36) != i1)
    return -1;
  x37 = XVECEXP (x1, 0, 7);
  x38 = XEXP (x37, 0);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XEXP (x37, 1);
  if (GET_MODE (x41) != i1)
    return -1;
  x42 = XVECEXP (x1, 0, 8);
  x43 = XEXP (x42, 0);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XEXP (x42, 1);
  if (GET_MODE (x46) != i1)
    return -1;
  x47 = XVECEXP (x1, 0, 9);
  x48 = XEXP (x47, 0);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XEXP (x47, 1);
  if (GET_MODE (x51) != i1)
    return -1;
  x52 = XVECEXP (x1, 0, 10);
  x53 = XEXP (x52, 0);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x52, 1);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  return 0;
}

int
pattern790 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s8_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern794 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -44])
    return -1;
  return 0;
}

int
pattern798 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  x53 = XEXP (x51, 1);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XVECEXP (x1, 0, 11);
  x57 = XEXP (x56, 0);
  if (GET_MODE (x57) != i1)
    return -1;
  x58 = XEXP (x56, 1);
  if (GET_MODE (x58) != i1)
    return -1;
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  x60 = XEXP (x59, 0);
  if (GET_MODE (x60) != i1)
    return -1;
  x61 = XVECEXP (x1, 0, 12);
  x62 = XEXP (x61, 0);
  if (GET_MODE (x62) != i1)
    return -1;
  x63 = XEXP (x61, 1);
  if (GET_MODE (x63) != i1)
    return -1;
  x64 = XEXP (x63, 0);
  if (GET_MODE (x64) != i1)
    return -1;
  x65 = XEXP (x64, 0);
  if (GET_MODE (x65) != i1)
    return -1;
  x66 = XVECEXP (x1, 0, 13);
  x67 = XEXP (x66, 0);
  if (GET_MODE (x67) != i1)
    return -1;
  x68 = XEXP (x66, 1);
  if (GET_MODE (x68) != i1)
    return -1;
  x69 = XEXP (x68, 0);
  if (GET_MODE (x69) != i1)
    return -1;
  x70 = XEXP (x69, 0);
  if (GET_MODE (x70) != i1)
    return -1;
  x71 = XVECEXP (x1, 0, 14);
  x72 = XEXP (x71, 0);
  if (GET_MODE (x72) != i1)
    return -1;
  x73 = XVECEXP (x1, 0, 15);
  x74 = XEXP (x73, 0);
  if (GET_MODE (x74) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case PLUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!arith_operand (operands[2], E_DImode)
          || !
#line 869 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 9; /* *addsi3_extended2 */

    case MINUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1050 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 18; /* *subsi3_extended2 */

    case NEG:
      operands[2] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 1102 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 22; /* *negsi2_extended2 */

    case MULT:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1267 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 29; /* *mulsi3_extended2 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 1967 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_XTHEADMEMIDX))
            return -1;
          return 127; /* *extendsidi2_internal */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 1984 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 130; /* *extendqidi2 */
          if (!(
#line 321 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 544; /* *extendqidi2_bitmanip */

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 1984 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 133; /* *extendhidi2 */
          if (!(
#line 321 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 547; /* *extendhidi2_bitmanip */

        default:
          return -1;
        }

    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern285 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 1984 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 128; /* *extendqihi2 */
          if (!
#line 321 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 542; /* *extendqihi2_bitmanip */

        case 1:
          if (
#line 1984 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 131; /* *extendhihi2 */
          if (!
#line 321 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 545; /* *extendhihi2_bitmanip */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern285 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 1984 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 129; /* *extendqisi2 */
          if (!
#line 321 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 543; /* *extendqisi2_bitmanip */

        case 1:
          if (
#line 1984 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 132; /* *extendhisi2 */
          if (!
#line 321 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 546; /* *extendhisi2_bitmanip */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern286 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 65 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 874; /* *extendhihi2_th_ext */
          if (!
#line 551 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return -1;
          return 929; /* *th_memidx_extendhihi2 */

        case 1:
          if (
#line 76 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 877; /* *extendqihi2_th_ext */
          if (
#line 551 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 926; /* *th_memidx_extendqihi2 */
          if (!
#line 628 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 937; /* *th_memidx_bb_extendqihi2 */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern286 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 65 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 875; /* *extendhisi2_th_ext */
          if (
#line 551 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 930; /* *th_memidx_extendhisi2 */
          if (!
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 935; /* *th_memidx_bb_extendhisi2 */

        case 1:
          if (
#line 76 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 878; /* *extendqisi2_th_ext */
          if (
#line 551 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 927; /* *th_memidx_extendqisi2 */
          if (!
#line 628 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 938; /* *th_memidx_bb_extendqisi2 */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 65 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 876; /* *extendhidi2_th_ext */
          if ((
#line 551 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 931; /* *th_memidx_extendhidi2 */
          if (!(
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 936; /* *th_memidx_bb_extendhidi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 76 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 879; /* *extendqidi2_th_ext */
          if ((
#line 551 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 928; /* *th_memidx_extendqidi2 */
          if (!(
#line 628 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 60 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 939; /* *th_memidx_bb_extendqidi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 482 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_64BIT && TARGET_XTHEADMEMIDX))
            return -1;
          return 922; /* *th_memidx_extendsidi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != VEC_SELECT
      || pattern333 (x3) != 0)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28261; /* *pred_extract_first_sextdirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28262; /* *pred_extract_first_sextdirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28263; /* *pred_extract_first_sextdirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28264; /* *pred_extract_first_sextdirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28265; /* *pred_extract_first_sextdirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28266; /* *pred_extract_first_sextdirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28267; /* *pred_extract_first_sextdirvvmf8qi */

            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 571 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 28279; /* *pred_extract_first_sextdiv1qi */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 572 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 28280; /* *pred_extract_first_sextdiv2qi */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 573 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 28281; /* *pred_extract_first_sextdiv4qi */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 574 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 28282; /* *pred_extract_first_sextdiv8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 575 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 28283; /* *pred_extract_first_sextdiv16qi */

            case E_V32QImode:
              if (!register_operand (operands[1], E_V32QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 28284; /* *pred_extract_first_sextdiv32qi */

            case E_V64QImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 577 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28285; /* *pred_extract_first_sextdiv64qi */

            case E_V128QImode:
              if (!register_operand (operands[1], E_V128QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 578 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28286; /* *pred_extract_first_sextdiv128qi */

            case E_V256QImode:
              if (!register_operand (operands[1], E_V256QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 579 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28287; /* *pred_extract_first_sextdiv256qi */

            case E_V512QImode:
              if (!register_operand (operands[1], E_V512QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 580 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28288; /* *pred_extract_first_sextdiv512qi */

            case E_V1024QImode:
              if (!register_operand (operands[1], E_V1024QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 581 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28289; /* *pred_extract_first_sextdiv1024qi */

            case E_V2048QImode:
              if (!register_operand (operands[1], E_V2048QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 582 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28290; /* *pred_extract_first_sextdiv2048qi */

            case E_V4096QImode:
              if (!register_operand (operands[1], E_V4096QImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 583 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28291; /* *pred_extract_first_sextdiv4096qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28268; /* *pred_extract_first_sextdirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28269; /* *pred_extract_first_sextdirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28270; /* *pred_extract_first_sextdirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28271; /* *pred_extract_first_sextdirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28272; /* *pred_extract_first_sextdirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 567 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28273; /* *pred_extract_first_sextdirvvmf4hi */

            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 584 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 28292; /* *pred_extract_first_sextdiv1hi */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 585 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 28293; /* *pred_extract_first_sextdiv2hi */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 586 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 28294; /* *pred_extract_first_sextdiv4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 587 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 28295; /* *pred_extract_first_sextdiv8hi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 588 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 28296; /* *pred_extract_first_sextdiv16hi */

            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 589 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28297; /* *pred_extract_first_sextdiv32hi */

            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 590 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28298; /* *pred_extract_first_sextdiv64hi */

            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 591 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28299; /* *pred_extract_first_sextdiv128hi */

            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 592 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28300; /* *pred_extract_first_sextdiv256hi */

            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 593 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28301; /* *pred_extract_first_sextdiv512hi */

            case E_V1024HImode:
              if (!register_operand (operands[1], E_V1024HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 594 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28302; /* *pred_extract_first_sextdiv1024hi */

            case E_V2048HImode:
              if (!register_operand (operands[1], E_V2048HImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 595 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28303; /* *pred_extract_first_sextdiv2048hi */

            default:
              return -1;
            }

        case E_SImode:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8SImode:
              if (!register_operand (operands[1], E_RVVM8SImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28274; /* *pred_extract_first_sextdirvvm8si */

            case E_RVVM4SImode:
              if (!register_operand (operands[1], E_RVVM4SImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28275; /* *pred_extract_first_sextdirvvm4si */

            case E_RVVM2SImode:
              if (!register_operand (operands[1], E_RVVM2SImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28276; /* *pred_extract_first_sextdirvvm2si */

            case E_RVVM1SImode:
              if (!register_operand (operands[1], E_RVVM1SImode)
                  || !
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28277; /* *pred_extract_first_sextdirvvm1si */

            case E_RVVMF2SImode:
              if (!register_operand (operands[1], E_RVVMF2SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 569 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28278; /* *pred_extract_first_sextdirvvmf2si */

            case E_V1SImode:
              if (!register_operand (operands[1], E_V1SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 596 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 28304; /* *pred_extract_first_sextdiv1si */

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 597 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 28305; /* *pred_extract_first_sextdiv2si */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 598 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 28306; /* *pred_extract_first_sextdiv4si */

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 599 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 28307; /* *pred_extract_first_sextdiv8si */

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 600 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28308; /* *pred_extract_first_sextdiv16si */

            case E_V32SImode:
              if (!register_operand (operands[1], E_V32SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 601 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28309; /* *pred_extract_first_sextdiv32si */

            case E_V64SImode:
              if (!register_operand (operands[1], E_V64SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 602 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28310; /* *pred_extract_first_sextdiv64si */

            case E_V128SImode:
              if (!register_operand (operands[1], E_V128SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28311; /* *pred_extract_first_sextdiv128si */

            case E_V256SImode:
              if (!register_operand (operands[1], E_V256SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 604 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28312; /* *pred_extract_first_sextdiv256si */

            case E_V512SImode:
              if (!register_operand (operands[1], E_V512SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28313; /* *pred_extract_first_sextdiv512si */

            case E_V1024SImode:
              if (!register_operand (operands[1], E_V1024SImode)
                  || !(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 606 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28314; /* *pred_extract_first_sextdiv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28315; /* *pred_extract_first_sextsirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28316; /* *pred_extract_first_sextsirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28317; /* *pred_extract_first_sextsirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28318; /* *pred_extract_first_sextsirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28319; /* *pred_extract_first_sextsirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28320; /* *pred_extract_first_sextsirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 559 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28321; /* *pred_extract_first_sextsirvvmf8qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28322; /* *pred_extract_first_sextsirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28323; /* *pred_extract_first_sextsirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28324; /* *pred_extract_first_sextsirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28325; /* *pred_extract_first_sextsirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28326; /* *pred_extract_first_sextsirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 85 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 561 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 28327; /* *pred_extract_first_sextsirvvmf4hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern149 (x2))
    {
    case 0:
      if (!
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30149; /* *dual_widen_suburvvm8hi */

    case 1:
      if (!
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30155; /* *dual_widen_suburvvm4hi */

    case 2:
      if (!
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30161; /* *dual_widen_suburvvm2hi */

    case 3:
      if (!
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30167; /* *dual_widen_suburvvm1hi */

    case 4:
      if (!
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30173; /* *dual_widen_suburvvmf2hi */

    case 5:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30179; /* *dual_widen_suburvvmf4hi */

    case 6:
      if (!
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30185; /* *dual_widen_suburvvm8si */

    case 7:
      if (!
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30191; /* *dual_widen_suburvvm4si */

    case 8:
      if (!
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30197; /* *dual_widen_suburvvm2si */

    case 9:
      if (!
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30203; /* *dual_widen_suburvvm1si */

    case 10:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30209; /* *dual_widen_suburvvmf2si */

    case 11:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30215; /* *dual_widen_suburvvm8di */

    case 12:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30221; /* *dual_widen_suburvvm4di */

    case 13:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30227; /* *dual_widen_suburvvm2di */

    case 14:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30233; /* *dual_widen_suburvvm1di */

    case 15:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30239; /* *dual_widen_subuv1hi */

    case 16:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30245; /* *dual_widen_subuv2hi */

    case 17:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30251; /* *dual_widen_subuv4hi */

    case 18:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30257; /* *dual_widen_subuv8hi */

    case 19:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30263; /* *dual_widen_subuv16hi */

    case 20:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30269; /* *dual_widen_subuv32hi */

    case 21:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30275; /* *dual_widen_subuv64hi */

    case 22:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30281; /* *dual_widen_subuv128hi */

    case 23:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30287; /* *dual_widen_subuv256hi */

    case 24:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30293; /* *dual_widen_subuv512hi */

    case 25:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30299; /* *dual_widen_subuv1024hi */

    case 26:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30305; /* *dual_widen_subuv2048hi */

    case 27:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30311; /* *dual_widen_subuv1si */

    case 28:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30317; /* *dual_widen_subuv2si */

    case 29:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30323; /* *dual_widen_subuv4si */

    case 30:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30329; /* *dual_widen_subuv8si */

    case 31:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30335; /* *dual_widen_subuv16si */

    case 32:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30341; /* *dual_widen_subuv32si */

    case 33:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30347; /* *dual_widen_subuv64si */

    case 34:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30353; /* *dual_widen_subuv128si */

    case 35:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30359; /* *dual_widen_subuv256si */

    case 36:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30365; /* *dual_widen_subuv512si */

    case 37:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30371; /* *dual_widen_subuv1024si */

    case 38:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30377; /* *dual_widen_subuv1di */

    case 39:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30383; /* *dual_widen_subuv2di */

    case 40:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30389; /* *dual_widen_subuv4di */

    case 41:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30395; /* *dual_widen_subuv8di */

    case 42:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30401; /* *dual_widen_subuv16di */

    case 43:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30407; /* *dual_widen_subuv32di */

    case 44:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30413; /* *dual_widen_subuv64di */

    case 45:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30419; /* *dual_widen_subuv128di */

    case 46:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30425; /* *dual_widen_subuv256di */

    case 47:
      if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30431; /* *dual_widen_subuv512di */

    case 48:
      if (!
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30531; /* *single_widen_first_suburvvm8hi */

    case 49:
      if (!
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30533; /* *single_widen_first_suburvvm4hi */

    case 50:
      if (!
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30535; /* *single_widen_first_suburvvm2hi */

    case 51:
      if (!
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30537; /* *single_widen_first_suburvvm1hi */

    case 52:
      if (!
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30539; /* *single_widen_first_suburvvmf2hi */

    case 53:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30541; /* *single_widen_first_suburvvmf4hi */

    case 54:
      if (!
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30543; /* *single_widen_first_suburvvm8si */

    case 55:
      if (!
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30545; /* *single_widen_first_suburvvm4si */

    case 56:
      if (!
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30547; /* *single_widen_first_suburvvm2si */

    case 57:
      if (!
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30549; /* *single_widen_first_suburvvm1si */

    case 58:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 30551; /* *single_widen_first_suburvvmf2si */

    case 59:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30553; /* *single_widen_first_suburvvm8di */

    case 60:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30555; /* *single_widen_first_suburvvm4di */

    case 61:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30557; /* *single_widen_first_suburvvm2di */

    case 62:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30559; /* *single_widen_first_suburvvm1di */

    case 63:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30561; /* *single_widen_first_subuv1hi */

    case 64:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30563; /* *single_widen_first_subuv2hi */

    case 65:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30565; /* *single_widen_first_subuv4hi */

    case 66:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30567; /* *single_widen_first_subuv8hi */

    case 67:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30569; /* *single_widen_first_subuv16hi */

    case 68:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30571; /* *single_widen_first_subuv32hi */

    case 69:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30573; /* *single_widen_first_subuv64hi */

    case 70:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30575; /* *single_widen_first_subuv128hi */

    case 71:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30577; /* *single_widen_first_subuv256hi */

    case 72:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30579; /* *single_widen_first_subuv512hi */

    case 73:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30581; /* *single_widen_first_subuv1024hi */

    case 74:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30583; /* *single_widen_first_subuv2048hi */

    case 75:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30585; /* *single_widen_first_subuv1si */

    case 76:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30587; /* *single_widen_first_subuv2si */

    case 77:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30589; /* *single_widen_first_subuv4si */

    case 78:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30591; /* *single_widen_first_subuv8si */

    case 79:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30593; /* *single_widen_first_subuv16si */

    case 80:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30595; /* *single_widen_first_subuv32si */

    case 81:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30597; /* *single_widen_first_subuv64si */

    case 82:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30599; /* *single_widen_first_subuv128si */

    case 83:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30601; /* *single_widen_first_subuv256si */

    case 84:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30603; /* *single_widen_first_subuv512si */

    case 85:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30605; /* *single_widen_first_subuv1024si */

    case 86:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30607; /* *single_widen_first_subuv1di */

    case 87:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30609; /* *single_widen_first_subuv2di */

    case 88:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30611; /* *single_widen_first_subuv4di */

    case 89:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30613; /* *single_widen_first_subuv8di */

    case 90:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30615; /* *single_widen_first_subuv16di */

    case 91:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30617; /* *single_widen_first_subuv32di */

    case 92:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30619; /* *single_widen_first_subuv64di */

    case 93:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30621; /* *single_widen_first_subuv128di */

    case 94:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30623; /* *single_widen_first_subuv256di */

    case 95:
      if (!(
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30625; /* *single_widen_first_subuv512di */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern163 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM8SImode)
          && 
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32389; /* *vwsll_zext1_trunc_rvvm8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32449; /* *vwsll_zext1_trunc_scalar_rvvm8si */

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && 
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32390; /* *vwsll_zext1_trunc_rvvm4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32450; /* *vwsll_zext1_trunc_scalar_rvvm4si */

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && 
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32391; /* *vwsll_zext1_trunc_rvvm2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32451; /* *vwsll_zext1_trunc_scalar_rvvm2si */

    case 3:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && 
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32392; /* *vwsll_zext1_trunc_rvvm1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32452; /* *vwsll_zext1_trunc_scalar_rvvm1si */

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 32393; /* *vwsll_zext1_trunc_rvvmf2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32453; /* *vwsll_zext1_trunc_scalar_rvvmf2si */

    case 5:
      if (vector_shift_operand (operands[2], E_RVVM8DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32394; /* *vwsll_zext1_trunc_rvvm8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32454; /* *vwsll_zext1_trunc_scalar_rvvm8di */

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32395; /* *vwsll_zext1_trunc_rvvm4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32455; /* *vwsll_zext1_trunc_scalar_rvvm4di */

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32396; /* *vwsll_zext1_trunc_rvvm2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32456; /* *vwsll_zext1_trunc_scalar_rvvm2di */

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32397; /* *vwsll_zext1_trunc_rvvm1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32457; /* *vwsll_zext1_trunc_scalar_rvvm1di */

    case 9:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 32398; /* *vwsll_zext1_trunc_v1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32458; /* *vwsll_zext1_trunc_scalar_v1si */

    case 10:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 32399; /* *vwsll_zext1_trunc_v2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32459; /* *vwsll_zext1_trunc_scalar_v2si */

    case 11:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 32400; /* *vwsll_zext1_trunc_v4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32460; /* *vwsll_zext1_trunc_scalar_v4si */

    case 12:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 32401; /* *vwsll_zext1_trunc_v8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32461; /* *vwsll_zext1_trunc_scalar_v8si */

    case 13:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 32402; /* *vwsll_zext1_trunc_v16si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32462; /* *vwsll_zext1_trunc_scalar_v16si */

    case 14:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 32403; /* *vwsll_zext1_trunc_v32si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32463; /* *vwsll_zext1_trunc_scalar_v32si */

    case 15:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 32404; /* *vwsll_zext1_trunc_v64si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32464; /* *vwsll_zext1_trunc_scalar_v64si */

    case 16:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 32405; /* *vwsll_zext1_trunc_v128si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32465; /* *vwsll_zext1_trunc_scalar_v128si */

    case 17:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 32406; /* *vwsll_zext1_trunc_v256si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32466; /* *vwsll_zext1_trunc_scalar_v256si */

    case 18:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 32407; /* *vwsll_zext1_trunc_v512si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32467; /* *vwsll_zext1_trunc_scalar_v512si */

    case 19:
      if (vector_shift_operand (operands[2], E_V1024SImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 32408; /* *vwsll_zext1_trunc_v1024si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32468; /* *vwsll_zext1_trunc_scalar_v1024si */

    case 20:
      if (vector_shift_operand (operands[2], E_V1DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 32409; /* *vwsll_zext1_trunc_v1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32469; /* *vwsll_zext1_trunc_scalar_v1di */

    case 21:
      if (vector_shift_operand (operands[2], E_V2DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 32410; /* *vwsll_zext1_trunc_v2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32470; /* *vwsll_zext1_trunc_scalar_v2di */

    case 22:
      if (vector_shift_operand (operands[2], E_V4DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 32411; /* *vwsll_zext1_trunc_v4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32471; /* *vwsll_zext1_trunc_scalar_v4di */

    case 23:
      if (vector_shift_operand (operands[2], E_V8DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 32412; /* *vwsll_zext1_trunc_v8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32472; /* *vwsll_zext1_trunc_scalar_v8di */

    case 24:
      if (vector_shift_operand (operands[2], E_V16DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 32413; /* *vwsll_zext1_trunc_v16di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32473; /* *vwsll_zext1_trunc_scalar_v16di */

    case 25:
      if (vector_shift_operand (operands[2], E_V32DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 32414; /* *vwsll_zext1_trunc_v32di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32474; /* *vwsll_zext1_trunc_scalar_v32di */

    case 26:
      if (vector_shift_operand (operands[2], E_V64DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 32415; /* *vwsll_zext1_trunc_v64di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32475; /* *vwsll_zext1_trunc_scalar_v64di */

    case 27:
      if (vector_shift_operand (operands[2], E_V128DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 32416; /* *vwsll_zext1_trunc_v128di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32476; /* *vwsll_zext1_trunc_scalar_v128di */

    case 28:
      if (vector_shift_operand (operands[2], E_V256DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 32417; /* *vwsll_zext1_trunc_v256di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32477; /* *vwsll_zext1_trunc_scalar_v256di */

    case 29:
      if (vector_shift_operand (operands[2], E_V512DImode)
          && (
#line 1606 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 32418; /* *vwsll_zext1_trunc_v512di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32478; /* *vwsll_zext1_trunc_scalar_v512di */

    case 30:
      if (!
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32419; /* *vwsll_zext2_trunc_rvvm8si */

    case 31:
      if (!
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32420; /* *vwsll_zext2_trunc_rvvm4si */

    case 32:
      if (!
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32421; /* *vwsll_zext2_trunc_rvvm2si */

    case 33:
      if (!
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32422; /* *vwsll_zext2_trunc_rvvm1si */

    case 34:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 32423; /* *vwsll_zext2_trunc_rvvmf2si */

    case 35:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32424; /* *vwsll_zext2_trunc_rvvm8di */

    case 36:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32425; /* *vwsll_zext2_trunc_rvvm4di */

    case 37:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32426; /* *vwsll_zext2_trunc_rvvm2di */

    case 38:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32427; /* *vwsll_zext2_trunc_rvvm1di */

    case 39:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32428; /* *vwsll_zext2_trunc_v1si */

    case 40:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32429; /* *vwsll_zext2_trunc_v2si */

    case 41:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32430; /* *vwsll_zext2_trunc_v4si */

    case 42:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32431; /* *vwsll_zext2_trunc_v8si */

    case 43:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32432; /* *vwsll_zext2_trunc_v16si */

    case 44:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32433; /* *vwsll_zext2_trunc_v32si */

    case 45:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32434; /* *vwsll_zext2_trunc_v64si */

    case 46:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32435; /* *vwsll_zext2_trunc_v128si */

    case 47:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32436; /* *vwsll_zext2_trunc_v256si */

    case 48:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32437; /* *vwsll_zext2_trunc_v512si */

    case 49:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32438; /* *vwsll_zext2_trunc_v1024si */

    case 50:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32439; /* *vwsll_zext2_trunc_v1di */

    case 51:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32440; /* *vwsll_zext2_trunc_v2di */

    case 52:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32441; /* *vwsll_zext2_trunc_v4di */

    case 53:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32442; /* *vwsll_zext2_trunc_v8di */

    case 54:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32443; /* *vwsll_zext2_trunc_v16di */

    case 55:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32444; /* *vwsll_zext2_trunc_v32di */

    case 56:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32445; /* *vwsll_zext2_trunc_v64di */

    case 57:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32446; /* *vwsll_zext2_trunc_v128di */

    case 58:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32447; /* *vwsll_zext2_trunc_v256di */

    case 59:
      if (!(
#line 1629 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32448; /* *vwsll_zext2_trunc_v512di */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern241 (x3))
    {
    case 0:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27891; /* copysignrvvm8hf3 */

    case 1:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27892; /* copysignrvvm4hf3 */

    case 2:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27893; /* copysignrvvm2hf3 */

    case 3:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27894; /* copysignrvvm1hf3 */

    case 4:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27895; /* copysignrvvmf2hf3 */

    case 5:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27896; /* copysignrvvmf4hf3 */

    case 6:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27897; /* copysignrvvm8sf3 */

    case 7:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27898; /* copysignrvvm4sf3 */

    case 8:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27899; /* copysignrvvm2sf3 */

    case 9:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27900; /* copysignrvvm1sf3 */

    case 10:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27901; /* copysignrvvmf2sf3 */

    case 11:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27902; /* copysignrvvm8df3 */

    case 12:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27903; /* copysignrvvm4df3 */

    case 13:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27904; /* copysignrvvm2df3 */

    case 14:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27905; /* copysignrvvm1df3 */

    case 15:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27906; /* copysignv1hf3 */

    case 16:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27907; /* copysignv2hf3 */

    case 17:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27908; /* copysignv4hf3 */

    case 18:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27909; /* copysignv8hf3 */

    case 19:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27910; /* copysignv16hf3 */

    case 20:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27911; /* copysignv32hf3 */

    case 21:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27912; /* copysignv64hf3 */

    case 22:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27913; /* copysignv128hf3 */

    case 23:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27914; /* copysignv256hf3 */

    case 24:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27915; /* copysignv512hf3 */

    case 25:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27916; /* copysignv1024hf3 */

    case 26:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27917; /* copysignv2048hf3 */

    case 27:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27918; /* copysignv1sf3 */

    case 28:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27919; /* copysignv2sf3 */

    case 29:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27920; /* copysignv4sf3 */

    case 30:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27921; /* copysignv8sf3 */

    case 31:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27922; /* copysignv16sf3 */

    case 32:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27923; /* copysignv32sf3 */

    case 33:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27924; /* copysignv64sf3 */

    case 34:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27925; /* copysignv128sf3 */

    case 35:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27926; /* copysignv256sf3 */

    case 36:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27927; /* copysignv512sf3 */

    case 37:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27928; /* copysignv1024sf3 */

    case 38:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27929; /* copysignv1df3 */

    case 39:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27930; /* copysignv2df3 */

    case 40:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27931; /* copysignv4df3 */

    case 41:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27932; /* copysignv8df3 */

    case 42:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27933; /* copysignv16df3 */

    case 43:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27934; /* copysignv32df3 */

    case 44:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27935; /* copysignv64df3 */

    case 45:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27936; /* copysignv128df3 */

    case 46:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27937; /* copysignv256df3 */

    case 47:
      if (!(
#line 1615 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27938; /* copysignv512df3 */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern167 (x1))
    {
    case 0:
      if (!(
#line 3573 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 394; /* fle_quietsfsi4_zfa */

    case 1:
      if (!(
#line 3573 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 398; /* fle_quietdfsi4_zfa */

    case 2:
      if (!(
#line 3573 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 402; /* fle_quiethfsi4_zfa */

    case 3:
      if (!(
#line 3573 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 396; /* fle_quietsfdi4_zfa */

    case 4:
      if (!(
#line 3573 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 400; /* fle_quietdfdi4_zfa */

    case 5:
      if (!(
#line 3573 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 404; /* fle_quiethfdi4_zfa */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !(
#line 2333 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 105 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 257; /* rintsf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !(
#line 2333 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 106 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 258; /* rintdf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode)
          || !(
#line 2333 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && 
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 259; /* rinthf2 */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern589 (x2, 
E_RVVMF64BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF8QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF8QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8695; /* pred_madcrvvmf8qi_scalar */

    case E_RVVMF4HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF4HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8701; /* pred_madcrvvmf4hi_scalar */

    case E_RVVMF2SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8706; /* pred_madcrvvmf2si_scalar */

    case E_RVVM1DImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM1DImode)
          || !(
#line 3567 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8800; /* *pred_madcrvvm1di_scalar */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern589 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_V512QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8716; /* pred_madcv512qi_scalar */

    case E_V512HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8729; /* pred_madcv512hi_scalar */

    case E_V512SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_V512SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 3496 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8741; /* pred_madcv512si_scalar */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18676; /* pred_redxor_vl0srvvm8qi */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18684; /* pred_redxor_vl0srvvm4qi */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18692; /* pred_redxor_vl0srvvm2qi */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18700; /* pred_redxor_vl0srvvm1qi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18804; /* pred_redxor_vl0srvvmf2qi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18812; /* pred_redxor_vl0srvvmf4qi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18820; /* pred_redxor_vl0srvvmf8qi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18852; /* pred_redxor_vl0sv1qi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18860; /* pred_redxor_vl0sv2qi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18868; /* pred_redxor_vl0sv4qi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18876; /* pred_redxor_vl0sv8qi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18884; /* pred_redxor_vl0sv16qi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18892; /* pred_redxor_vl0sv32qi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18900; /* pred_redxor_vl0sv64qi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18908; /* pred_redxor_vl0sv128qi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18916; /* pred_redxor_vl0sv256qi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18924; /* pred_redxor_vl0sv512qi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18932; /* pred_redxor_vl0sv1024qi */

        case 18:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18940; /* pred_redxor_vl0sv2048qi */

        case 19:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18948; /* pred_redxor_vl0sv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18708; /* pred_redxor_vl0srvvm8hi */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18716; /* pred_redxor_vl0srvvm4hi */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18724; /* pred_redxor_vl0srvvm2hi */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18732; /* pred_redxor_vl0srvvm1hi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18828; /* pred_redxor_vl0srvvmf2hi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18836; /* pred_redxor_vl0srvvmf4hi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18956; /* pred_redxor_vl0sv1hi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18964; /* pred_redxor_vl0sv2hi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18972; /* pred_redxor_vl0sv4hi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18980; /* pred_redxor_vl0sv8hi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18988; /* pred_redxor_vl0sv16hi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18996; /* pred_redxor_vl0sv32hi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19004; /* pred_redxor_vl0sv64hi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19012; /* pred_redxor_vl0sv128hi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19020; /* pred_redxor_vl0sv256hi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19028; /* pred_redxor_vl0sv512hi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19036; /* pred_redxor_vl0sv1024hi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19044; /* pred_redxor_vl0sv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18740; /* pred_redxor_vl0srvvm8si */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18748; /* pred_redxor_vl0srvvm4si */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18756; /* pred_redxor_vl0srvvm2si */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18764; /* pred_redxor_vl0srvvm1si */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18844; /* pred_redxor_vl0srvvmf2si */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19052; /* pred_redxor_vl0sv1si */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19060; /* pred_redxor_vl0sv2si */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19068; /* pred_redxor_vl0sv4si */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19076; /* pred_redxor_vl0sv8si */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19084; /* pred_redxor_vl0sv16si */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19092; /* pred_redxor_vl0sv32si */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19100; /* pred_redxor_vl0sv64si */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19108; /* pred_redxor_vl0sv128si */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19116; /* pred_redxor_vl0sv256si */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19124; /* pred_redxor_vl0sv512si */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19132; /* pred_redxor_vl0sv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18772; /* pred_redxor_vl0srvvm8di */

        case 1:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18780; /* pred_redxor_vl0srvvm4di */

        case 2:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18788; /* pred_redxor_vl0srvvm2di */

        case 3:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18796; /* pred_redxor_vl0srvvm1di */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19140; /* pred_redxor_vl0sv1di */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19148; /* pred_redxor_vl0sv2di */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19156; /* pred_redxor_vl0sv4di */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19164; /* pred_redxor_vl0sv8di */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19172; /* pred_redxor_vl0sv16di */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19180; /* pred_redxor_vl0sv32di */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19188; /* pred_redxor_vl0sv64di */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19196; /* pred_redxor_vl0sv128di */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19204; /* pred_redxor_vl0sv256di */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19212; /* pred_redxor_vl0sv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18672; /* pred_redminu_vl0srvvm8qi */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18680; /* pred_redminu_vl0srvvm4qi */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18688; /* pred_redminu_vl0srvvm2qi */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18696; /* pred_redminu_vl0srvvm1qi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18800; /* pred_redminu_vl0srvvmf2qi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18808; /* pred_redminu_vl0srvvmf4qi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18816; /* pred_redminu_vl0srvvmf8qi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18848; /* pred_redminu_vl0sv1qi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18856; /* pred_redminu_vl0sv2qi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18864; /* pred_redminu_vl0sv4qi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18872; /* pred_redminu_vl0sv8qi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18880; /* pred_redminu_vl0sv16qi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18888; /* pred_redminu_vl0sv32qi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18896; /* pred_redminu_vl0sv64qi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18904; /* pred_redminu_vl0sv128qi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18912; /* pred_redminu_vl0sv256qi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18920; /* pred_redminu_vl0sv512qi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18928; /* pred_redminu_vl0sv1024qi */

        case 18:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18936; /* pred_redminu_vl0sv2048qi */

        case 19:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18944; /* pred_redminu_vl0sv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18704; /* pred_redminu_vl0srvvm8hi */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18712; /* pred_redminu_vl0srvvm4hi */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18720; /* pred_redminu_vl0srvvm2hi */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18728; /* pred_redminu_vl0srvvm1hi */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18824; /* pred_redminu_vl0srvvmf2hi */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18832; /* pred_redminu_vl0srvvmf4hi */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18952; /* pred_redminu_vl0sv1hi */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18960; /* pred_redminu_vl0sv2hi */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18968; /* pred_redminu_vl0sv4hi */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18976; /* pred_redminu_vl0sv8hi */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18984; /* pred_redminu_vl0sv16hi */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18992; /* pred_redminu_vl0sv32hi */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19000; /* pred_redminu_vl0sv64hi */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19008; /* pred_redminu_vl0sv128hi */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19016; /* pred_redminu_vl0sv256hi */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19024; /* pred_redminu_vl0sv512hi */

        case 16:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19032; /* pred_redminu_vl0sv1024hi */

        case 17:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19040; /* pred_redminu_vl0sv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18736; /* pred_redminu_vl0srvvm8si */

        case 1:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18744; /* pred_redminu_vl0srvvm4si */

        case 2:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18752; /* pred_redminu_vl0srvvm2si */

        case 3:
          if (!
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18760; /* pred_redminu_vl0srvvm1si */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18840; /* pred_redminu_vl0srvvmf2si */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19048; /* pred_redminu_vl0sv1si */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19056; /* pred_redminu_vl0sv2si */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19064; /* pred_redminu_vl0sv4si */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19072; /* pred_redminu_vl0sv8si */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19080; /* pred_redminu_vl0sv16si */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19088; /* pred_redminu_vl0sv32si */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19096; /* pred_redminu_vl0sv64si */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19104; /* pred_redminu_vl0sv128si */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19112; /* pred_redminu_vl0sv256si */

        case 14:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19120; /* pred_redminu_vl0sv512si */

        case 15:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19128; /* pred_redminu_vl0sv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18768; /* pred_redminu_vl0srvvm8di */

        case 1:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18776; /* pred_redminu_vl0srvvm4di */

        case 2:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18784; /* pred_redminu_vl0srvvm2di */

        case 3:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18792; /* pred_redminu_vl0srvvm1di */

        case 4:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19136; /* pred_redminu_vl0sv1di */

        case 5:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19144; /* pred_redminu_vl0sv2di */

        case 6:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19152; /* pred_redminu_vl0sv4di */

        case 7:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19160; /* pred_redminu_vl0sv8di */

        case 8:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19168; /* pred_redminu_vl0sv16di */

        case 9:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19176; /* pred_redminu_vl0sv32di */

        case 10:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19184; /* pred_redminu_vl0sv64di */

        case 11:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19192; /* pred_redminu_vl0sv128di */

        case 12:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19200; /* pred_redminu_vl0sv256di */

        case 13:
          if (!(
#line 7803 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19208; /* pred_redminu_vl0sv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18125; /* pred_redsumrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18133; /* pred_redsumrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18141; /* pred_redsumrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18149; /* pred_redsumrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18253; /* pred_redsumrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18261; /* pred_redsumrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18269; /* pred_redsumrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18301; /* pred_redsumv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18309; /* pred_redsumv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18317; /* pred_redsumv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18325; /* pred_redsumv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18333; /* pred_redsumv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18341; /* pred_redsumv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18349; /* pred_redsumv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18357; /* pred_redsumv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18365; /* pred_redsumv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18373; /* pred_redsumv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18381; /* pred_redsumv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18389; /* pred_redsumv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18397; /* pred_redsumv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18157; /* pred_redsumrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18165; /* pred_redsumrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18173; /* pred_redsumrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18181; /* pred_redsumrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18277; /* pred_redsumrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18285; /* pred_redsumrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18405; /* pred_redsumv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18413; /* pred_redsumv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18421; /* pred_redsumv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18429; /* pred_redsumv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18437; /* pred_redsumv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18445; /* pred_redsumv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18453; /* pred_redsumv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18461; /* pred_redsumv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18469; /* pred_redsumv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18477; /* pred_redsumv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18485; /* pred_redsumv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18493; /* pred_redsumv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18189; /* pred_redsumrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18197; /* pred_redsumrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18205; /* pred_redsumrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18213; /* pred_redsumrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18293; /* pred_redsumrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18501; /* pred_redsumv1si */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18509; /* pred_redsumv2si */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18517; /* pred_redsumv4si */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18525; /* pred_redsumv8si */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18533; /* pred_redsumv16si */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18541; /* pred_redsumv32si */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18549; /* pred_redsumv64si */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18557; /* pred_redsumv128si */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18565; /* pred_redsumv256si */

        case 14:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18573; /* pred_redsumv512si */

        case 15:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18581; /* pred_redsumv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18221; /* pred_redsumrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18229; /* pred_redsumrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18237; /* pred_redsumrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18245; /* pred_redsumrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18589; /* pred_redsumv1di */

        case 5:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18597; /* pred_redsumv2di */

        case 6:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18605; /* pred_redsumv4di */

        case 7:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18613; /* pred_redsumv8di */

        case 8:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18621; /* pred_redsumv16di */

        case 9:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18629; /* pred_redsumv32di */

        case 10:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18637; /* pred_redsumv64di */

        case 11:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18645; /* pred_redsumv128di */

        case 12:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18653; /* pred_redsumv256di */

        case 13:
          if (!(
#line 7781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18661; /* pred_redsumv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 2)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  switch (XVECLEN (x3, 0))
    {
    case 6:
      return recog_84 (x1, insn, pnum_clobbers);

    case 8:
      x8 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 66
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 67
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 69
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[5] = x12;
      if (!vector_length_operand (operands[5], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x3, 0, 2);
      operands[6] = x13;
      if (!const_int_operand (operands[6], E_VOIDmode))
        return -1;
      x14 = XVECEXP (x3, 0, 3);
      operands[7] = x14;
      if (!const_int_operand (operands[7], E_VOIDmode))
        return -1;
      x15 = XVECEXP (x3, 0, 4);
      operands[8] = x15;
      if (!const_int_operand (operands[8], E_VOIDmode))
        return -1;
      switch (XINT (x4, 1))
        {
        case 145:
          return recog_83 (x1, insn, pnum_clobbers);

        case 146:
          return recog_82 (x1, insn, pnum_clobbers);

        case 147:
          return recog_81 (x1, insn, pnum_clobbers);

        case 148:
          return recog_80 (x1, insn, pnum_clobbers);

        case 167:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19813; /* pred_wredosumrvvm8hf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19815; /* pred_wredosumrvvm4hf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19817; /* pred_wredosumrvvm2hf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19819; /* pred_wredosumrvvm1hf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19821; /* pred_wredosumrvvmf2hf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19823; /* pred_wredosumrvvmf4hf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19835; /* pred_wredosumv1hf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19837; /* pred_wredosumv2hf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19839; /* pred_wredosumv4hf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19841; /* pred_wredosumv8hf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19843; /* pred_wredosumv16hf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19845; /* pred_wredosumv32hf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19847; /* pred_wredosumv64hf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19849; /* pred_wredosumv128hf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19851; /* pred_wredosumv256hf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19853; /* pred_wredosumv512hf */

                case 16:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19855; /* pred_wredosumv1024hf */

                case 17:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19857; /* pred_wredosumv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19825; /* pred_wredosumrvvm8sf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19827; /* pred_wredosumrvvm4sf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19829; /* pred_wredosumrvvm2sf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19831; /* pred_wredosumrvvm1sf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19833; /* pred_wredosumrvvmf2sf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19859; /* pred_wredosumv1sf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19861; /* pred_wredosumv2sf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19863; /* pred_wredosumv4sf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19865; /* pred_wredosumv8sf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19867; /* pred_wredosumv16sf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19869; /* pred_wredosumv32sf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19871; /* pred_wredosumv64sf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19873; /* pred_wredosumv128sf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19875; /* pred_wredosumv256sf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19877; /* pred_wredosumv512sf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19879; /* pred_wredosumv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 168:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19814; /* pred_wredusumrvvm8hf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19816; /* pred_wredusumrvvm4hf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19818; /* pred_wredusumrvvm2hf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19820; /* pred_wredusumrvvm1hf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19822; /* pred_wredusumrvvmf2hf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19824; /* pred_wredusumrvvmf4hf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19836; /* pred_wredusumv1hf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19838; /* pred_wredusumv2hf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19840; /* pred_wredusumv4hf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19842; /* pred_wredusumv8hf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19844; /* pred_wredusumv16hf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19846; /* pred_wredusumv32hf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19848; /* pred_wredusumv64hf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19850; /* pred_wredusumv128hf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19852; /* pred_wredusumv256hf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19854; /* pred_wredusumv512hf */

                case 16:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19856; /* pred_wredusumv1024hf */

                case 17:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19858; /* pred_wredusumv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19826; /* pred_wredusumrvvm8sf */

                case 1:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19828; /* pred_wredusumrvvm4sf */

                case 2:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19830; /* pred_wredusumrvvm2sf */

                case 3:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19832; /* pred_wredusumrvvm1sf */

                case 4:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19834; /* pred_wredusumrvvmf2sf */

                case 5:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19860; /* pred_wredusumv1sf */

                case 6:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19862; /* pred_wredusumv2sf */

                case 7:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19864; /* pred_wredusumv4sf */

                case 8:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19866; /* pred_wredusumv8sf */

                case 9:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19868; /* pred_wredusumv16sf */

                case 10:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19870; /* pred_wredusumv32sf */

                case 11:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19872; /* pred_wredusumv64sf */

                case 12:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19874; /* pred_wredusumv128sf */

                case 13:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19876; /* pred_wredusumv256sf */

                case 14:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19878; /* pred_wredusumv512sf */

                case 15:
                  if (!(
#line 7963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19880; /* pred_wredusumv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 169:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19881; /* pred_wredosum_vl0srvvm8hf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19883; /* pred_wredosum_vl0srvvm4hf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19885; /* pred_wredosum_vl0srvvm2hf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19887; /* pred_wredosum_vl0srvvm1hf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19889; /* pred_wredosum_vl0srvvmf2hf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19891; /* pred_wredosum_vl0srvvmf4hf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19903; /* pred_wredosum_vl0sv1hf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19905; /* pred_wredosum_vl0sv2hf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19907; /* pred_wredosum_vl0sv4hf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19909; /* pred_wredosum_vl0sv8hf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19911; /* pred_wredosum_vl0sv16hf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19913; /* pred_wredosum_vl0sv32hf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19915; /* pred_wredosum_vl0sv64hf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19917; /* pred_wredosum_vl0sv128hf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19919; /* pred_wredosum_vl0sv256hf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19921; /* pred_wredosum_vl0sv512hf */

                case 16:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19923; /* pred_wredosum_vl0sv1024hf */

                case 17:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19925; /* pred_wredosum_vl0sv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19893; /* pred_wredosum_vl0srvvm8sf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19895; /* pred_wredosum_vl0srvvm4sf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19897; /* pred_wredosum_vl0srvvm2sf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19899; /* pred_wredosum_vl0srvvm1sf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19901; /* pred_wredosum_vl0srvvmf2sf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19927; /* pred_wredosum_vl0sv1sf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19929; /* pred_wredosum_vl0sv2sf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19931; /* pred_wredosum_vl0sv4sf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19933; /* pred_wredosum_vl0sv8sf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19935; /* pred_wredosum_vl0sv16sf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19937; /* pred_wredosum_vl0sv32sf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19939; /* pred_wredosum_vl0sv64sf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19941; /* pred_wredosum_vl0sv128sf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19943; /* pred_wredosum_vl0sv256sf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19945; /* pred_wredosum_vl0sv512sf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19947; /* pred_wredosum_vl0sv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 170:
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1SFmode:
              switch (pattern681 (x2, 
E_RVVM1SFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19882; /* pred_wredusum_vl0srvvm8hf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19884; /* pred_wredusum_vl0srvvm4hf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 652 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19886; /* pred_wredusum_vl0srvvm2hf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19888; /* pred_wredusum_vl0srvvm1hf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 653 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
                    return -1;
                  return 19890; /* pred_wredusum_vl0srvvmf2hf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 654 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19892; /* pred_wredusum_vl0srvvmf4hf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 659 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19904; /* pred_wredusum_vl0sv1hf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 660 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19906; /* pred_wredusum_vl0sv2hf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 661 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19908; /* pred_wredusum_vl0sv4hf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 662 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19910; /* pred_wredusum_vl0sv8hf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 663 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
                    return -1;
                  return 19912; /* pred_wredusum_vl0sv16hf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 664 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19914; /* pred_wredusum_vl0sv32hf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 665 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19916; /* pred_wredusum_vl0sv64hf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 666 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19918; /* pred_wredusum_vl0sv128hf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 667 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19920; /* pred_wredusum_vl0sv256hf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 668 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19922; /* pred_wredusum_vl0sv512hf */

                case 16:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 669 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19924; /* pred_wredusum_vl0sv1024hf */

                case 17:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 670 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19926; /* pred_wredusum_vl0sv2048hf */

                default:
                  return -1;
                }

            case E_RVVM1DFmode:
              switch (pattern682 (x2, 
E_RVVM1DFmode))
                {
                case 0:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19894; /* pred_wredusum_vl0srvvm8sf */

                case 1:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19896; /* pred_wredusum_vl0srvvm4sf */

                case 2:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19898; /* pred_wredusum_vl0srvvm2sf */

                case 3:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19900; /* pred_wredusum_vl0srvvm1sf */

                case 4:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 657 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 19902; /* pred_wredusum_vl0srvvmf2sf */

                case 5:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 671 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19928; /* pred_wredusum_vl0sv1sf */

                case 6:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 672 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19930; /* pred_wredusum_vl0sv2sf */

                case 7:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 673 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19932; /* pred_wredusum_vl0sv4sf */

                case 8:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 674 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
                    return -1;
                  return 19934; /* pred_wredusum_vl0sv8sf */

                case 9:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 19936; /* pred_wredusum_vl0sv16sf */

                case 10:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 676 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 19938; /* pred_wredusum_vl0sv32sf */

                case 11:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 19940; /* pred_wredusum_vl0sv64sf */

                case 12:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 678 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 19942; /* pred_wredusum_vl0sv128sf */

                case 13:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 679 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 19944; /* pred_wredusum_vl0sv256sf */

                case 14:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 680 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 19946; /* pred_wredusum_vl0sv512sf */

                case 15:
                  if (!(
#line 7989 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 681 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 19948; /* pred_wredusum_vl0sv1024sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20487; /* pred_slide1uprvvm8hf */

    case 1:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20489; /* pred_slide1uprvvm4hf */

    case 2:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20491; /* pred_slide1uprvvm2hf */

    case 3:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20493; /* pred_slide1uprvvm1hf */

    case 4:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 20495; /* pred_slide1uprvvmf2hf */

    case 5:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20497; /* pred_slide1uprvvmf4hf */

    case 6:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20499; /* pred_slide1uprvvm8sf */

    case 7:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20501; /* pred_slide1uprvvm4sf */

    case 8:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20503; /* pred_slide1uprvvm2sf */

    case 9:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20505; /* pred_slide1uprvvm1sf */

    case 10:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 20507; /* pred_slide1uprvvmf2sf */

    case 11:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20509; /* pred_slide1uprvvm8df */

    case 12:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20511; /* pred_slide1uprvvm4df */

    case 13:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20513; /* pred_slide1uprvvm2df */

    case 14:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20515; /* pred_slide1uprvvm1df */

    case 15:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 20517; /* pred_slide1upv1hf */

    case 16:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 20519; /* pred_slide1upv2hf */

    case 17:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 20521; /* pred_slide1upv4hf */

    case 18:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 20523; /* pred_slide1upv8hf */

    case 19:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 20525; /* pred_slide1upv16hf */

    case 20:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20527; /* pred_slide1upv32hf */

    case 21:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20529; /* pred_slide1upv64hf */

    case 22:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20531; /* pred_slide1upv128hf */

    case 23:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20533; /* pred_slide1upv256hf */

    case 24:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20535; /* pred_slide1upv512hf */

    case 25:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20537; /* pred_slide1upv1024hf */

    case 26:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20539; /* pred_slide1upv2048hf */

    case 27:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20541; /* pred_slide1upv1sf */

    case 28:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20543; /* pred_slide1upv2sf */

    case 29:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20545; /* pred_slide1upv4sf */

    case 30:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20547; /* pred_slide1upv8sf */

    case 31:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20549; /* pred_slide1upv16sf */

    case 32:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20551; /* pred_slide1upv32sf */

    case 33:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20553; /* pred_slide1upv64sf */

    case 34:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20555; /* pred_slide1upv128sf */

    case 35:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20557; /* pred_slide1upv256sf */

    case 36:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20559; /* pred_slide1upv512sf */

    case 37:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20561; /* pred_slide1upv1024sf */

    case 38:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20563; /* pred_slide1upv1df */

    case 39:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20565; /* pred_slide1upv2df */

    case 40:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20567; /* pred_slide1upv4df */

    case 41:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20569; /* pred_slide1upv8df */

    case 42:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20571; /* pred_slide1upv16df */

    case 43:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20573; /* pred_slide1upv32df */

    case 44:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20575; /* pred_slide1upv64df */

    case 45:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20577; /* pred_slide1upv128df */

    case 46:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20579; /* pred_slide1upv256df */

    case 47:
      if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20581; /* pred_slide1upv512df */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 186:
      switch (pattern183 (x1, 
186))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2325; /* pred_indexed_store_widthbrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2331; /* pred_indexed_store_widthbrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2349; /* pred_indexed_store_widthbrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2337; /* pred_indexed_store_widthbrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2355; /* pred_indexed_store_widthbrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2373; /* pred_indexed_store_widthbrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2343; /* pred_indexed_store_widthbrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2361; /* pred_indexed_store_widthbrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2379; /* pred_indexed_store_widthbrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2397; /* pred_indexed_store_widthbrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2367; /* pred_indexed_store_widthbrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2385; /* pred_indexed_store_widthbrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2403; /* pred_indexed_store_widthbrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2391; /* pred_indexed_store_widthbrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2409; /* pred_indexed_store_widthbrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2415; /* pred_indexed_store_widthbrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2421; /* pred_indexed_store_widthbrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2427; /* pred_indexed_store_widthbrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2433; /* pred_indexed_store_widthbrvvmf2si */

        default:
          return -1;
        }

    case 188:
      switch (pattern183 (x1, 
188))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2326; /* pred_indexed_store_widthhrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2332; /* pred_indexed_store_widthhrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2350; /* pred_indexed_store_widthhrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2338; /* pred_indexed_store_widthhrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2356; /* pred_indexed_store_widthhrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2374; /* pred_indexed_store_widthhrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2344; /* pred_indexed_store_widthhrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2362; /* pred_indexed_store_widthhrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2380; /* pred_indexed_store_widthhrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2398; /* pred_indexed_store_widthhrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2368; /* pred_indexed_store_widthhrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2386; /* pred_indexed_store_widthhrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2404; /* pred_indexed_store_widthhrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2392; /* pred_indexed_store_widthhrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2410; /* pred_indexed_store_widthhrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2416; /* pred_indexed_store_widthhrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2422; /* pred_indexed_store_widthhrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2428; /* pred_indexed_store_widthhrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2434; /* pred_indexed_store_widthhrvvmf2si */

        default:
          return -1;
        }

    case 190:
      switch (pattern183 (x1, 
190))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2327; /* pred_indexed_store_widthwrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2333; /* pred_indexed_store_widthwrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2351; /* pred_indexed_store_widthwrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2339; /* pred_indexed_store_widthwrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2357; /* pred_indexed_store_widthwrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2375; /* pred_indexed_store_widthwrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2345; /* pred_indexed_store_widthwrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2363; /* pred_indexed_store_widthwrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2381; /* pred_indexed_store_widthwrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2399; /* pred_indexed_store_widthwrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2369; /* pred_indexed_store_widthwrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2387; /* pred_indexed_store_widthwrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2405; /* pred_indexed_store_widthwrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2393; /* pred_indexed_store_widthwrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2411; /* pred_indexed_store_widthwrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2417; /* pred_indexed_store_widthwrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2423; /* pred_indexed_store_widthwrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2429; /* pred_indexed_store_widthwrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2435; /* pred_indexed_store_widthwrvvmf2si */

        default:
          return -1;
        }

    case 192:
      switch (pattern183 (x1, 
192))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2328; /* pred_indexed_ustore_widthbrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2334; /* pred_indexed_ustore_widthbrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2352; /* pred_indexed_ustore_widthbrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2340; /* pred_indexed_ustore_widthbrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2358; /* pred_indexed_ustore_widthbrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2376; /* pred_indexed_ustore_widthbrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2346; /* pred_indexed_ustore_widthbrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2364; /* pred_indexed_ustore_widthbrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2382; /* pred_indexed_ustore_widthbrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2400; /* pred_indexed_ustore_widthbrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2370; /* pred_indexed_ustore_widthbrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2388; /* pred_indexed_ustore_widthbrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2406; /* pred_indexed_ustore_widthbrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2394; /* pred_indexed_ustore_widthbrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2412; /* pred_indexed_ustore_widthbrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2418; /* pred_indexed_ustore_widthbrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2424; /* pred_indexed_ustore_widthbrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2430; /* pred_indexed_ustore_widthbrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2436; /* pred_indexed_ustore_widthbrvvmf2si */

        default:
          return -1;
        }

    case 193:
      switch (pattern183 (x1, 
193))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2329; /* pred_indexed_ustore_widthhrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2335; /* pred_indexed_ustore_widthhrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2353; /* pred_indexed_ustore_widthhrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2341; /* pred_indexed_ustore_widthhrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2359; /* pred_indexed_ustore_widthhrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2377; /* pred_indexed_ustore_widthhrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2347; /* pred_indexed_ustore_widthhrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2365; /* pred_indexed_ustore_widthhrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2383; /* pred_indexed_ustore_widthhrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2401; /* pred_indexed_ustore_widthhrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2371; /* pred_indexed_ustore_widthhrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2389; /* pred_indexed_ustore_widthhrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2407; /* pred_indexed_ustore_widthhrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2395; /* pred_indexed_ustore_widthhrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2413; /* pred_indexed_ustore_widthhrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2419; /* pred_indexed_ustore_widthhrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2425; /* pred_indexed_ustore_widthhrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2431; /* pred_indexed_ustore_widthhrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2437; /* pred_indexed_ustore_widthhrvvmf2si */

        default:
          return -1;
        }

    case 194:
      switch (pattern183 (x1, 
194))
        {
        case 0:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2330; /* pred_indexed_ustore_widthwrvvm8qi */

        case 1:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2336; /* pred_indexed_ustore_widthwrvvm4qi */

        case 2:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2354; /* pred_indexed_ustore_widthwrvvm8hi */

        case 3:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2342; /* pred_indexed_ustore_widthwrvvm2qi */

        case 4:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2360; /* pred_indexed_ustore_widthwrvvm4hi */

        case 5:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2378; /* pred_indexed_ustore_widthwrvvm8si */

        case 6:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2348; /* pred_indexed_ustore_widthwrvvm1qi */

        case 7:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2366; /* pred_indexed_ustore_widthwrvvm2hi */

        case 8:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2384; /* pred_indexed_ustore_widthwrvvm4si */

        case 9:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2402; /* pred_indexed_ustore_widthwrvvm8di */

        case 10:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2372; /* pred_indexed_ustore_widthwrvvm1hi */

        case 11:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2390; /* pred_indexed_ustore_widthwrvvm2si */

        case 12:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2408; /* pred_indexed_ustore_widthwrvvm4di */

        case 13:
          if (!
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
            return -1;
          return 2396; /* pred_indexed_ustore_widthwrvvm1si */

        case 14:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2414; /* pred_indexed_ustore_widthwrvvm2di */

        case 15:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 2420; /* pred_indexed_ustore_widthwrvvm1di */

        case 16:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2426; /* pred_indexed_ustore_widthwrvvmf8qi */

        case 17:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2432; /* pred_indexed_ustore_widthwrvvmf4hi */

        case 18:
          if (!(
#line 327 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 2438; /* pred_indexed_ustore_widthwrvvmf2si */

        default:
          return -1;
        }

    case 91:
      if (pattern184 (x1, 
67) != 0
          || !const_int_operand (operands[0], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      operands[1] = x3;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 2);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 3);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode)
          || !
#line 1743 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3644; /* vsetvl_vtype_change_only */

    case 96:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 5
          || XINT (x3, 1) != 93)
        return -1;
      x6 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 66
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 67
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != SCRATCH)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      operands[0] = x10;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[4] = x12;
      if (!vector_length_operand (operands[4], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x3, 0, 2);
      operands[5] = x13;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 2);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 3);
      operands[3] = x5;
      return recog_93 (x1, insn, pnum_clobbers);

    case 97:
      return recog_97 (x1, insn, pnum_clobbers);

    case 98:
      return recog_96 (x1, insn, pnum_clobbers);

    case 128:
      return recog_100 (x1, insn, pnum_clobbers);

    case 129:
      return recog_99 (x1, insn, pnum_clobbers);

    case 130:
      return recog_101 (x1, insn, pnum_clobbers);

    case 131:
      return recog_102 (x1, insn, pnum_clobbers);

    case 132:
      return recog_103 (x1, insn, pnum_clobbers);

    case 133:
      switch (pattern197 (x1))
        {
        case 0:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20488; /* pred_slide1downrvvm8hf */

        case 1:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20490; /* pred_slide1downrvvm4hf */

        case 2:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20492; /* pred_slide1downrvvm2hf */

        case 3:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20494; /* pred_slide1downrvvm1hf */

        case 4:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20496; /* pred_slide1downrvvmf2hf */

        case 5:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 20498; /* pred_slide1downrvvmf4hf */

        case 6:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20500; /* pred_slide1downrvvm8sf */

        case 7:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20502; /* pred_slide1downrvvm4sf */

        case 8:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20504; /* pred_slide1downrvvm2sf */

        case 9:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20506; /* pred_slide1downrvvm1sf */

        case 10:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 20508; /* pred_slide1downrvvmf2sf */

        case 11:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20510; /* pred_slide1downrvvm8df */

        case 12:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20512; /* pred_slide1downrvvm4df */

        case 13:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20514; /* pred_slide1downrvvm2df */

        case 14:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20516; /* pred_slide1downrvvm1df */

        case 15:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 20518; /* pred_slide1downv1hf */

        case 16:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 20520; /* pred_slide1downv2hf */

        case 17:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 20522; /* pred_slide1downv4hf */

        case 18:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 20524; /* pred_slide1downv8hf */

        case 19:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 20526; /* pred_slide1downv16hf */

        case 20:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20528; /* pred_slide1downv32hf */

        case 21:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20530; /* pred_slide1downv64hf */

        case 22:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20532; /* pred_slide1downv128hf */

        case 23:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20534; /* pred_slide1downv256hf */

        case 24:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20536; /* pred_slide1downv512hf */

        case 25:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20538; /* pred_slide1downv1024hf */

        case 26:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20540; /* pred_slide1downv2048hf */

        case 27:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20542; /* pred_slide1downv1sf */

        case 28:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20544; /* pred_slide1downv2sf */

        case 29:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20546; /* pred_slide1downv4sf */

        case 30:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20548; /* pred_slide1downv8sf */

        case 31:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20550; /* pred_slide1downv16sf */

        case 32:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20552; /* pred_slide1downv32sf */

        case 33:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20554; /* pred_slide1downv64sf */

        case 34:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20556; /* pred_slide1downv128sf */

        case 35:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20558; /* pred_slide1downv256sf */

        case 36:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20560; /* pred_slide1downv512sf */

        case 37:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20562; /* pred_slide1downv1024sf */

        case 38:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20564; /* pred_slide1downv1df */

        case 39:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20566; /* pred_slide1downv2df */

        case 40:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20568; /* pred_slide1downv4df */

        case 41:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20570; /* pred_slide1downv8df */

        case 42:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20572; /* pred_slide1downv16df */

        case 43:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20574; /* pred_slide1downv32df */

        case 44:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20576; /* pred_slide1downv64df */

        case 45:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20578; /* pred_slide1downv128df */

        case 46:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20580; /* pred_slide1downv256df */

        case 47:
          if (!(
#line 8218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20582; /* pred_slide1downv512df */

        default:
          return -1;
        }

    case 95:
      return recog_98 (x1, insn, pnum_clobbers);

    case 374:
      if (pattern198 (x1) != 0
          || !
#line 2566 "../../gcc-15.0.1-20250329/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34084; /* riscv_cv_simd_cplxmul_r_si */

    case 375:
      if (pattern198 (x1) != 0
          || !
#line 2583 "../../gcc-15.0.1-20250329/gcc/config/riscv/corev.md"
(TARGET_XCVSIMD && !TARGET_64BIT))
        return -1;
      return 34085; /* riscv_cv_simd_cplxmul_i_si */

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HFmode)
      && reg_or_mem_operand (operands[1], E_V1024HFmode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3294; /* *movv1024hfsi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3295; /* *movv1024hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HFmode)
      || !register_operand (operands[1], E_V1024HFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3392; /* *movv1024hf_vls */
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512DImode)
      && reg_or_mem_operand (operands[1], E_V512DImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3282; /* *movv512disi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3283; /* *movv512didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512DImode)
      || !register_operand (operands[1], E_V512DImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3381; /* *movv512di_vls */
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512SImode)
      && reg_or_mem_operand (operands[1], E_V512SImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3270; /* *movv512sisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3271; /* *movv512sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512SImode)
      || !register_operand (operands[1], E_V512SImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3370; /* *movv512si_vls */
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V1024HImode)
      && reg_or_mem_operand (operands[1], E_V1024HImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3258; /* *movv1024hisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3259; /* *movv1024hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V1024HImode)
      || !register_operand (operands[1], E_V1024HImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3359; /* *movv1024hi_vls */
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V4096QImode)
      && reg_or_mem_operand (operands[1], E_V4096QImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3246; /* *movv4096qisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3247; /* *movv4096qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V4096QImode)
      || !register_operand (operands[1], E_V4096QImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 3348; /* *movv4096qi_vls */
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64QImode)
      && reg_or_mem_operand (operands[1], E_V64QImode))
    {
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3234; /* *movv64qisi_lra */
        }
      if ((
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3235; /* *movv64qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64QImode)
      || !register_operand (operands[1], E_V64QImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3342; /* *movv64qi_vls */
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF16BImode)
      && register_operand (operands[1], E_RVVMF16BImode)
      && 
#line 1294 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2814; /* *movrvvmf16bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF16BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF16BImode))
    return -1;
  if ((
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2852; /* *movrvvmf16bisi_lra */
    }
  if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2853; /* *movrvvmf16bidi_lra */
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2HFmode)
      && register_operand (operands[1], E_RVVMF2HFmode)
      && (
#line 1257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 938 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 2797; /* *movrvvmf2hf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2HFmode))
    return -1;
  if ((
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2833; /* *movrvvmf2hfsi_lra */
    }
  if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2844; /* *movrvvmf2hfdi_lra */
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4QImode)
      && register_operand (operands[1], E_RVVMF4QImode)
      && 
#line 1257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return 2791; /* *movrvvmf4qi_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4QImode))
    return -1;
  if ((
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2827; /* *movrvvmf4qisi_lra */
    }
  if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2838; /* *movrvvmf4qidi_lra */
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2BImode)
      && reg_or_mem_operand (operands[1], E_V2BImode)
      && (
#line 1434 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2BImode)
       || register_operand (operands[1], V2BImode))) && 
#line 4341 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
    return 3228; /* *movv2bi */
  if (!register_operand (operands[0], E_V2BImode)
      || !register_operand (operands[1], E_V2BImode)
      || !(
#line 1530 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
    return -1;
  return 3495; /* *movv2bi_vls */
}

 int
recog_195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1DFmode)
      && reg_or_mem_operand (operands[1], E_V1DFmode)
      && (
#line 1434 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1DFmode)
       || register_operand (operands[1], V1DFmode))) && 
#line 4334 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 3222; /* *movv1df */
  if (!register_operand (operands[0], E_V1DFmode)
      || !register_operand (operands[1], E_V1DFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 3405; /* *movv1df_vls */
}

 int
recog_201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16HFmode)
      && reg_or_mem_operand (operands[1], E_V16HFmode)
      && (
#line 1434 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16HFmode)
       || register_operand (operands[1], V16HFmode))) && 
#line 4328 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3216; /* *movv16hf */
  if (!register_operand (operands[0], E_V16HFmode)
      || !register_operand (operands[1], E_V16HFmode)
      || !(
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3386; /* *movv16hf_vls */
}

 int
recog_207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8DImode)
      && reg_or_mem_operand (operands[1], E_V8DImode)
      && (
#line 1434 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8DImode)
       || register_operand (operands[1], V8DImode))) && 
#line 4322 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 3210; /* *movv8di */
  if (!register_operand (operands[0], E_V8DImode)
      || !register_operand (operands[1], E_V8DImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3375; /* *movv8di_vls */
}

 int
recog_213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SImode)
      && reg_or_mem_operand (operands[1], E_V4SImode)
      && (
#line 1434 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))) && 
#line 4316 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 3204; /* *movv4si */
  if (!register_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 3363; /* *movv4si_vls */
}

 int
recog_220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HImode)
      && reg_or_mem_operand (operands[1], E_V1HImode)
      && (
#line 1434 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HImode)
       || register_operand (operands[1], V1HImode))) && 
#line 4309 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 3197; /* *movv1hi */
  if (!register_operand (operands[0], E_V1HImode)
      || !register_operand (operands[1], E_V1HImode)
      || !(
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 3349; /* *movv1hi_vls */
}

 int
recog_227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3190; /* *movrvvm4x2qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3191; /* *movrvvm4x2qi_di */
}

 int
recog_234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1333 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3176; /* *movrvvm4x2sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1333 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3177; /* *movrvvm4x2sf_di */
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3162; /* *movrvvm4x2si_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3163; /* *movrvvm4x2si_di */
}

 int
recog_247 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3150; /* *movrvvm1x6qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3151; /* *movrvvm1x6qi_di */
}

 int
recog_254 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1310 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3136; /* *movrvvm2x3sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1310 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3137; /* *movrvvm2x3sf_di */
}

 int
recog_261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1303 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3122; /* *movrvvm1x3hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1303 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3123; /* *movrvvm1x3hf_di */
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3108; /* *movrvvm1x3bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1296 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3109; /* *movrvvm1x3bf_di */
}

 int
recog_278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4HImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3088; /* *movrvvm1x4hi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3089; /* *movrvvm1x4hi_di */
}

 int
recog_286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3072; /* *movrvvmf2x3qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3073; /* *movrvvmf2x3qi_di */
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3056; /* *movrvvm1x5sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3057; /* *movrvvm1x5sf_di */
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4HFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3040; /* *movrvvmf2x4hf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3041; /* *movrvvmf2x4hf_di */
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3024; /* *movrvvmf2x3bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3025; /* *movrvvmf2x3bf_di */
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3008; /* *movrvvm1x5si_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3009; /* *movrvvm1x5si_di */
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5HImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2994; /* *movrvvmf2x5hi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2995; /* *movrvvmf2x5hi_di */
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x4QImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2978; /* *movrvvmf4x4qi_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2979; /* *movrvvmf4x4qi_di */
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3DFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2962; /* *movrvvm1x3df_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2963; /* *movrvvm1x3df_di */
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x2SFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2946; /* *movrvvmf2x2sf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2947; /* *movrvvmf2x2sf_di */
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x8BFmode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2930; /* *movrvvmf4x8bf_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2931; /* *movrvvmf4x8bf_di */
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7DImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2914; /* *movrvvm1x7di_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2915; /* *movrvvm1x7di_di */
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6SImode))
    return -1;
  if ((
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2898; /* *movrvvmf2x6si_si */
    }
  if (!(
#line 1405 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1185 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2899; /* *movrvvmf2x6si_di */
}

 int
recog_381 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern328 (x2))
    {
    case 0:
      return 297; /* *ashrsi3 */

    case 1:
      if (!
#line 2914 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 300; /* ashrdi3 */

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25494; /* ashrrvvm8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25698; /* vashrrvvm8qi3 */

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25497; /* ashrrvvm4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25701; /* vashrrvvm4qi3 */

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25500; /* ashrrvvm2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25704; /* vashrrvvm2qi3 */

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25503; /* ashrrvvm1qi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25707; /* vashrrvvm1qi3 */

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25506; /* ashrrvvm8hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25710; /* vashrrvvm8hi3 */

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25509; /* ashrrvvm4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25713; /* vashrrvvm4hi3 */

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25512; /* ashrrvvm2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25716; /* vashrrvvm2hi3 */

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25515; /* ashrrvvm1hi3 */
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25719; /* vashrrvvm1hi3 */

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25518; /* ashrrvvm8si3 */
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25722; /* vashrrvvm8si3 */

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25521; /* ashrrvvm4si3 */
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25725; /* vashrrvvm4si3 */

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25524; /* ashrrvvm2si3 */
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25728; /* vashrrvvm2si3 */

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && 
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return 25527; /* ashrrvvm1si3 */
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25731; /* vashrrvvm1si3 */

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25530; /* ashrrvvm8di3 */
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25734; /* vashrrvvm8di3 */

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25533; /* ashrrvvm4di3 */
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25737; /* vashrrvvm4di3 */

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25536; /* ashrrvvm2di3 */
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25740; /* vashrrvvm2di3 */

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 25539; /* ashrrvvm1di3 */
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25743; /* vashrrvvm1di3 */

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25542; /* ashrrvvmf2qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25746; /* vashrrvvmf2qi3 */

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25545; /* ashrrvvmf4qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25749; /* vashrrvvmf4qi3 */

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25548; /* ashrrvvmf8qi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25752; /* vashrrvvmf8qi3 */

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 25551; /* ashrrvvmf2hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 25755; /* vashrrvvmf2hi3 */

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25554; /* ashrrvvmf4hi3 */
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25758; /* vashrrvvmf4hi3 */

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 25557; /* ashrrvvmf2si3 */
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 25761; /* vashrrvvmf2si3 */

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 25560; /* ashrv1qi3 */
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 25764; /* vashrv1qi3 */

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 25563; /* ashrv2qi3 */
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 25767; /* vashrv2qi3 */

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 25566; /* ashrv4qi3 */
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 25770; /* vashrv4qi3 */

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 25569; /* ashrv8qi3 */
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 25773; /* vashrv8qi3 */

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 25572; /* ashrv16qi3 */
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 25776; /* vashrv16qi3 */

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 25575; /* ashrv32qi3 */
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 25779; /* vashrv32qi3 */

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 25578; /* ashrv64qi3 */
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25782; /* vashrv64qi3 */

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 25581; /* ashrv128qi3 */
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25785; /* vashrv128qi3 */

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 25584; /* ashrv256qi3 */
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25788; /* vashrv256qi3 */

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 25587; /* ashrv512qi3 */
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25791; /* vashrv512qi3 */

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 25590; /* ashrv1024qi3 */
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25794; /* vashrv1024qi3 */

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 25593; /* ashrv2048qi3 */
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25797; /* vashrv2048qi3 */

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 25596; /* ashrv4096qi3 */
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25800; /* vashrv4096qi3 */

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 25599; /* ashrv1hi3 */
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25803; /* vashrv1hi3 */

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 25602; /* ashrv2hi3 */
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25806; /* vashrv2hi3 */

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 25605; /* ashrv4hi3 */
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25809; /* vashrv4hi3 */

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 25608; /* ashrv8hi3 */
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25812; /* vashrv8hi3 */

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 25611; /* ashrv16hi3 */
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25815; /* vashrv16hi3 */

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 25614; /* ashrv32hi3 */
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25818; /* vashrv32hi3 */

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 25617; /* ashrv64hi3 */
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25821; /* vashrv64hi3 */

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 25620; /* ashrv128hi3 */
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25824; /* vashrv128hi3 */

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 25623; /* ashrv256hi3 */
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25827; /* vashrv256hi3 */

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 25626; /* ashrv512hi3 */
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25830; /* vashrv512hi3 */

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 25629; /* ashrv1024hi3 */
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25833; /* vashrv1024hi3 */

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 25632; /* ashrv2048hi3 */
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25836; /* vashrv2048hi3 */

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 25635; /* ashrv1si3 */
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25839; /* vashrv1si3 */

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 25638; /* ashrv2si3 */
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25842; /* vashrv2si3 */

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 25641; /* ashrv4si3 */
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25845; /* vashrv4si3 */

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 25644; /* ashrv8si3 */
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25848; /* vashrv8si3 */

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 25647; /* ashrv16si3 */
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25851; /* vashrv16si3 */

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 25650; /* ashrv32si3 */
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25854; /* vashrv32si3 */

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 25653; /* ashrv64si3 */
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25857; /* vashrv64si3 */

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 25656; /* ashrv128si3 */
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25860; /* vashrv128si3 */

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 25659; /* ashrv256si3 */
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25863; /* vashrv256si3 */

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 25662; /* ashrv512si3 */
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25866; /* vashrv512si3 */

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 25665; /* ashrv1024si3 */
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25869; /* vashrv1024si3 */

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 25668; /* ashrv1di3 */
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25872; /* vashrv1di3 */

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 25671; /* ashrv2di3 */
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25875; /* vashrv2di3 */

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 25674; /* ashrv4di3 */
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25878; /* vashrv4di3 */

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 25677; /* ashrv8di3 */
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25881; /* vashrv8di3 */

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 25680; /* ashrv16di3 */
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25884; /* vashrv16di3 */

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 25683; /* ashrv32di3 */
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25887; /* vashrv32di3 */

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 25686; /* ashrv64di3 */
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25890; /* vashrv64di3 */

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 25689; /* ashrv128di3 */
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25893; /* vashrv128di3 */

    case 68:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 25692; /* ashrv256di3 */
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25896; /* vashrv256di3 */

    case 69:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && (
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 25695; /* ashrv512di3 */
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !(
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25899; /* vashrv512di3 */

    default:
      return -1;
    }
}

 int
recog_402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33508; /* pred_crypto_vvsm4rvsrvvm8si */
      if (!
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33568; /* pred_crypto_vvsm4rvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33628; /* pred_crypto_vvsm4rvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33676; /* pred_crypto_vvsm4rvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33712; /* pred_crypto_vvsm4rvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33736; /* pred_crypto_vvsm4rvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33520; /* pred_crypto_vvsm4rvsrvvm4si */
      if (!
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33580; /* pred_crypto_vvsm4rvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33640; /* pred_crypto_vvsm4rvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33688; /* pred_crypto_vvsm4rvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33724; /* pred_crypto_vvsm4rvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33532; /* pred_crypto_vvsm4rvsrvvm2si */
      if (!
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33592; /* pred_crypto_vvsm4rvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33652; /* pred_crypto_vvsm4rvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33700; /* pred_crypto_vvsm4rvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33544; /* pred_crypto_vvsm4rvsrvvm1si */
      if (!
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33604; /* pred_crypto_vvsm4rvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33664; /* pred_crypto_vvsm4rvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 33556; /* pred_crypto_vvsm4rvsrvvmf2si */
      if (!(
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33616; /* pred_crypto_vvsm4rvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_405 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33505; /* pred_crypto_vvaesdmvsrvvm8si */
      if (!
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33565; /* pred_crypto_vvaesdmvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33625; /* pred_crypto_vvaesdmvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33673; /* pred_crypto_vvaesdmvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33709; /* pred_crypto_vvaesdmvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33733; /* pred_crypto_vvaesdmvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33517; /* pred_crypto_vvaesdmvsrvvm4si */
      if (!
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33577; /* pred_crypto_vvaesdmvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33637; /* pred_crypto_vvaesdmvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33685; /* pred_crypto_vvaesdmvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33721; /* pred_crypto_vvaesdmvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33529; /* pred_crypto_vvaesdmvsrvvm2si */
      if (!
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33589; /* pred_crypto_vvaesdmvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33649; /* pred_crypto_vvaesdmvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33697; /* pred_crypto_vvaesdmvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33541; /* pred_crypto_vvaesdmvsrvvm1si */
      if (!
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33601; /* pred_crypto_vvaesdmvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33661; /* pred_crypto_vvaesdmvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return 33553; /* pred_crypto_vvaesdmvsrvvmf2si */
      if (!(
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 33613; /* pred_crypto_vvaesdmvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  if (!vector_length_operand (x4, E_VOIDmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!const_int_operand (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[3] = x7;
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      return recog_397 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      operands[5] = x4;
      operands[6] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[7] = x8;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 2);
      operands[4] = x10;
      x11 = XEXP (x2, 2);
      operands[1] = x11;
      x12 = XEXP (x7, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[3] = x12;
          return recog_398 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          if (GET_MODE (x12) != E_DImode)
            return -1;
          x13 = XEXP (x12, 0);
          operands[3] = x13;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern684 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4033; /* *pred_mergervvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern684 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4034; /* *pred_mergervvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern684 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4035; /* *pred_mergervvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern684 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4036; /* *pred_mergervvm1di_extended_scalar */

            case E_V1DImode:
              if (pattern684 (x2, 
E_V1DImode, 
E_V1BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4037; /* *pred_mergev1di_extended_scalar */

            case E_V2DImode:
              if (pattern684 (x2, 
E_V2DImode, 
E_V2BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4038; /* *pred_mergev2di_extended_scalar */

            case E_V4DImode:
              if (pattern684 (x2, 
E_V4DImode, 
E_V4BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 4039; /* *pred_mergev4di_extended_scalar */

            case E_V8DImode:
              if (pattern684 (x2, 
E_V8DImode, 
E_V8BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 4040; /* *pred_mergev8di_extended_scalar */

            case E_V16DImode:
              if (pattern684 (x2, 
E_V16DImode, 
E_V16BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 4041; /* *pred_mergev16di_extended_scalar */

            case E_V32DImode:
              if (pattern684 (x2, 
E_V32DImode, 
E_V32BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 4042; /* *pred_mergev32di_extended_scalar */

            case E_V64DImode:
              if (pattern684 (x2, 
E_V64DImode, 
E_V64BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 4043; /* *pred_mergev64di_extended_scalar */

            case E_V128DImode:
              if (pattern684 (x2, 
E_V128DImode, 
E_V128BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 4044; /* *pred_mergev128di_extended_scalar */

            case E_V256DImode:
              if (pattern684 (x2, 
E_V256DImode, 
E_V256BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 4045; /* *pred_mergev256di_extended_scalar */

            case E_V512DImode:
              if (pattern684 (x2, 
E_V512DImode, 
E_V512BImode) != 0
                  || !(
#line 2104 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 4046; /* *pred_mergev512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern472 (x2))
        {
        case 0:
          if (!
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28608; /* *cond_len_extendrvvm4qirvvm8hi */

        case 1:
          if (!
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28610; /* *cond_len_extendrvvm2qirvvm4hi */

        case 2:
          if (!
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28612; /* *cond_len_extendrvvm1qirvvm2hi */

        case 3:
          if (!
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28614; /* *cond_len_extendrvvmf2qirvvm1hi */

        case 4:
          if (!
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28616; /* *cond_len_extendrvvmf4qirvvmf2hi */

        case 5:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 28618; /* *cond_len_extendrvvmf8qirvvmf4hi */

        case 6:
          if (!
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28620; /* *cond_len_extendrvvm4hirvvm8si */

        case 7:
          if (!
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28704; /* *cond_len_extendrvvm2qirvvm8si */

        case 8:
          if (!
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28622; /* *cond_len_extendrvvm2hirvvm4si */

        case 9:
          if (!
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28706; /* *cond_len_extendrvvm1qirvvm4si */

        case 10:
          if (!
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28624; /* *cond_len_extendrvvm1hirvvm2si */

        case 11:
          if (!
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28708; /* *cond_len_extendrvvmf2qirvvm2si */

        case 12:
          if (!
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28626; /* *cond_len_extendrvvmf2hirvvm1si */

        case 13:
          if (!
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
            return -1;
          return 28710; /* *cond_len_extendrvvmf4qirvvm1si */

        case 14:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 28628; /* *cond_len_extendrvvmf4hirvvmf2si */

        case 15:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1106 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 28712; /* *cond_len_extendrvvmf8qirvvmf2si */

        case 16:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28630; /* *cond_len_extendrvvm4sirvvm8di */

        case 17:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28714; /* *cond_len_extendrvvm2hirvvm8di */

        case 18:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28764; /* *cond_len_extendrvvm1qirvvm8di */

        case 19:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28632; /* *cond_len_extendrvvm2sirvvm4di */

        case 20:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28716; /* *cond_len_extendrvvm1hirvvm4di */

        case 21:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28766; /* *cond_len_extendrvvmf2qirvvm4di */

        case 22:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28634; /* *cond_len_extendrvvm1sirvvm2di */

        case 23:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28718; /* *cond_len_extendrvvmf2hirvvm2di */

        case 24:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28768; /* *cond_len_extendrvvmf4qirvvm2di */

        case 25:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28636; /* *cond_len_extendrvvmf2sirvvm1di */

        case 26:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28720; /* *cond_len_extendrvvmf4hirvvm1di */

        case 27:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28770; /* *cond_len_extendrvvmf8qirvvm1di */

        case 28:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 28638; /* *cond_len_extendv1qiv1hi */

        case 29:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 28640; /* *cond_len_extendv2qiv2hi */

        case 30:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 28642; /* *cond_len_extendv4qiv4hi */

        case 31:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 28644; /* *cond_len_extendv8qiv8hi */

        case 32:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 28646; /* *cond_len_extendv16qiv16hi */

        case 33:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28648; /* *cond_len_extendv32qiv32hi */

        case 34:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28650; /* *cond_len_extendv64qiv64hi */

        case 35:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28652; /* *cond_len_extendv128qiv128hi */

        case 36:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28654; /* *cond_len_extendv256qiv256hi */

        case 37:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28656; /* *cond_len_extendv512qiv512hi */

        case 38:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28658; /* *cond_len_extendv1024qiv1024hi */

        case 39:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28660; /* *cond_len_extendv2048qiv2048hi */

        case 40:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 28662; /* *cond_len_extendv1hiv1si */

        case 41:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1111 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 28722; /* *cond_len_extendv1qiv1si */

        case 42:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 28664; /* *cond_len_extendv2hiv2si */

        case 43:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1112 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 28724; /* *cond_len_extendv2qiv2si */

        case 44:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 28666; /* *cond_len_extendv4hiv4si */

        case 45:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1113 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 28726; /* *cond_len_extendv4qiv4si */

        case 46:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 28668; /* *cond_len_extendv8hiv8si */

        case 47:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 28728; /* *cond_len_extendv8qiv8si */

        case 48:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28670; /* *cond_len_extendv16hiv16si */

        case 49:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28730; /* *cond_len_extendv16qiv16si */

        case 50:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28672; /* *cond_len_extendv32hiv32si */

        case 51:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1116 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28732; /* *cond_len_extendv32qiv32si */

        case 52:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28674; /* *cond_len_extendv64hiv64si */

        case 53:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1117 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28734; /* *cond_len_extendv64qiv64si */

        case 54:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28676; /* *cond_len_extendv128hiv128si */

        case 55:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1118 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28736; /* *cond_len_extendv128qiv128si */

        case 56:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28678; /* *cond_len_extendv256hiv256si */

        case 57:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1119 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28738; /* *cond_len_extendv256qiv256si */

        case 58:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28680; /* *cond_len_extendv512hiv512si */

        case 59:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1120 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28740; /* *cond_len_extendv512qiv512si */

        case 60:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28682; /* *cond_len_extendv1024hiv1024si */

        case 61:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28742; /* *cond_len_extendv1024qiv1024si */

        case 62:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28684; /* *cond_len_extendv1siv1di */

        case 63:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1122 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28744; /* *cond_len_extendv1hiv1di */

        case 64:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1154 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28772; /* *cond_len_extendv1qiv1di */

        case 65:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28686; /* *cond_len_extendv2siv2di */

        case 66:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28746; /* *cond_len_extendv2hiv2di */

        case 67:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28774; /* *cond_len_extendv2qiv2di */

        case 68:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28688; /* *cond_len_extendv4siv4di */

        case 69:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1124 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28748; /* *cond_len_extendv4hiv4di */

        case 70:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 28776; /* *cond_len_extendv4qiv4di */

        case 71:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28690; /* *cond_len_extendv8siv8di */

        case 72:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1125 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28750; /* *cond_len_extendv8hiv8di */

        case 73:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28778; /* *cond_len_extendv8qiv8di */

        case 74:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28692; /* *cond_len_extendv16siv16di */

        case 75:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1126 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28752; /* *cond_len_extendv16hiv16di */

        case 76:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1158 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28780; /* *cond_len_extendv16qiv16di */

        case 77:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28694; /* *cond_len_extendv32siv32di */

        case 78:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1127 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28754; /* *cond_len_extendv32hiv32di */

        case 79:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28782; /* *cond_len_extendv32qiv32di */

        case 80:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28696; /* *cond_len_extendv64siv64di */

        case 81:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1128 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28756; /* *cond_len_extendv64hiv64di */

        case 82:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28784; /* *cond_len_extendv64qiv64di */

        case 83:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28698; /* *cond_len_extendv128siv128di */

        case 84:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1129 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28758; /* *cond_len_extendv128hiv128di */

        case 85:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1161 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28786; /* *cond_len_extendv128qiv128di */

        case 86:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28700; /* *cond_len_extendv256siv256di */

        case 87:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1130 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28760; /* *cond_len_extendv256hiv256di */

        case 88:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28788; /* *cond_len_extendv256qiv256di */

        case 89:
          if (!(
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28702; /* *cond_len_extendv512siv512di */

        case 90:
          if (!(
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28762; /* *cond_len_extendv512hiv512di */

        case 91:
          if (!(
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28790; /* *cond_len_extendv512qiv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_399 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      operands[4] = x4;
      operands[5] = x5;
      x8 = XVECEXP (x3, 0, 2);
      operands[6] = x8;
      x12 = XEXP (x7, 0);
      operands[2] = x12;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      x10 = XEXP (x6, 2);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern470 (x2, 
E_RVVMF4BImode, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 990 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28870; /* *cond_len_extendrvvm4hfrvvm8sf */

        case E_RVVM4SFmode:
          if (pattern470 (x2, 
E_RVVMF8BImode, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 991 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28871; /* *cond_len_extendrvvm2hfrvvm4sf */

        case E_RVVM2SFmode:
          if (pattern470 (x2, 
E_RVVMF16BImode, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 992 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28872; /* *cond_len_extendrvvm1hfrvvm2sf */

        case E_RVVM1SFmode:
          if (pattern470 (x2, 
E_RVVMF32BImode, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 993 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28873; /* *cond_len_extendrvvmf2hfrvvm1sf */

        case E_RVVMF2SFmode:
          if (pattern470 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 994 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 28874; /* *cond_len_extendrvvmf4hfrvvmf2sf */

        case E_RVVM8DFmode:
          if (pattern470 (x2, 
E_RVVMF8BImode, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28875; /* *cond_len_extendrvvm4sfrvvm8df */

        case E_RVVM4DFmode:
          if (pattern470 (x2, 
E_RVVMF16BImode, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28876; /* *cond_len_extendrvvm2sfrvvm4df */

        case E_RVVM2DFmode:
          if (pattern470 (x2, 
E_RVVMF32BImode, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28877; /* *cond_len_extendrvvm1sfrvvm2df */

        case E_RVVM1DFmode:
          if (pattern470 (x2, 
E_RVVMF64BImode, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28878; /* *cond_len_extendrvvmf2sfrvvm1df */

        case E_V1SFmode:
          if (pattern470 (x2, 
E_V1BImode, 
E_V1SFmode, 
E_V1HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 999 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28879; /* *cond_len_extendv1hfv1sf */

        case E_V2SFmode:
          if (pattern470 (x2, 
E_V2BImode, 
E_V2SFmode, 
E_V2HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1000 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28880; /* *cond_len_extendv2hfv2sf */

        case E_V4SFmode:
          if (pattern470 (x2, 
E_V4BImode, 
E_V4SFmode, 
E_V4HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1001 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28881; /* *cond_len_extendv4hfv4sf */

        case E_V8SFmode:
          if (pattern470 (x2, 
E_V8BImode, 
E_V8SFmode, 
E_V8HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1002 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 28882; /* *cond_len_extendv8hfv8sf */

        case E_V16SFmode:
          if (pattern470 (x2, 
E_V16BImode, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1003 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28883; /* *cond_len_extendv16hfv16sf */

        case E_V32SFmode:
          if (pattern470 (x2, 
E_V32BImode, 
E_V32SFmode, 
E_V32HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1004 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28884; /* *cond_len_extendv32hfv32sf */

        case E_V64SFmode:
          if (pattern470 (x2, 
E_V64BImode, 
E_V64SFmode, 
E_V64HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28885; /* *cond_len_extendv64hfv64sf */

        case E_V128SFmode:
          if (pattern470 (x2, 
E_V128BImode, 
E_V128SFmode, 
E_V128HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1006 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28886; /* *cond_len_extendv128hfv128sf */

        case E_V256SFmode:
          if (pattern470 (x2, 
E_V256BImode, 
E_V256SFmode, 
E_V256HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1007 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28887; /* *cond_len_extendv256hfv256sf */

        case E_V512SFmode:
          if (pattern470 (x2, 
E_V512BImode, 
E_V512SFmode, 
E_V512HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1008 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28888; /* *cond_len_extendv512hfv512sf */

        case E_V1024SFmode:
          if (pattern470 (x2, 
E_V1024BImode, 
E_V1024SFmode, 
E_V1024HFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1009 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28889; /* *cond_len_extendv1024hfv1024sf */

        case E_V1DFmode:
          if (pattern470 (x2, 
E_V1BImode, 
E_V1DFmode, 
E_V1SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1010 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28890; /* *cond_len_extendv1sfv1df */

        case E_V2DFmode:
          if (pattern470 (x2, 
E_V2BImode, 
E_V2DFmode, 
E_V2SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1011 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28891; /* *cond_len_extendv2sfv2df */

        case E_V4DFmode:
          if (pattern470 (x2, 
E_V4BImode, 
E_V4DFmode, 
E_V4SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 28892; /* *cond_len_extendv4sfv4df */

        case E_V8DFmode:
          if (pattern470 (x2, 
E_V8BImode, 
E_V8DFmode, 
E_V8SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 28893; /* *cond_len_extendv8sfv8df */

        case E_V16DFmode:
          if (pattern470 (x2, 
E_V16BImode, 
E_V16DFmode, 
E_V16SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1014 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 28894; /* *cond_len_extendv16sfv16df */

        case E_V32DFmode:
          if (pattern470 (x2, 
E_V32BImode, 
E_V32DFmode, 
E_V32SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 28895; /* *cond_len_extendv32sfv32df */

        case E_V64DFmode:
          if (pattern470 (x2, 
E_V64BImode, 
E_V64DFmode, 
E_V64SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 28896; /* *cond_len_extendv64sfv64df */

        case E_V128DFmode:
          if (pattern470 (x2, 
E_V128BImode, 
E_V128DFmode, 
E_V128SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1017 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 28897; /* *cond_len_extendv128sfv128df */

        case E_V256DFmode:
          if (pattern470 (x2, 
E_V256BImode, 
E_V256DFmode, 
E_V256SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1018 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 28898; /* *cond_len_extendv256sfv256df */

        case E_V512DFmode:
          if (pattern470 (x2, 
E_V512BImode, 
E_V512DFmode, 
E_V512SFmode) != 0
              || !(
#line 331 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1019 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 28899; /* *cond_len_extendv512sfv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_474 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64HImode)
      && (
#line 2340 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 4293; /* *pred_broadcastv64hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64HImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4415; /* *pred_broadcastv64hi_imm */
}

 int
recog_480 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1HImode)
      && (
#line 2340 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 4287; /* *pred_broadcastv1hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1HImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 4409; /* *pred_broadcastv1hi_imm */
}

 int
recog_487 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64QImode)
      && (
#line 2340 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 4280; /* *pred_broadcastv64qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64QImode)
      || !(
#line 2360 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4402; /* *pred_broadcastv64qi_imm */
}

 int
recog_494 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
      && vector_const_0_operand (operands[3], E_RVVM1DFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4273; /* *pred_broadcastrvvm1df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1DFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4395; /* *pred_broadcastrvvm1df_imm */
}

 int
recog_501 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
      && vector_const_0_operand (operands[3], E_RVVM4SFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 4266; /* *pred_broadcastrvvm4sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4SFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4388; /* *pred_broadcastrvvm4sf_imm */
}

 int
recog_508 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF2BImode)
      && vector_const_0_operand (operands[3], E_RVVM8HFmode)
      && (
#line 2340 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return 4259; /* *pred_broadcastrvvm8hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF2BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8HFmode)
      || !(
#line 2360 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4381; /* *pred_broadcastrvvm8hf_imm */
}

 int
recog_515 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64DFmode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 20701; /* pred_gatherv64df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 20823; /* pred_gatherv64df_scalar */
}

 int
recog_519 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 20697; /* pred_gatherv4df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20819; /* pred_gatherv4df_scalar */
}

 int
recog_523 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 20693; /* pred_gatherv512sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20815; /* pred_gatherv512sf_scalar */
}

 int
recog_528 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16SFmode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 20688; /* pred_gatherv16sf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20810; /* pred_gatherv16sf_scalar */
}

 int
recog_533 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2048HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return 20683; /* pred_gatherv2048hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 20805; /* pred_gatherv2048hf_scalar */
}

 int
recog_538 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64HFmode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return 20678; /* pred_gatherv64hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 20800; /* pred_gatherv64hf_scalar */
}

 int
recog_544 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 20672; /* pred_gatherv1hf */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 20794; /* pred_gatherv1hf_scalar */
}

 int
recog_549 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V32DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 20667; /* pred_gatherv32di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20789; /* pred_gatherv32di_scalar */
}

 int
recog_554 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V1DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 20662; /* pred_gatherv1di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 20784; /* pred_gatherv1di_scalar */
}

 int
recog_559 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 20657; /* pred_gatherv64si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 20779; /* pred_gatherv64si_scalar */
}

 int
recog_563 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4SImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 20653; /* pred_gatherv4si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 20775; /* pred_gatherv4si_scalar */
}

 int
recog_568 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V512HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 20648; /* pred_gatherv512hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 20770; /* pred_gatherv512hi_scalar */
}

 int
recog_573 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V16HImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 20643; /* pred_gatherv16hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 20765; /* pred_gatherv16hi_scalar */
}

 int
recog_579 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V2048QImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 20637; /* pred_gatherv2048qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 20759; /* pred_gatherv2048qi_scalar */
}

 int
recog_584 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V64QImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 20632; /* pred_gatherv64qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 20754; /* pred_gatherv64qi_scalar */
}

 int
recog_588 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_V4QImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return 20628; /* pred_gatherv4qi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return -1;
  return 20750; /* pred_gatherv4qi_scalar */
}

 int
recog_593 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern603 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
    return -1;
  if (register_operand (operands[4], E_RVVM4DImode)
      && (
#line 8239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 20623; /* pred_gatherrvvm4df */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 8259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 20745; /* pred_gatherrvvm4df_scalar */
}

 int
recog_598 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern558 (x2))
    {
    case 0:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8089; /* pred_mulhsurvvm8qi */

    case 1:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8092; /* pred_mulhsurvvm4qi */

    case 2:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8095; /* pred_mulhsurvvm2qi */

    case 3:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8098; /* pred_mulhsurvvm1qi */

    case 4:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8101; /* pred_mulhsurvvmf2qi */

    case 5:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8104; /* pred_mulhsurvvmf4qi */

    case 6:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8107; /* pred_mulhsurvvmf8qi */

    case 7:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8110; /* pred_mulhsurvvm8hi */

    case 8:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8113; /* pred_mulhsurvvm4hi */

    case 9:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8116; /* pred_mulhsurvvm2hi */

    case 10:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8119; /* pred_mulhsurvvm1hi */

    case 11:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8122; /* pred_mulhsurvvmf2hi */

    case 12:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 504 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8125; /* pred_mulhsurvvmf4hi */

    case 13:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8128; /* pred_mulhsurvvm8si */

    case 14:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8131; /* pred_mulhsurvvm4si */

    case 15:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8134; /* pred_mulhsurvvm2si */

    case 16:
      if (!
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8137; /* pred_mulhsurvvm1si */

    case 17:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 506 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8140; /* pred_mulhsurvvmf2si */

    case 18:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8143; /* pred_mulhsurvvm8di */

    case 19:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8146; /* pred_mulhsurvvm4di */

    case 20:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8149; /* pred_mulhsurvvm2di */

    case 21:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8152; /* pred_mulhsurvvm1di */

    case 22:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 510 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8155; /* pred_mulhsuv1qi */

    case 23:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 511 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8158; /* pred_mulhsuv2qi */

    case 24:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 512 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8161; /* pred_mulhsuv4qi */

    case 25:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 513 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8164; /* pred_mulhsuv8qi */

    case 26:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 514 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8167; /* pred_mulhsuv16qi */

    case 27:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 515 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8170; /* pred_mulhsuv32qi */

    case 28:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 516 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8173; /* pred_mulhsuv64qi */

    case 29:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 517 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8176; /* pred_mulhsuv128qi */

    case 30:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 518 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8179; /* pred_mulhsuv256qi */

    case 31:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 519 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8182; /* pred_mulhsuv512qi */

    case 32:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8185; /* pred_mulhsuv1024qi */

    case 33:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 521 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8188; /* pred_mulhsuv2048qi */

    case 34:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8191; /* pred_mulhsuv4096qi */

    case 35:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 523 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8194; /* pred_mulhsuv1hi */

    case 36:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8197; /* pred_mulhsuv2hi */

    case 37:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8200; /* pred_mulhsuv4hi */

    case 38:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 526 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8203; /* pred_mulhsuv8hi */

    case 39:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 527 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8206; /* pred_mulhsuv16hi */

    case 40:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 528 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8209; /* pred_mulhsuv32hi */

    case 41:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 529 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8212; /* pred_mulhsuv64hi */

    case 42:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 530 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8215; /* pred_mulhsuv128hi */

    case 43:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8218; /* pred_mulhsuv256hi */

    case 44:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8221; /* pred_mulhsuv512hi */

    case 45:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8224; /* pred_mulhsuv1024hi */

    case 46:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 534 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8227; /* pred_mulhsuv2048hi */

    case 47:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 535 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8230; /* pred_mulhsuv1si */

    case 48:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 536 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8233; /* pred_mulhsuv2si */

    case 49:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 537 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8236; /* pred_mulhsuv4si */

    case 50:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 538 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8239; /* pred_mulhsuv8si */

    case 51:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 539 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8242; /* pred_mulhsuv16si */

    case 52:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 540 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8245; /* pred_mulhsuv32si */

    case 53:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 541 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8248; /* pred_mulhsuv64si */

    case 54:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 542 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8251; /* pred_mulhsuv128si */

    case 55:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 543 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8254; /* pred_mulhsuv256si */

    case 56:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8257; /* pred_mulhsuv512si */

    case 57:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 545 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8260; /* pred_mulhsuv1024si */

    case 58:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 8263; /* pred_mulhsuv1di */

    case 59:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 547 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 8266; /* pred_mulhsuv2di */

    case 60:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 548 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 8269; /* pred_mulhsuv4di */

    case 61:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 549 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8272; /* pred_mulhsuv8di */

    case 62:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 550 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8275; /* pred_mulhsuv16di */

    case 63:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 551 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8278; /* pred_mulhsuv32di */

    case 64:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 552 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8281; /* pred_mulhsuv64di */

    case 65:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8284; /* pred_mulhsuv128di */

    case 66:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 554 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8287; /* pred_mulhsuv256di */

    case 67:
      if (!(
#line 3074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 555 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8290; /* pred_mulhsuv512di */

    case 68:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8293; /* pred_mulhsurvvm8qi_scalar */

    case 69:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8296; /* pred_mulhsurvvm4qi_scalar */

    case 70:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8299; /* pred_mulhsurvvm2qi_scalar */

    case 71:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8302; /* pred_mulhsurvvm1qi_scalar */

    case 72:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8305; /* pred_mulhsurvvmf2qi_scalar */

    case 73:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8308; /* pred_mulhsurvvmf4qi_scalar */

    case 74:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8311; /* pred_mulhsurvvmf8qi_scalar */

    case 75:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8314; /* pred_mulhsurvvm8hi_scalar */

    case 76:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8317; /* pred_mulhsurvvm4hi_scalar */

    case 77:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8320; /* pred_mulhsurvvm2hi_scalar */

    case 78:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8323; /* pred_mulhsurvvm1hi_scalar */

    case 79:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8326; /* pred_mulhsurvvmf2hi_scalar */

    case 80:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8329; /* pred_mulhsurvvmf4hi_scalar */

    case 81:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8332; /* pred_mulhsurvvm8si_scalar */

    case 82:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8335; /* pred_mulhsurvvm4si_scalar */

    case 83:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8338; /* pred_mulhsurvvm2si_scalar */

    case 84:
      if (!
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8341; /* pred_mulhsurvvm1si_scalar */

    case 85:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 8344; /* pred_mulhsurvvmf2si_scalar */

    case 86:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 8347; /* pred_mulhsuv1qi_scalar */

    case 87:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 8350; /* pred_mulhsuv2qi_scalar */

    case 88:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 8353; /* pred_mulhsuv4qi_scalar */

    case 89:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 8356; /* pred_mulhsuv8qi_scalar */

    case 90:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 8359; /* pred_mulhsuv16qi_scalar */

    case 91:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 8362; /* pred_mulhsuv32qi_scalar */

    case 92:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8365; /* pred_mulhsuv64qi_scalar */

    case 93:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8368; /* pred_mulhsuv128qi_scalar */

    case 94:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8371; /* pred_mulhsuv256qi_scalar */

    case 95:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8374; /* pred_mulhsuv512qi_scalar */

    case 96:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8377; /* pred_mulhsuv1024qi_scalar */

    case 97:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8380; /* pred_mulhsuv2048qi_scalar */

    case 98:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8383; /* pred_mulhsuv4096qi_scalar */

    case 99:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 8386; /* pred_mulhsuv1hi_scalar */

    case 100:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 8389; /* pred_mulhsuv2hi_scalar */

    case 101:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 8392; /* pred_mulhsuv4hi_scalar */

    case 102:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 8395; /* pred_mulhsuv8hi_scalar */

    case 103:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 8398; /* pred_mulhsuv16hi_scalar */

    case 104:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8401; /* pred_mulhsuv32hi_scalar */

    case 105:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8404; /* pred_mulhsuv64hi_scalar */

    case 106:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8407; /* pred_mulhsuv128hi_scalar */

    case 107:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8410; /* pred_mulhsuv256hi_scalar */

    case 108:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8413; /* pred_mulhsuv512hi_scalar */

    case 109:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8416; /* pred_mulhsuv1024hi_scalar */

    case 110:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8419; /* pred_mulhsuv2048hi_scalar */

    case 111:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 8422; /* pred_mulhsuv1si_scalar */

    case 112:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 8425; /* pred_mulhsuv2si_scalar */

    case 113:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 8428; /* pred_mulhsuv4si_scalar */

    case 114:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 8431; /* pred_mulhsuv8si_scalar */

    case 115:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 8434; /* pred_mulhsuv16si_scalar */

    case 116:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 8437; /* pred_mulhsuv32si_scalar */

    case 117:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 8440; /* pred_mulhsuv64si_scalar */

    case 118:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 8443; /* pred_mulhsuv128si_scalar */

    case 119:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 8446; /* pred_mulhsuv256si_scalar */

    case 120:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 8449; /* pred_mulhsuv512si_scalar */

    case 121:
      if (!(
#line 3095 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 8452; /* pred_mulhsuv1024si_scalar */

    case 122:
      if (!(
#line 3149 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8455; /* *pred_mulhsurvvm8di_scalar */

    case 123:
      if (!(
#line 3149 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 790 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8458; /* *pred_mulhsurvvm4di_scalar */

    case 124:
      if (!(
#line 3149 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8461; /* *pred_mulhsurvvm2di_scalar */

    case 125:
      if (!(
#line 3149 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 791 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8464; /* *pred_mulhsurvvm1di_scalar */

    case 126:
      if (!(
#line 3171 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8467; /* *pred_mulhsurvvm8di_extended_scalar */

    case 127:
      if (!(
#line 3171 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 790 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8470; /* *pred_mulhsurvvm4di_extended_scalar */

    case 128:
      if (!(
#line 3171 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8473; /* *pred_mulhsurvvm2di_extended_scalar */

    case 129:
      if (!(
#line 3171 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 791 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 8476; /* *pred_mulhsurvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_605 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern604 (x2))
    {
    case 0:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32945; /* pred_vbrevrvvm8qi */

    case 1:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32948; /* pred_vbrevrvvm4qi */

    case 2:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32951; /* pred_vbrevrvvm2qi */

    case 3:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32954; /* pred_vbrevrvvm1qi */

    case 4:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32957; /* pred_vbrevrvvm8hi */

    case 5:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32960; /* pred_vbrevrvvm4hi */

    case 6:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32963; /* pred_vbrevrvvm2hi */

    case 7:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32966; /* pred_vbrevrvvm1hi */

    case 8:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32969; /* pred_vbrevrvvm8si */

    case 9:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32972; /* pred_vbrevrvvm4si */

    case 10:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32975; /* pred_vbrevrvvm2si */

    case 11:
      if (!
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
        return -1;
      return 32978; /* pred_vbrevrvvm1si */

    case 12:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32981; /* pred_vbrevrvvm8di */

    case 13:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32984; /* pred_vbrevrvvm4di */

    case 14:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32987; /* pred_vbrevrvvm2di */

    case 15:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32990; /* pred_vbrevrvvm1di */

    case 16:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32993; /* pred_vbrevrvvmf2qi */

    case 17:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 32996; /* pred_vbrevrvvmf4qi */

    case 18:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 32999; /* pred_vbrevrvvmf8qi */

    case 19:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 33002; /* pred_vbrevrvvmf2hi */

    case 20:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33005; /* pred_vbrevrvvmf4hi */

    case 21:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33008; /* pred_vbrevrvvmf2si */

    case 22:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 33011; /* pred_vbrevv1qi */

    case 23:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 33014; /* pred_vbrevv2qi */

    case 24:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 33017; /* pred_vbrevv4qi */

    case 25:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 33020; /* pred_vbrevv8qi */

    case 26:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 33023; /* pred_vbrevv16qi */

    case 27:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 33026; /* pred_vbrevv32qi */

    case 28:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33029; /* pred_vbrevv64qi */

    case 29:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33032; /* pred_vbrevv128qi */

    case 30:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33035; /* pred_vbrevv256qi */

    case 31:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33038; /* pred_vbrevv512qi */

    case 32:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33041; /* pred_vbrevv1024qi */

    case 33:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33044; /* pred_vbrevv2048qi */

    case 34:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33047; /* pred_vbrevv4096qi */

    case 35:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 33050; /* pred_vbrevv1hi */

    case 36:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 33053; /* pred_vbrevv2hi */

    case 37:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 33056; /* pred_vbrevv4hi */

    case 38:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 33059; /* pred_vbrevv8hi */

    case 39:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 33062; /* pred_vbrevv16hi */

    case 40:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33065; /* pred_vbrevv32hi */

    case 41:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33068; /* pred_vbrevv64hi */

    case 42:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33071; /* pred_vbrevv128hi */

    case 43:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33074; /* pred_vbrevv256hi */

    case 44:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33077; /* pred_vbrevv512hi */

    case 45:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33080; /* pred_vbrevv1024hi */

    case 46:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33083; /* pred_vbrevv2048hi */

    case 47:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 33086; /* pred_vbrevv1si */

    case 48:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 33089; /* pred_vbrevv2si */

    case 49:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 33092; /* pred_vbrevv4si */

    case 50:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 33095; /* pred_vbrevv8si */

    case 51:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33098; /* pred_vbrevv16si */

    case 52:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33101; /* pred_vbrevv32si */

    case 53:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33104; /* pred_vbrevv64si */

    case 54:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33107; /* pred_vbrevv128si */

    case 55:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33110; /* pred_vbrevv256si */

    case 56:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33113; /* pred_vbrevv512si */

    case 57:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33116; /* pred_vbrevv1024si */

    case 58:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33119; /* pred_vbrevv1di */

    case 59:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33122; /* pred_vbrevv2di */

    case 60:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33125; /* pred_vbrevv4di */

    case 61:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33128; /* pred_vbrevv8di */

    case 62:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33131; /* pred_vbrevv16di */

    case 63:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33134; /* pred_vbrevv32di */

    case 64:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33137; /* pred_vbrevv64di */

    case 65:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33140; /* pred_vbrevv128di */

    case 66:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33143; /* pred_vbrevv256di */

    case 67:
      if (!(
#line 342 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33146; /* pred_vbrevv512di */

    default:
      return -1;
    }
}

 int
recog_624 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVM1DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVM1DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVM1DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13096; /* *pred_mul_plusrvvm1di_undef */
}

 int
recog_628 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_RVVMF2HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_RVVMF2HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_RVVMF2HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return -1;
  return 13100; /* *pred_mul_plusrvvmf2hi_undef */
}

 int
recog_631 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 13103; /* *pred_mul_plusv1qi_undef */
}

 int
recog_635 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V16QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V16QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V16QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
    return -1;
  return 13107; /* *pred_mul_plusv16qi_undef */
}

 int
recog_639 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V256QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V256QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V256QImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13111; /* *pred_mul_plusv256qi_undef */
}

 int
recog_644 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 13116; /* *pred_mul_plusv1hi_undef */
}

 int
recog_649 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V32HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V32HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V32HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13121; /* *pred_mul_plusv32hi_undef */
}

 int
recog_654 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1024HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1024HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1024HImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13126; /* *pred_mul_plusv1024hi_undef */
}

 int
recog_659 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V8SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V8SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V8SImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 13131; /* *pred_mul_plusv8si_undef */
}

 int
recog_664 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V256SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V256SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V256SImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13136; /* *pred_mul_plusv256si_undef */
}

 int
recog_670 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V8DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V8DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V8DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13142; /* *pred_mul_plusv8di_undef */
}

 int
recog_676 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V512DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V512DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V512DImode)
      || !(
#line 5331 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13148; /* *pred_mul_plusv512di_undef */
}

 int
recog_682 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_671 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V16DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13211; /* *pred_maddv16di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13279; /* *pred_maccv16di */
}

 int
recog_688 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_665 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V512SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13205; /* *pred_maddv512si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13273; /* *pred_maccv512si */
}

 int
recog_695 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_658 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13198; /* *pred_maddv4si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13266; /* *pred_maccv4si */
}

 int
recog_702 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_651 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V128HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 13191; /* *pred_maddv128hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13259; /* *pred_maccv128hi */
}

 int
recog_709 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_644 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return 13184; /* *pred_maddv1hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
    return -1;
  return 13252; /* *pred_maccv1hi */
}

 int
recog_716 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_637 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V64QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 13177; /* *pred_maddv64qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13245; /* *pred_maccv64qi */
}

 int
recog_724 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13345; /* *pred_maddv4di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13413; /* *pred_maccv4di_scalar */
}

 int
recog_731 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13338; /* *pred_maddv64si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13406; /* *pred_maccv64si_scalar */
}

 int
recog_738 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13331; /* *pred_maddv2048hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13399; /* *pred_maccv2048hi_scalar */
}

 int
recog_745 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 13324; /* *pred_maddv16hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 13392; /* *pred_maccv16hi_scalar */
}

 int
recog_752 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return recog_748 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          return recog_746 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          operands[2] = x14;
          if (!reg_or_0_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern720 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13421; /* *pred_maddrvvm8di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13435; /* *pred_maccrvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern720 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13422; /* *pred_maddrvvm4di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13436; /* *pred_maccrvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern720 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13423; /* *pred_maddrvvm2di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13437; /* *pred_maccrvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern720 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13424; /* *pred_maddrvvm1di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13438; /* *pred_maccrvvm1di_extended_scalar */

            case E_V1DImode:
              if (pattern720 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return 13425; /* *pred_maddv1di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13439; /* *pred_maccv1di_extended_scalar */

            case E_V2DImode:
              if (pattern720 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return 13426; /* *pred_maddv2di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13440; /* *pred_maccv2di_extended_scalar */

            case E_V4DImode:
              if (pattern720 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return 13427; /* *pred_maddv4di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13441; /* *pred_maccv4di_extended_scalar */

            case E_V8DImode:
              if (pattern720 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return 13428; /* *pred_maddv8di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13442; /* *pred_maccv8di_extended_scalar */

            case E_V16DImode:
              if (pattern720 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return 13429; /* *pred_maddv16di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13443; /* *pred_maccv16di_extended_scalar */

            case E_V32DImode:
              if (pattern720 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return 13430; /* *pred_maddv32di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13444; /* *pred_maccv32di_extended_scalar */

            case E_V64DImode:
              if (pattern720 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return 13431; /* *pred_maddv64di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13445; /* *pred_maccv64di_extended_scalar */

            case E_V128DImode:
              if (pattern720 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return 13432; /* *pred_maddv128di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13446; /* *pred_maccv128di_extended_scalar */

            case E_V256DImode:
              if (pattern720 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return 13433; /* *pred_maddv256di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13447; /* *pred_maccv256di_extended_scalar */

            case E_V512DImode:
              if (pattern720 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return 13434; /* *pred_maddv512di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5562 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13448; /* *pred_maccv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      x15 = XEXP (x2, 2);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          return recog_747 (x1, insn, pnum_clobbers);

        case VEC_DUPLICATE:
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          x11 = XEXP (x4, 1);
          switch (GET_CODE (x11))
            {
            case SIGN_EXTEND:
              switch (pattern705 (x2))
                {
                case 0:
                  if (!
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13913; /* pred_widen_mul_plussrvvm8hi_scalar */

                case 1:
                  if (!
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13915; /* pred_widen_mul_plussrvvm4hi_scalar */

                case 2:
                  if (!
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13917; /* pred_widen_mul_plussrvvm2hi_scalar */

                case 3:
                  if (!
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13919; /* pred_widen_mul_plussrvvm1hi_scalar */

                case 4:
                  if (!
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13921; /* pred_widen_mul_plussrvvmf2hi_scalar */

                case 5:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 13923; /* pred_widen_mul_plussrvvmf4hi_scalar */

                case 6:
                  if (!
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13925; /* pred_widen_mul_plussrvvm8si_scalar */

                case 7:
                  if (!
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13927; /* pred_widen_mul_plussrvvm4si_scalar */

                case 8:
                  if (!
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13929; /* pred_widen_mul_plussrvvm2si_scalar */

                case 9:
                  if (!
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13931; /* pred_widen_mul_plussrvvm1si_scalar */

                case 10:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 13933; /* pred_widen_mul_plussrvvmf2si_scalar */

                case 11:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13935; /* pred_widen_mul_plussrvvm8di_scalar */

                case 12:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13937; /* pred_widen_mul_plussrvvm4di_scalar */

                case 13:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13939; /* pred_widen_mul_plussrvvm2di_scalar */

                case 14:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13941; /* pred_widen_mul_plussrvvm1di_scalar */

                case 15:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                    return -1;
                  return 13943; /* pred_widen_mul_plussv1hi_scalar */

                case 16:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                    return -1;
                  return 13945; /* pred_widen_mul_plussv2hi_scalar */

                case 17:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                    return -1;
                  return 13947; /* pred_widen_mul_plussv4hi_scalar */

                case 18:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                    return -1;
                  return 13949; /* pred_widen_mul_plussv8hi_scalar */

                case 19:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                    return -1;
                  return 13951; /* pred_widen_mul_plussv16hi_scalar */

                case 20:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13953; /* pred_widen_mul_plussv32hi_scalar */

                case 21:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13955; /* pred_widen_mul_plussv64hi_scalar */

                case 22:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13957; /* pred_widen_mul_plussv128hi_scalar */

                case 23:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 13959; /* pred_widen_mul_plussv256hi_scalar */

                case 24:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 13961; /* pred_widen_mul_plussv512hi_scalar */

                case 25:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 13963; /* pred_widen_mul_plussv1024hi_scalar */

                case 26:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 13965; /* pred_widen_mul_plussv2048hi_scalar */

                case 27:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                    return -1;
                  return 13967; /* pred_widen_mul_plussv1si_scalar */

                case 28:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                    return -1;
                  return 13969; /* pred_widen_mul_plussv2si_scalar */

                case 29:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                    return -1;
                  return 13971; /* pred_widen_mul_plussv4si_scalar */

                case 30:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                    return -1;
                  return 13973; /* pred_widen_mul_plussv8si_scalar */

                case 31:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13975; /* pred_widen_mul_plussv16si_scalar */

                case 32:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13977; /* pred_widen_mul_plussv32si_scalar */

                case 33:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13979; /* pred_widen_mul_plussv64si_scalar */

                case 34:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 13981; /* pred_widen_mul_plussv128si_scalar */

                case 35:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 13983; /* pred_widen_mul_plussv256si_scalar */

                case 36:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 13985; /* pred_widen_mul_plussv512si_scalar */

                case 37:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 13987; /* pred_widen_mul_plussv1024si_scalar */

                case 38:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13989; /* pred_widen_mul_plussv1di_scalar */

                case 39:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13991; /* pred_widen_mul_plussv2di_scalar */

                case 40:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13993; /* pred_widen_mul_plussv4di_scalar */

                case 41:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13995; /* pred_widen_mul_plussv8di_scalar */

                case 42:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13997; /* pred_widen_mul_plussv16di_scalar */

                case 43:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13999; /* pred_widen_mul_plussv32di_scalar */

                case 44:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14001; /* pred_widen_mul_plussv64di_scalar */

                case 45:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14003; /* pred_widen_mul_plussv128di_scalar */

                case 46:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14005; /* pred_widen_mul_plussv256di_scalar */

                case 47:
                  if (!(
#line 5909 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14007; /* pred_widen_mul_plussv512di_scalar */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern705 (x2))
                {
                case 0:
                  if (!
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14057; /* pred_widen_mul_plussurvvm8hi_scalar */

                case 1:
                  if (!
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14058; /* pred_widen_mul_plussurvvm4hi_scalar */

                case 2:
                  if (!
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14059; /* pred_widen_mul_plussurvvm2hi_scalar */

                case 3:
                  if (!
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14060; /* pred_widen_mul_plussurvvm1hi_scalar */

                case 4:
                  if (!
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14061; /* pred_widen_mul_plussurvvmf2hi_scalar */

                case 5:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 14062; /* pred_widen_mul_plussurvvmf4hi_scalar */

                case 6:
                  if (!
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14063; /* pred_widen_mul_plussurvvm8si_scalar */

                case 7:
                  if (!
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14064; /* pred_widen_mul_plussurvvm4si_scalar */

                case 8:
                  if (!
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14065; /* pred_widen_mul_plussurvvm2si_scalar */

                case 9:
                  if (!
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14066; /* pred_widen_mul_plussurvvm1si_scalar */

                case 10:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 14067; /* pred_widen_mul_plussurvvmf2si_scalar */

                case 11:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14068; /* pred_widen_mul_plussurvvm8di_scalar */

                case 12:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14069; /* pred_widen_mul_plussurvvm4di_scalar */

                case 13:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14070; /* pred_widen_mul_plussurvvm2di_scalar */

                case 14:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14071; /* pred_widen_mul_plussurvvm1di_scalar */

                case 15:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                    return -1;
                  return 14072; /* pred_widen_mul_plussuv1hi_scalar */

                case 16:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                    return -1;
                  return 14073; /* pred_widen_mul_plussuv2hi_scalar */

                case 17:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                    return -1;
                  return 14074; /* pred_widen_mul_plussuv4hi_scalar */

                case 18:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                    return -1;
                  return 14075; /* pred_widen_mul_plussuv8hi_scalar */

                case 19:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                    return -1;
                  return 14076; /* pred_widen_mul_plussuv16hi_scalar */

                case 20:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14077; /* pred_widen_mul_plussuv32hi_scalar */

                case 21:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14078; /* pred_widen_mul_plussuv64hi_scalar */

                case 22:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14079; /* pred_widen_mul_plussuv128hi_scalar */

                case 23:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14080; /* pred_widen_mul_plussuv256hi_scalar */

                case 24:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14081; /* pred_widen_mul_plussuv512hi_scalar */

                case 25:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14082; /* pred_widen_mul_plussuv1024hi_scalar */

                case 26:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14083; /* pred_widen_mul_plussuv2048hi_scalar */

                case 27:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                    return -1;
                  return 14084; /* pred_widen_mul_plussuv1si_scalar */

                case 28:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                    return -1;
                  return 14085; /* pred_widen_mul_plussuv2si_scalar */

                case 29:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                    return -1;
                  return 14086; /* pred_widen_mul_plussuv4si_scalar */

                case 30:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                    return -1;
                  return 14087; /* pred_widen_mul_plussuv8si_scalar */

                case 31:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14088; /* pred_widen_mul_plussuv16si_scalar */

                case 32:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14089; /* pred_widen_mul_plussuv32si_scalar */

                case 33:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14090; /* pred_widen_mul_plussuv64si_scalar */

                case 34:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14091; /* pred_widen_mul_plussuv128si_scalar */

                case 35:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14092; /* pred_widen_mul_plussuv256si_scalar */

                case 36:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14093; /* pred_widen_mul_plussuv512si_scalar */

                case 37:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14094; /* pred_widen_mul_plussuv1024si_scalar */

                case 38:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14095; /* pred_widen_mul_plussuv1di_scalar */

                case 39:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14096; /* pred_widen_mul_plussuv2di_scalar */

                case 40:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14097; /* pred_widen_mul_plussuv4di_scalar */

                case 41:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14098; /* pred_widen_mul_plussuv8di_scalar */

                case 42:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14099; /* pred_widen_mul_plussuv16di_scalar */

                case 43:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14100; /* pred_widen_mul_plussuv32di_scalar */

                case 44:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14101; /* pred_widen_mul_plussuv64di_scalar */

                case 45:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14102; /* pred_widen_mul_plussuv128di_scalar */

                case 46:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14103; /* pred_widen_mul_plussuv256di_scalar */

                case 47:
                  if (!(
#line 5958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14104; /* pred_widen_mul_plussuv512di_scalar */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_749 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_769 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V64SImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13502; /* *pred_minus_mulv64si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13570; /* *pred_nmsubv64si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13638; /* *pred_nmsacv64si */
}

 int
recog_772 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V8SImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 13499; /* *pred_minus_mulv8si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V8SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V8SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 13567; /* *pred_nmsubv8si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 13635; /* *pred_nmsacv8si */
}

 int
recog_773 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V4SImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13498; /* *pred_minus_mulv4si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13566; /* *pred_nmsubv4si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13634; /* *pred_nmsacv4si */
}

 int
recog_779 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V256HImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13492; /* *pred_minus_mulv256hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13560; /* *pred_nmsubv256hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13628; /* *pred_nmsacv256hi */
}

 int
recog_785 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V4HImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13486; /* *pred_minus_mulv4hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13554; /* *pred_nmsubv4hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 13622; /* *pred_nmsacv4hi */
}

 int
recog_791 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V512QImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 13480; /* *pred_minus_mulv512qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V512QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V512QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return 13548; /* *pred_nmsubv512qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13616; /* *pred_nmsacv512qi */
}

 int
recog_799 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V2QImode) == 0
      && (
#line 5613 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 13472; /* *pred_minus_mulv2qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return 13540; /* *pred_nmsubv2qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
    return -1;
  return 13608; /* *pred_nmsacv2qi */
}

 int
recog_807 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13717; /* *pred_nmsubv64di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13785; /* *pred_nmsacv64di_scalar */
}

 int
recog_815 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13709; /* *pred_nmsubv512si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13777; /* *pred_nmsacv512si_scalar */
}

 int
recog_823 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13701; /* *pred_nmsubv2si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13769; /* *pred_nmsacv2si_scalar */
}

 int
recog_831 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return 13693; /* *pred_nmsubv32hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13761; /* *pred_nmsacv32hi_scalar */
}

 int
recog_840 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern707 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32657; /* pred_vandnrvvm8qi_scalar */

        case E_RVVM4QImode:
          if (pattern707 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32658; /* pred_vandnrvvm4qi_scalar */

        case E_RVVM2QImode:
          if (pattern707 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32659; /* pred_vandnrvvm2qi_scalar */

        case E_RVVM1QImode:
          if (pattern707 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32660; /* pred_vandnrvvm1qi_scalar */

        case E_RVVMF2QImode:
          if (pattern707 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32661; /* pred_vandnrvvmf2qi_scalar */

        case E_RVVMF4QImode:
          if (pattern707 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32662; /* pred_vandnrvvmf4qi_scalar */

        case E_RVVMF8QImode:
          if (pattern707 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 724 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32663; /* pred_vandnrvvmf8qi_scalar */

        case E_RVVM8HImode:
          if (pattern707 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32664; /* pred_vandnrvvm8hi_scalar */

        case E_RVVM4HImode:
          if (pattern707 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32665; /* pred_vandnrvvm4hi_scalar */

        case E_RVVM2HImode:
          if (pattern707 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32666; /* pred_vandnrvvm2hi_scalar */

        case E_RVVM1HImode:
          if (pattern707 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32667; /* pred_vandnrvvm1hi_scalar */

        case E_RVVMF2HImode:
          if (pattern707 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32668; /* pred_vandnrvvmf2hi_scalar */

        case E_RVVMF4HImode:
          if (pattern707 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 726 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32669; /* pred_vandnrvvmf4hi_scalar */

        case E_RVVM8SImode:
          if (pattern707 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32670; /* pred_vandnrvvm8si_scalar */

        case E_RVVM4SImode:
          if (pattern707 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32671; /* pred_vandnrvvm4si_scalar */

        case E_RVVM2SImode:
          if (pattern707 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32672; /* pred_vandnrvvm2si_scalar */

        case E_RVVM1SImode:
          if (pattern707 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0
              || !
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB))
            return -1;
          return 32673; /* pred_vandnrvvm1si_scalar */

        case E_RVVMF2SImode:
          if (pattern707 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 728 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32674; /* pred_vandnrvvmf2si_scalar */

        case E_V1QImode:
          if (pattern707 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 730 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 32675; /* pred_vandnv1qi_scalar */

        case E_V2QImode:
          if (pattern707 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 731 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 32676; /* pred_vandnv2qi_scalar */

        case E_V4QImode:
          if (pattern707 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 732 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 32677; /* pred_vandnv4qi_scalar */

        case E_V8QImode:
          if (pattern707 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 733 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 32678; /* pred_vandnv8qi_scalar */

        case E_V16QImode:
          if (pattern707 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 734 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 32679; /* pred_vandnv16qi_scalar */

        case E_V32QImode:
          if (pattern707 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 735 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 32680; /* pred_vandnv32qi_scalar */

        case E_V64QImode:
          if (pattern707 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 736 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32681; /* pred_vandnv64qi_scalar */

        case E_V128QImode:
          if (pattern707 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 737 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32682; /* pred_vandnv128qi_scalar */

        case E_V256QImode:
          if (pattern707 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 738 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32683; /* pred_vandnv256qi_scalar */

        case E_V512QImode:
          if (pattern707 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 739 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32684; /* pred_vandnv512qi_scalar */

        case E_V1024QImode:
          if (pattern707 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 740 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32685; /* pred_vandnv1024qi_scalar */

        case E_V2048QImode:
          if (pattern707 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 741 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32686; /* pred_vandnv2048qi_scalar */

        case E_V4096QImode:
          if (pattern707 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 742 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32687; /* pred_vandnv4096qi_scalar */

        case E_V1HImode:
          if (pattern707 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 743 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 32688; /* pred_vandnv1hi_scalar */

        case E_V2HImode:
          if (pattern707 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 744 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 32689; /* pred_vandnv2hi_scalar */

        case E_V4HImode:
          if (pattern707 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 745 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 32690; /* pred_vandnv4hi_scalar */

        case E_V8HImode:
          if (pattern707 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 32691; /* pred_vandnv8hi_scalar */

        case E_V16HImode:
          if (pattern707 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 747 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 32692; /* pred_vandnv16hi_scalar */

        case E_V32HImode:
          if (pattern707 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 748 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32693; /* pred_vandnv32hi_scalar */

        case E_V64HImode:
          if (pattern707 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 749 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32694; /* pred_vandnv64hi_scalar */

        case E_V128HImode:
          if (pattern707 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 750 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32695; /* pred_vandnv128hi_scalar */

        case E_V256HImode:
          if (pattern707 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 751 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32696; /* pred_vandnv256hi_scalar */

        case E_V512HImode:
          if (pattern707 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 752 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32697; /* pred_vandnv512hi_scalar */

        case E_V1024HImode:
          if (pattern707 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 753 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32698; /* pred_vandnv1024hi_scalar */

        case E_V2048HImode:
          if (pattern707 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 754 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32699; /* pred_vandnv2048hi_scalar */

        case E_V1SImode:
          if (pattern707 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 755 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 32700; /* pred_vandnv1si_scalar */

        case E_V2SImode:
          if (pattern707 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 756 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 32701; /* pred_vandnv2si_scalar */

        case E_V4SImode:
          if (pattern707 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 757 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 32702; /* pred_vandnv4si_scalar */

        case E_V8SImode:
          if (pattern707 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 32703; /* pred_vandnv8si_scalar */

        case E_V16SImode:
          if (pattern707 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 759 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32704; /* pred_vandnv16si_scalar */

        case E_V32SImode:
          if (pattern707 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 760 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32705; /* pred_vandnv32si_scalar */

        case E_V64SImode:
          if (pattern707 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 761 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32706; /* pred_vandnv64si_scalar */

        case E_V128SImode:
          if (pattern707 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 762 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32707; /* pred_vandnv128si_scalar */

        case E_V256SImode:
          if (pattern707 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 763 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32708; /* pred_vandnv256si_scalar */

        case E_V512SImode:
          if (pattern707 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 764 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32709; /* pred_vandnv512si_scalar */

        case E_V1024SImode:
          if (pattern707 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0
              || !(
#line 139 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 765 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32710; /* pred_vandnv1024si_scalar */

        case E_RVVM8DImode:
          if (pattern708 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32711; /* *pred_vandnrvvm8di_scalar */

        case E_RVVM4DImode:
          if (pattern708 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32712; /* *pred_vandnrvvm4di_scalar */

        case E_RVVM2DImode:
          if (pattern708 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32713; /* *pred_vandnrvvm2di_scalar */

        case E_RVVM1DImode:
          if (pattern708 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32714; /* *pred_vandnrvvm1di_scalar */

        case E_V1DImode:
          if (pattern708 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 777 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32715; /* *pred_vandnv1di_scalar */

        case E_V2DImode:
          if (pattern708 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 778 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32716; /* *pred_vandnv2di_scalar */

        case E_V4DImode:
          if (pattern708 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 779 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32717; /* *pred_vandnv4di_scalar */

        case E_V8DImode:
          if (pattern708 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32718; /* *pred_vandnv8di_scalar */

        case E_V16DImode:
          if (pattern708 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32719; /* *pred_vandnv16di_scalar */

        case E_V32DImode:
          if (pattern708 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 782 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32720; /* *pred_vandnv32di_scalar */

        case E_V64DImode:
          if (pattern708 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 783 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32721; /* *pred_vandnv64di_scalar */

        case E_V128DImode:
          if (pattern708 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 784 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32722; /* *pred_vandnv128di_scalar */

        case E_V256DImode:
          if (pattern708 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 785 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32723; /* *pred_vandnv256di_scalar */

        case E_V512DImode:
          if (pattern708 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 786 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32724; /* *pred_vandnv512di_scalar */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8DImode:
          if (pattern721 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32725; /* *pred_vandnrvvm8di_extended_scalar */

        case E_RVVM4DImode:
          if (pattern721 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32726; /* *pred_vandnrvvm4di_extended_scalar */

        case E_RVVM2DImode:
          if (pattern721 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32727; /* *pred_vandnrvvm2di_extended_scalar */

        case E_RVVM1DImode:
          if (pattern721 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32728; /* *pred_vandnrvvm1di_extended_scalar */

        case E_V1DImode:
          if (pattern721 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 777 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32729; /* *pred_vandnv1di_extended_scalar */

        case E_V2DImode:
          if (pattern721 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 778 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32730; /* *pred_vandnv2di_extended_scalar */

        case E_V4DImode:
          if (pattern721 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 779 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 32731; /* *pred_vandnv4di_extended_scalar */

        case E_V8DImode:
          if (pattern721 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32732; /* *pred_vandnv8di_extended_scalar */

        case E_V16DImode:
          if (pattern721 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32733; /* *pred_vandnv16di_extended_scalar */

        case E_V32DImode:
          if (pattern721 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 782 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32734; /* *pred_vandnv32di_extended_scalar */

        case E_V64DImode:
          if (pattern721 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 783 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32735; /* *pred_vandnv64di_extended_scalar */

        case E_V128DImode:
          if (pattern721 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 784 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32736; /* *pred_vandnv128di_extended_scalar */

        case E_V256DImode:
          if (pattern721 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 785 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32737; /* *pred_vandnv256di_extended_scalar */

        case E_V512DImode:
          if (pattern721 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB || TARGET_ZVKB) && 
#line 786 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32738; /* *pred_vandnv512di_extended_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_861 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V2SImode)
      && (
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 6318; /* pred_ashlv2si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 6797; /* pred_ashlv2si_scalar */
}

 int
recog_866 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V256HImode)
      && (
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 6233; /* pred_ashlv256hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 6782; /* pred_ashlv256hi_scalar */
}

 int
recog_871 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern672 (x2, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V512SImode)
      && (
#line 301 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 32896; /* pred_vwsllv512di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 32944; /* pred_vwsllv512di_scalar */
}

 int
recog_876 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern672 (x2, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16SImode)
      && (
#line 301 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 32891; /* pred_vwsllv16di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 32939; /* pred_vwsllv16di_scalar */
}

 int
recog_881 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9305; /* pred_dual_widen_mulsrvvm8hi */

        case 1:
          if (!
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9311; /* pred_dual_widen_mulsrvvm4hi */

        case 2:
          if (!
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9317; /* pred_dual_widen_mulsrvvm2hi */

        case 3:
          if (!
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9323; /* pred_dual_widen_mulsrvvm1hi */

        case 4:
          if (!
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9329; /* pred_dual_widen_mulsrvvmf2hi */

        case 5:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9335; /* pred_dual_widen_mulsrvvmf4hi */

        case 6:
          if (!
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9341; /* pred_dual_widen_mulsrvvm8si */

        case 7:
          if (!
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9347; /* pred_dual_widen_mulsrvvm4si */

        case 8:
          if (!
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9353; /* pred_dual_widen_mulsrvvm2si */

        case 9:
          if (!
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9359; /* pred_dual_widen_mulsrvvm1si */

        case 10:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9365; /* pred_dual_widen_mulsrvvmf2si */

        case 11:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9371; /* pred_dual_widen_mulsrvvm8di */

        case 12:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9377; /* pred_dual_widen_mulsrvvm4di */

        case 13:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9383; /* pred_dual_widen_mulsrvvm2di */

        case 14:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9389; /* pred_dual_widen_mulsrvvm1di */

        case 15:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9395; /* pred_dual_widen_mulsv1hi */

        case 16:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9401; /* pred_dual_widen_mulsv2hi */

        case 17:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9407; /* pred_dual_widen_mulsv4hi */

        case 18:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9413; /* pred_dual_widen_mulsv8hi */

        case 19:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9419; /* pred_dual_widen_mulsv16hi */

        case 20:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9425; /* pred_dual_widen_mulsv32hi */

        case 21:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9431; /* pred_dual_widen_mulsv64hi */

        case 22:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9437; /* pred_dual_widen_mulsv128hi */

        case 23:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9443; /* pred_dual_widen_mulsv256hi */

        case 24:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9449; /* pred_dual_widen_mulsv512hi */

        case 25:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9455; /* pred_dual_widen_mulsv1024hi */

        case 26:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9461; /* pred_dual_widen_mulsv2048hi */

        case 27:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9467; /* pred_dual_widen_mulsv1si */

        case 28:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9473; /* pred_dual_widen_mulsv2si */

        case 29:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9479; /* pred_dual_widen_mulsv4si */

        case 30:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9485; /* pred_dual_widen_mulsv8si */

        case 31:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9491; /* pred_dual_widen_mulsv16si */

        case 32:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9497; /* pred_dual_widen_mulsv32si */

        case 33:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9503; /* pred_dual_widen_mulsv64si */

        case 34:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9509; /* pred_dual_widen_mulsv128si */

        case 35:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9515; /* pred_dual_widen_mulsv256si */

        case 36:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9521; /* pred_dual_widen_mulsv512si */

        case 37:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9527; /* pred_dual_widen_mulsv1024si */

        case 38:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9533; /* pred_dual_widen_mulsv1di */

        case 39:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9539; /* pred_dual_widen_mulsv2di */

        case 40:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9545; /* pred_dual_widen_mulsv4di */

        case 41:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9551; /* pred_dual_widen_mulsv8di */

        case 42:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9557; /* pred_dual_widen_mulsv16di */

        case 43:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9563; /* pred_dual_widen_mulsv32di */

        case 44:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9569; /* pred_dual_widen_mulsv64di */

        case 45:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9575; /* pred_dual_widen_mulsv128di */

        case 46:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9581; /* pred_dual_widen_mulsv256di */

        case 47:
          if (!(
#line 4005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9587; /* pred_dual_widen_mulsv512di */

        case 48:
          if (!
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9593; /* pred_dual_widen_mulsrvvm8hi_scalar */

        case 49:
          if (!
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9599; /* pred_dual_widen_mulsrvvm4hi_scalar */

        case 50:
          if (!
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9605; /* pred_dual_widen_mulsrvvm2hi_scalar */

        case 51:
          if (!
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9611; /* pred_dual_widen_mulsrvvm1hi_scalar */

        case 52:
          if (!
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9617; /* pred_dual_widen_mulsrvvmf2hi_scalar */

        case 53:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9623; /* pred_dual_widen_mulsrvvmf4hi_scalar */

        case 54:
          if (!
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9629; /* pred_dual_widen_mulsrvvm8si_scalar */

        case 55:
          if (!
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9635; /* pred_dual_widen_mulsrvvm4si_scalar */

        case 56:
          if (!
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9641; /* pred_dual_widen_mulsrvvm2si_scalar */

        case 57:
          if (!
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9647; /* pred_dual_widen_mulsrvvm1si_scalar */

        case 58:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9653; /* pred_dual_widen_mulsrvvmf2si_scalar */

        case 59:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9659; /* pred_dual_widen_mulsrvvm8di_scalar */

        case 60:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9665; /* pred_dual_widen_mulsrvvm4di_scalar */

        case 61:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9671; /* pred_dual_widen_mulsrvvm2di_scalar */

        case 62:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9677; /* pred_dual_widen_mulsrvvm1di_scalar */

        case 63:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9683; /* pred_dual_widen_mulsv1hi_scalar */

        case 64:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9689; /* pred_dual_widen_mulsv2hi_scalar */

        case 65:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9695; /* pred_dual_widen_mulsv4hi_scalar */

        case 66:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9701; /* pred_dual_widen_mulsv8hi_scalar */

        case 67:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9707; /* pred_dual_widen_mulsv16hi_scalar */

        case 68:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9713; /* pred_dual_widen_mulsv32hi_scalar */

        case 69:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9719; /* pred_dual_widen_mulsv64hi_scalar */

        case 70:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9725; /* pred_dual_widen_mulsv128hi_scalar */

        case 71:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9731; /* pred_dual_widen_mulsv256hi_scalar */

        case 72:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9737; /* pred_dual_widen_mulsv512hi_scalar */

        case 73:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9743; /* pred_dual_widen_mulsv1024hi_scalar */

        case 74:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9749; /* pred_dual_widen_mulsv2048hi_scalar */

        case 75:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9755; /* pred_dual_widen_mulsv1si_scalar */

        case 76:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9761; /* pred_dual_widen_mulsv2si_scalar */

        case 77:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9767; /* pred_dual_widen_mulsv4si_scalar */

        case 78:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9773; /* pred_dual_widen_mulsv8si_scalar */

        case 79:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9779; /* pred_dual_widen_mulsv16si_scalar */

        case 80:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9785; /* pred_dual_widen_mulsv32si_scalar */

        case 81:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9791; /* pred_dual_widen_mulsv64si_scalar */

        case 82:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9797; /* pred_dual_widen_mulsv128si_scalar */

        case 83:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9803; /* pred_dual_widen_mulsv256si_scalar */

        case 84:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9809; /* pred_dual_widen_mulsv512si_scalar */

        case 85:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9815; /* pred_dual_widen_mulsv1024si_scalar */

        case 86:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9821; /* pred_dual_widen_mulsv1di_scalar */

        case 87:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9827; /* pred_dual_widen_mulsv2di_scalar */

        case 88:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9833; /* pred_dual_widen_mulsv4di_scalar */

        case 89:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9839; /* pred_dual_widen_mulsv8di_scalar */

        case 90:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9845; /* pred_dual_widen_mulsv16di_scalar */

        case 91:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9851; /* pred_dual_widen_mulsv32di_scalar */

        case 92:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9857; /* pred_dual_widen_mulsv64di_scalar */

        case 93:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9863; /* pred_dual_widen_mulsv128di_scalar */

        case 94:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9869; /* pred_dual_widen_mulsv256di_scalar */

        case 95:
          if (!(
#line 4028 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9875; /* pred_dual_widen_mulsv512di_scalar */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10453; /* pred_widen_mulsurvvm8hi */

        case 1:
          if (!
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10454; /* pred_widen_mulsurvvm4hi */

        case 2:
          if (!
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10455; /* pred_widen_mulsurvvm2hi */

        case 3:
          if (!
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10456; /* pred_widen_mulsurvvm1hi */

        case 4:
          if (!
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10457; /* pred_widen_mulsurvvmf2hi */

        case 5:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10458; /* pred_widen_mulsurvvmf4hi */

        case 6:
          if (!
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10459; /* pred_widen_mulsurvvm8si */

        case 7:
          if (!
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10460; /* pred_widen_mulsurvvm4si */

        case 8:
          if (!
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10461; /* pred_widen_mulsurvvm2si */

        case 9:
          if (!
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10462; /* pred_widen_mulsurvvm1si */

        case 10:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10463; /* pred_widen_mulsurvvmf2si */

        case 11:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10464; /* pred_widen_mulsurvvm8di */

        case 12:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10465; /* pred_widen_mulsurvvm4di */

        case 13:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10466; /* pred_widen_mulsurvvm2di */

        case 14:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10467; /* pred_widen_mulsurvvm1di */

        case 15:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10468; /* pred_widen_mulsuv1hi */

        case 16:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10469; /* pred_widen_mulsuv2hi */

        case 17:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10470; /* pred_widen_mulsuv4hi */

        case 18:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10471; /* pred_widen_mulsuv8hi */

        case 19:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10472; /* pred_widen_mulsuv16hi */

        case 20:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10473; /* pred_widen_mulsuv32hi */

        case 21:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10474; /* pred_widen_mulsuv64hi */

        case 22:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10475; /* pred_widen_mulsuv128hi */

        case 23:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10476; /* pred_widen_mulsuv256hi */

        case 24:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10477; /* pred_widen_mulsuv512hi */

        case 25:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10478; /* pred_widen_mulsuv1024hi */

        case 26:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10479; /* pred_widen_mulsuv2048hi */

        case 27:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10480; /* pred_widen_mulsuv1si */

        case 28:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10481; /* pred_widen_mulsuv2si */

        case 29:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10482; /* pred_widen_mulsuv4si */

        case 30:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10483; /* pred_widen_mulsuv8si */

        case 31:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10484; /* pred_widen_mulsuv16si */

        case 32:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10485; /* pred_widen_mulsuv32si */

        case 33:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10486; /* pred_widen_mulsuv64si */

        case 34:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10487; /* pred_widen_mulsuv128si */

        case 35:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10488; /* pred_widen_mulsuv256si */

        case 36:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10489; /* pred_widen_mulsuv512si */

        case 37:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10490; /* pred_widen_mulsuv1024si */

        case 38:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10491; /* pred_widen_mulsuv1di */

        case 39:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10492; /* pred_widen_mulsuv2di */

        case 40:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10493; /* pred_widen_mulsuv4di */

        case 41:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10494; /* pred_widen_mulsuv8di */

        case 42:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10495; /* pred_widen_mulsuv16di */

        case 43:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10496; /* pred_widen_mulsuv32di */

        case 44:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10497; /* pred_widen_mulsuv64di */

        case 45:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10498; /* pred_widen_mulsuv128di */

        case 46:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10499; /* pred_widen_mulsuv256di */

        case 47:
          if (!(
#line 4160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10500; /* pred_widen_mulsuv512di */

        case 48:
          if (!
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10501; /* pred_widen_mulsurvvm8hi_scalar */

        case 49:
          if (!
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10502; /* pred_widen_mulsurvvm4hi_scalar */

        case 50:
          if (!
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10503; /* pred_widen_mulsurvvm2hi_scalar */

        case 51:
          if (!
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10504; /* pred_widen_mulsurvvm1hi_scalar */

        case 52:
          if (!
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10505; /* pred_widen_mulsurvvmf2hi_scalar */

        case 53:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10506; /* pred_widen_mulsurvvmf4hi_scalar */

        case 54:
          if (!
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10507; /* pred_widen_mulsurvvm8si_scalar */

        case 55:
          if (!
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10508; /* pred_widen_mulsurvvm4si_scalar */

        case 56:
          if (!
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10509; /* pred_widen_mulsurvvm2si_scalar */

        case 57:
          if (!
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10510; /* pred_widen_mulsurvvm1si_scalar */

        case 58:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10511; /* pred_widen_mulsurvvmf2si_scalar */

        case 59:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10512; /* pred_widen_mulsurvvm8di_scalar */

        case 60:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10513; /* pred_widen_mulsurvvm4di_scalar */

        case 61:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10514; /* pred_widen_mulsurvvm2di_scalar */

        case 62:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10515; /* pred_widen_mulsurvvm1di_scalar */

        case 63:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10516; /* pred_widen_mulsuv1hi_scalar */

        case 64:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10517; /* pred_widen_mulsuv2hi_scalar */

        case 65:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10518; /* pred_widen_mulsuv4hi_scalar */

        case 66:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10519; /* pred_widen_mulsuv8hi_scalar */

        case 67:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10520; /* pred_widen_mulsuv16hi_scalar */

        case 68:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10521; /* pred_widen_mulsuv32hi_scalar */

        case 69:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10522; /* pred_widen_mulsuv64hi_scalar */

        case 70:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10523; /* pred_widen_mulsuv128hi_scalar */

        case 71:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10524; /* pred_widen_mulsuv256hi_scalar */

        case 72:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10525; /* pred_widen_mulsuv512hi_scalar */

        case 73:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10526; /* pred_widen_mulsuv1024hi_scalar */

        case 74:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10527; /* pred_widen_mulsuv2048hi_scalar */

        case 75:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10528; /* pred_widen_mulsuv1si_scalar */

        case 76:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10529; /* pred_widen_mulsuv2si_scalar */

        case 77:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10530; /* pred_widen_mulsuv4si_scalar */

        case 78:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10531; /* pred_widen_mulsuv8si_scalar */

        case 79:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10532; /* pred_widen_mulsuv16si_scalar */

        case 80:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10533; /* pred_widen_mulsuv32si_scalar */

        case 81:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10534; /* pred_widen_mulsuv64si_scalar */

        case 82:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10535; /* pred_widen_mulsuv128si_scalar */

        case 83:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10536; /* pred_widen_mulsuv256si_scalar */

        case 84:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10537; /* pred_widen_mulsuv512si_scalar */

        case 85:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10538; /* pred_widen_mulsuv1024si_scalar */

        case 86:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10539; /* pred_widen_mulsuv1di_scalar */

        case 87:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10540; /* pred_widen_mulsuv2di_scalar */

        case 88:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10541; /* pred_widen_mulsuv4di_scalar */

        case 89:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10542; /* pred_widen_mulsuv8di_scalar */

        case 90:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10543; /* pred_widen_mulsuv16di_scalar */

        case 91:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10544; /* pred_widen_mulsuv32di_scalar */

        case 92:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10545; /* pred_widen_mulsuv64di_scalar */

        case 93:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10546; /* pred_widen_mulsuv128di_scalar */

        case 94:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10547; /* pred_widen_mulsuv256di_scalar */

        case 95:
          if (!(
#line 4183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10548; /* pred_widen_mulsuv512di_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_895 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return recog_753 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      x12 = XEXP (x4, 0);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          switch (pattern489 (x2))
            {
            case 0:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6857; /* pred_addrvvm8qi_scalar */

            case 1:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6866; /* pred_addrvvm4qi_scalar */

            case 2:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6875; /* pred_addrvvm2qi_scalar */

            case 3:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6884; /* pred_addrvvm1qi_scalar */

            case 4:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6893; /* pred_addrvvmf2qi_scalar */

            case 5:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6902; /* pred_addrvvmf4qi_scalar */

            case 6:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6911; /* pred_addrvvmf8qi_scalar */

            case 7:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6920; /* pred_addrvvm8hi_scalar */

            case 8:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6929; /* pred_addrvvm4hi_scalar */

            case 9:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6938; /* pred_addrvvm2hi_scalar */

            case 10:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6947; /* pred_addrvvm1hi_scalar */

            case 11:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6956; /* pred_addrvvmf2hi_scalar */

            case 12:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6965; /* pred_addrvvmf4hi_scalar */

            case 13:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6974; /* pred_addrvvm8si_scalar */

            case 14:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6983; /* pred_addrvvm4si_scalar */

            case 15:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6992; /* pred_addrvvm2si_scalar */

            case 16:
              if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7001; /* pred_addrvvm1si_scalar */

            case 17:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 7010; /* pred_addrvvmf2si_scalar */

            case 18:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 7019; /* pred_addv1qi_scalar */

            case 19:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 7028; /* pred_addv2qi_scalar */

            case 20:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 7037; /* pred_addv4qi_scalar */

            case 21:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 7046; /* pred_addv8qi_scalar */

            case 22:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 7055; /* pred_addv16qi_scalar */

            case 23:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 7064; /* pred_addv32qi_scalar */

            case 24:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7073; /* pred_addv64qi_scalar */

            case 25:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7082; /* pred_addv128qi_scalar */

            case 26:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7091; /* pred_addv256qi_scalar */

            case 27:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7100; /* pred_addv512qi_scalar */

            case 28:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7109; /* pred_addv1024qi_scalar */

            case 29:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7118; /* pred_addv2048qi_scalar */

            case 30:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7127; /* pred_addv4096qi_scalar */

            case 31:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 7136; /* pred_addv1hi_scalar */

            case 32:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 7145; /* pred_addv2hi_scalar */

            case 33:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 7154; /* pred_addv4hi_scalar */

            case 34:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 7163; /* pred_addv8hi_scalar */

            case 35:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 7172; /* pred_addv16hi_scalar */

            case 36:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7181; /* pred_addv32hi_scalar */

            case 37:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7190; /* pred_addv64hi_scalar */

            case 38:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7199; /* pred_addv128hi_scalar */

            case 39:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7208; /* pred_addv256hi_scalar */

            case 40:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7217; /* pred_addv512hi_scalar */

            case 41:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7226; /* pred_addv1024hi_scalar */

            case 42:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7235; /* pred_addv2048hi_scalar */

            case 43:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 7244; /* pred_addv1si_scalar */

            case 44:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 7253; /* pred_addv2si_scalar */

            case 45:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 7262; /* pred_addv4si_scalar */

            case 46:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 7271; /* pred_addv8si_scalar */

            case 47:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7280; /* pred_addv16si_scalar */

            case 48:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7289; /* pred_addv32si_scalar */

            case 49:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7298; /* pred_addv64si_scalar */

            case 50:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7307; /* pred_addv128si_scalar */

            case 51:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7316; /* pred_addv256si_scalar */

            case 52:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7325; /* pred_addv512si_scalar */

            case 53:
              if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7334; /* pred_addv1024si_scalar */

            case 54:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7667; /* *pred_addrvvm8di_scalar */

            case 55:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7676; /* *pred_addrvvm4di_scalar */

            case 56:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7685; /* *pred_addrvvm2di_scalar */

            case 57:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7694; /* *pred_addrvvm1di_scalar */

            case 58:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7703; /* *pred_addv1di_scalar */

            case 59:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7712; /* *pred_addv2di_scalar */

            case 60:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7721; /* *pred_addv4di_scalar */

            case 61:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7730; /* *pred_addv8di_scalar */

            case 62:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7739; /* *pred_addv16di_scalar */

            case 63:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7748; /* *pred_addv32di_scalar */

            case 64:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7757; /* *pred_addv64di_scalar */

            case 65:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7766; /* *pred_addv128di_scalar */

            case 66:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7775; /* *pred_addv256di_scalar */

            case 67:
              if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7784; /* *pred_addv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          return recog_608 (x1, insn, pnum_clobbers);

        case ZERO_EXTEND:
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HImode:
              if (pattern690 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10262; /* pred_single_widen_addurvvm8hi_extended_scalar */

            case E_RVVM4HImode:
              if (pattern690 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10264; /* pred_single_widen_addurvvm4hi_extended_scalar */

            case E_RVVM2HImode:
              if (pattern690 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10266; /* pred_single_widen_addurvvm2hi_extended_scalar */

            case E_RVVM1HImode:
              if (pattern690 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10268; /* pred_single_widen_addurvvm1hi_extended_scalar */

            case E_RVVMF2HImode:
              if (pattern690 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10270; /* pred_single_widen_addurvvmf2hi_extended_scalar */

            case E_RVVMF4HImode:
              if (pattern690 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 10272; /* pred_single_widen_addurvvmf4hi_extended_scalar */

            case E_RVVM8SImode:
              if (pattern690 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10274; /* pred_single_widen_addurvvm8si_extended_scalar */

            case E_RVVM4SImode:
              if (pattern690 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10276; /* pred_single_widen_addurvvm4si_extended_scalar */

            case E_RVVM2SImode:
              if (pattern690 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10278; /* pred_single_widen_addurvvm2si_extended_scalar */

            case E_RVVM1SImode:
              if (pattern690 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10280; /* pred_single_widen_addurvvm1si_extended_scalar */

            case E_RVVMF2SImode:
              if (pattern690 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 10282; /* pred_single_widen_addurvvmf2si_extended_scalar */

            case E_RVVM8DImode:
              if (pattern690 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10284; /* pred_single_widen_addurvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern690 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10286; /* pred_single_widen_addurvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern690 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10288; /* pred_single_widen_addurvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern690 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10290; /* pred_single_widen_addurvvm1di_extended_scalar */

            case E_V1HImode:
              if (pattern690 (x2, 
E_V1HImode, 
E_V1BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 10292; /* pred_single_widen_adduv1hi_extended_scalar */

            case E_V2HImode:
              if (pattern690 (x2, 
E_V2HImode, 
E_V2BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 10294; /* pred_single_widen_adduv2hi_extended_scalar */

            case E_V4HImode:
              if (pattern690 (x2, 
E_V4HImode, 
E_V4BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 10296; /* pred_single_widen_adduv4hi_extended_scalar */

            case E_V8HImode:
              if (pattern690 (x2, 
E_V8HImode, 
E_V8BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 10298; /* pred_single_widen_adduv8hi_extended_scalar */

            case E_V16HImode:
              if (pattern690 (x2, 
E_V16HImode, 
E_V16BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 10300; /* pred_single_widen_adduv16hi_extended_scalar */

            case E_V32HImode:
              if (pattern690 (x2, 
E_V32HImode, 
E_V32BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10302; /* pred_single_widen_adduv32hi_extended_scalar */

            case E_V64HImode:
              if (pattern690 (x2, 
E_V64HImode, 
E_V64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10304; /* pred_single_widen_adduv64hi_extended_scalar */

            case E_V128HImode:
              if (pattern690 (x2, 
E_V128HImode, 
E_V128BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10306; /* pred_single_widen_adduv128hi_extended_scalar */

            case E_V256HImode:
              if (pattern690 (x2, 
E_V256HImode, 
E_V256BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10308; /* pred_single_widen_adduv256hi_extended_scalar */

            case E_V512HImode:
              if (pattern690 (x2, 
E_V512HImode, 
E_V512BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10310; /* pred_single_widen_adduv512hi_extended_scalar */

            case E_V1024HImode:
              if (pattern690 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10312; /* pred_single_widen_adduv1024hi_extended_scalar */

            case E_V2048HImode:
              if (pattern690 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10314; /* pred_single_widen_adduv2048hi_extended_scalar */

            case E_V1SImode:
              if (pattern690 (x2, 
E_V1SImode, 
E_V1BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 10316; /* pred_single_widen_adduv1si_extended_scalar */

            case E_V2SImode:
              if (pattern690 (x2, 
E_V2SImode, 
E_V2BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 10318; /* pred_single_widen_adduv2si_extended_scalar */

            case E_V4SImode:
              if (pattern690 (x2, 
E_V4SImode, 
E_V4BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 10320; /* pred_single_widen_adduv4si_extended_scalar */

            case E_V8SImode:
              if (pattern690 (x2, 
E_V8SImode, 
E_V8BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 10322; /* pred_single_widen_adduv8si_extended_scalar */

            case E_V16SImode:
              if (pattern690 (x2, 
E_V16SImode, 
E_V16BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10324; /* pred_single_widen_adduv16si_extended_scalar */

            case E_V32SImode:
              if (pattern690 (x2, 
E_V32SImode, 
E_V32BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10326; /* pred_single_widen_adduv32si_extended_scalar */

            case E_V64SImode:
              if (pattern690 (x2, 
E_V64SImode, 
E_V64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10328; /* pred_single_widen_adduv64si_extended_scalar */

            case E_V128SImode:
              if (pattern690 (x2, 
E_V128SImode, 
E_V128BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10330; /* pred_single_widen_adduv128si_extended_scalar */

            case E_V256SImode:
              if (pattern690 (x2, 
E_V256SImode, 
E_V256BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10332; /* pred_single_widen_adduv256si_extended_scalar */

            case E_V512SImode:
              if (pattern690 (x2, 
E_V512SImode, 
E_V512BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10334; /* pred_single_widen_adduv512si_extended_scalar */

            case E_V1024SImode:
              if (pattern690 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10336; /* pred_single_widen_adduv1024si_extended_scalar */

            case E_V1DImode:
              if (pattern690 (x2, 
E_V1DImode, 
E_V1BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10338; /* pred_single_widen_adduv1di_extended_scalar */

            case E_V2DImode:
              if (pattern690 (x2, 
E_V2DImode, 
E_V2BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10340; /* pred_single_widen_adduv2di_extended_scalar */

            case E_V4DImode:
              if (pattern690 (x2, 
E_V4DImode, 
E_V4BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10342; /* pred_single_widen_adduv4di_extended_scalar */

            case E_V8DImode:
              if (pattern690 (x2, 
E_V8DImode, 
E_V8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10344; /* pred_single_widen_adduv8di_extended_scalar */

            case E_V16DImode:
              if (pattern690 (x2, 
E_V16DImode, 
E_V16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10346; /* pred_single_widen_adduv16di_extended_scalar */

            case E_V32DImode:
              if (pattern690 (x2, 
E_V32DImode, 
E_V32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10348; /* pred_single_widen_adduv32di_extended_scalar */

            case E_V64DImode:
              if (pattern690 (x2, 
E_V64DImode, 
E_V64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10350; /* pred_single_widen_adduv64di_extended_scalar */

            case E_V128DImode:
              if (pattern690 (x2, 
E_V128DImode, 
E_V128BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10352; /* pred_single_widen_adduv128di_extended_scalar */

            case E_V256DImode:
              if (pattern690 (x2, 
E_V256DImode, 
E_V256BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10354; /* pred_single_widen_adduv256di_extended_scalar */

            case E_V512DImode:
              if (pattern690 (x2, 
E_V512DImode, 
E_V512BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10356; /* pred_single_widen_adduv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_751 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_750 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_752 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_904 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern499 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5506; /* pred_umaxrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5523; /* pred_umaxrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5540; /* pred_umaxrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5557; /* pred_umaxrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5574; /* pred_umaxrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5591; /* pred_umaxrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5608; /* pred_umaxrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5625; /* pred_umaxrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5642; /* pred_umaxrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5659; /* pred_umaxrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5676; /* pred_umaxrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5693; /* pred_umaxrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5710; /* pred_umaxrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5727; /* pred_umaxrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5744; /* pred_umaxrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5761; /* pred_umaxrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5778; /* pred_umaxrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5795; /* pred_umaxrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5812; /* pred_umaxrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5829; /* pred_umaxrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5846; /* pred_umaxrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5863; /* pred_umaxrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5880; /* pred_umaxv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5897; /* pred_umaxv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5914; /* pred_umaxv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5931; /* pred_umaxv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5948; /* pred_umaxv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5965; /* pred_umaxv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5982; /* pred_umaxv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5999; /* pred_umaxv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6016; /* pred_umaxv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6033; /* pred_umaxv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6050; /* pred_umaxv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6067; /* pred_umaxv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6084; /* pred_umaxv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6101; /* pred_umaxv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6118; /* pred_umaxv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6135; /* pred_umaxv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6152; /* pred_umaxv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6169; /* pred_umaxv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6186; /* pred_umaxv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6203; /* pred_umaxv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6220; /* pred_umaxv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6237; /* pred_umaxv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6254; /* pred_umaxv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6271; /* pred_umaxv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6288; /* pred_umaxv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6305; /* pred_umaxv1si */

    case 48:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6322; /* pred_umaxv2si */

    case 49:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6339; /* pred_umaxv4si */

    case 50:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6356; /* pred_umaxv8si */

    case 51:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6373; /* pred_umaxv16si */

    case 52:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6390; /* pred_umaxv32si */

    case 53:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6407; /* pred_umaxv64si */

    case 54:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6424; /* pred_umaxv128si */

    case 55:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6441; /* pred_umaxv256si */

    case 56:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6458; /* pred_umaxv512si */

    case 57:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6475; /* pred_umaxv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6492; /* pred_umaxv1di */

    case 59:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6509; /* pred_umaxv2di */

    case 60:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6526; /* pred_umaxv4di */

    case 61:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6543; /* pred_umaxv8di */

    case 62:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6560; /* pred_umaxv16di */

    case 63:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6577; /* pred_umaxv32di */

    case 64:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6594; /* pred_umaxv64di */

    case 65:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6611; /* pred_umaxv128di */

    case 66:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6628; /* pred_umaxv256di */

    case 67:
      if (!(
#line 2723 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6645; /* pred_umaxv512di */

    case 68:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6862; /* pred_umaxrvvm8qi_scalar */

    case 69:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6871; /* pred_umaxrvvm4qi_scalar */

    case 70:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6880; /* pred_umaxrvvm2qi_scalar */

    case 71:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6889; /* pred_umaxrvvm1qi_scalar */

    case 72:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6898; /* pred_umaxrvvmf2qi_scalar */

    case 73:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6907; /* pred_umaxrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6916; /* pred_umaxrvvmf8qi_scalar */

    case 75:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6925; /* pred_umaxrvvm8hi_scalar */

    case 76:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6934; /* pred_umaxrvvm4hi_scalar */

    case 77:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6943; /* pred_umaxrvvm2hi_scalar */

    case 78:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6952; /* pred_umaxrvvm1hi_scalar */

    case 79:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6961; /* pred_umaxrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6970; /* pred_umaxrvvmf4hi_scalar */

    case 81:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6979; /* pred_umaxrvvm8si_scalar */

    case 82:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6988; /* pred_umaxrvvm4si_scalar */

    case 83:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6997; /* pred_umaxrvvm2si_scalar */

    case 84:
      if (!
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7006; /* pred_umaxrvvm1si_scalar */

    case 85:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7015; /* pred_umaxrvvmf2si_scalar */

    case 86:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7024; /* pred_umaxv1qi_scalar */

    case 87:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7033; /* pred_umaxv2qi_scalar */

    case 88:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7042; /* pred_umaxv4qi_scalar */

    case 89:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7051; /* pred_umaxv8qi_scalar */

    case 90:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7060; /* pred_umaxv16qi_scalar */

    case 91:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7069; /* pred_umaxv32qi_scalar */

    case 92:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7078; /* pred_umaxv64qi_scalar */

    case 93:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7087; /* pred_umaxv128qi_scalar */

    case 94:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7096; /* pred_umaxv256qi_scalar */

    case 95:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7105; /* pred_umaxv512qi_scalar */

    case 96:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7114; /* pred_umaxv1024qi_scalar */

    case 97:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7123; /* pred_umaxv2048qi_scalar */

    case 98:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7132; /* pred_umaxv4096qi_scalar */

    case 99:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7141; /* pred_umaxv1hi_scalar */

    case 100:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7150; /* pred_umaxv2hi_scalar */

    case 101:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7159; /* pred_umaxv4hi_scalar */

    case 102:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7168; /* pred_umaxv8hi_scalar */

    case 103:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7177; /* pred_umaxv16hi_scalar */

    case 104:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7186; /* pred_umaxv32hi_scalar */

    case 105:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7195; /* pred_umaxv64hi_scalar */

    case 106:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7204; /* pred_umaxv128hi_scalar */

    case 107:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7213; /* pred_umaxv256hi_scalar */

    case 108:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7222; /* pred_umaxv512hi_scalar */

    case 109:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7231; /* pred_umaxv1024hi_scalar */

    case 110:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7240; /* pred_umaxv2048hi_scalar */

    case 111:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7249; /* pred_umaxv1si_scalar */

    case 112:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7258; /* pred_umaxv2si_scalar */

    case 113:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7267; /* pred_umaxv4si_scalar */

    case 114:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7276; /* pred_umaxv8si_scalar */

    case 115:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7285; /* pred_umaxv16si_scalar */

    case 116:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7294; /* pred_umaxv32si_scalar */

    case 117:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7303; /* pred_umaxv64si_scalar */

    case 118:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7312; /* pred_umaxv128si_scalar */

    case 119:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7321; /* pred_umaxv256si_scalar */

    case 120:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7330; /* pred_umaxv512si_scalar */

    case 121:
      if (!(
#line 2781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7339; /* pred_umaxv1024si_scalar */

    case 122:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7672; /* *pred_umaxrvvm8di_scalar */

    case 123:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7681; /* *pred_umaxrvvm4di_scalar */

    case 124:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7690; /* *pred_umaxrvvm2di_scalar */

    case 125:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7699; /* *pred_umaxrvvm1di_scalar */

    case 126:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7708; /* *pred_umaxv1di_scalar */

    case 127:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7717; /* *pred_umaxv2di_scalar */

    case 128:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7726; /* *pred_umaxv4di_scalar */

    case 129:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7735; /* *pred_umaxv8di_scalar */

    case 130:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7744; /* *pred_umaxv16di_scalar */

    case 131:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7753; /* *pred_umaxv32di_scalar */

    case 132:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7762; /* *pred_umaxv64di_scalar */

    case 133:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7771; /* *pred_umaxv128di_scalar */

    case 134:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7780; /* *pred_umaxv256di_scalar */

    case 135:
      if (!(
#line 2879 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7789; /* *pred_umaxv512di_scalar */

    case 136:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7798; /* *pred_umaxrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7807; /* *pred_umaxrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7816; /* *pred_umaxrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7825; /* *pred_umaxrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7834; /* *pred_umaxv1di_extended_scalar */

    case 141:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7843; /* *pred_umaxv2di_extended_scalar */

    case 142:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7852; /* *pred_umaxv4di_extended_scalar */

    case 143:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7861; /* *pred_umaxv8di_extended_scalar */

    case 144:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7870; /* *pred_umaxv16di_extended_scalar */

    case 145:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7879; /* *pred_umaxv32di_extended_scalar */

    case 146:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7888; /* *pred_umaxv64di_extended_scalar */

    case 147:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7897; /* *pred_umaxv128di_extended_scalar */

    case 148:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7906; /* *pred_umaxv256di_extended_scalar */

    case 149:
      if (!(
#line 2901 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7915; /* *pred_umaxv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_915 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      return recog_885 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_884 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[5] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[6] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[7] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4QImode:
          if (pattern504 (x2, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10837; /* pred_truncrvvm8hi */

        case E_RVVM2QImode:
          if (pattern504 (x2, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10838; /* pred_truncrvvm4hi */

        case E_RVVM1QImode:
          if (pattern504 (x2, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10839; /* pred_truncrvvm2hi */

        case E_RVVMF2QImode:
          if (pattern504 (x2, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10840; /* pred_truncrvvm1hi */

        case E_RVVMF4QImode:
          if (pattern504 (x2, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10841; /* pred_truncrvvmf2hi */

        case E_RVVMF8QImode:
          if (pattern504 (x2, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10842; /* pred_truncrvvmf4hi */

        case E_RVVM4HImode:
          if (pattern504 (x2, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10843; /* pred_truncrvvm8si */

        case E_RVVM2HImode:
          if (pattern504 (x2, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10844; /* pred_truncrvvm4si */

        case E_RVVM1HImode:
          if (pattern504 (x2, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10845; /* pred_truncrvvm2si */

        case E_RVVMF2HImode:
          if (pattern504 (x2, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10846; /* pred_truncrvvm1si */

        case E_RVVMF4HImode:
          if (pattern504 (x2, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10847; /* pred_truncrvvmf2si */

        case E_RVVM4SImode:
          if (pattern504 (x2, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10848; /* pred_truncrvvm8di */

        case E_RVVM2SImode:
          if (pattern504 (x2, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10849; /* pred_truncrvvm4di */

        case E_RVVM1SImode:
          if (pattern504 (x2, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10850; /* pred_truncrvvm2di */

        case E_RVVMF2SImode:
          if (pattern504 (x2, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10851; /* pred_truncrvvm1di */

        case E_V1QImode:
          if (pattern504 (x2, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10852; /* pred_truncv1hi */

        case E_V2QImode:
          if (pattern504 (x2, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10853; /* pred_truncv2hi */

        case E_V4QImode:
          if (pattern504 (x2, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10854; /* pred_truncv4hi */

        case E_V8QImode:
          if (pattern504 (x2, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10855; /* pred_truncv8hi */

        case E_V16QImode:
          if (pattern504 (x2, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10856; /* pred_truncv16hi */

        case E_V32QImode:
          if (pattern504 (x2, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10857; /* pred_truncv32hi */

        case E_V64QImode:
          if (pattern504 (x2, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10858; /* pred_truncv64hi */

        case E_V128QImode:
          if (pattern504 (x2, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10859; /* pred_truncv128hi */

        case E_V256QImode:
          if (pattern504 (x2, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10860; /* pred_truncv256hi */

        case E_V512QImode:
          if (pattern504 (x2, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10861; /* pred_truncv512hi */

        case E_V1024QImode:
          if (pattern504 (x2, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10862; /* pred_truncv1024hi */

        case E_V2048QImode:
          if (pattern504 (x2, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10863; /* pred_truncv2048hi */

        case E_V1HImode:
          if (pattern504 (x2, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10864; /* pred_truncv1si */

        case E_V2HImode:
          if (pattern504 (x2, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10865; /* pred_truncv2si */

        case E_V4HImode:
          if (pattern504 (x2, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10866; /* pred_truncv4si */

        case E_V8HImode:
          if (pattern504 (x2, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10867; /* pred_truncv8si */

        case E_V16HImode:
          if (pattern504 (x2, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10868; /* pred_truncv16si */

        case E_V32HImode:
          if (pattern504 (x2, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10869; /* pred_truncv32si */

        case E_V64HImode:
          if (pattern504 (x2, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10870; /* pred_truncv64si */

        case E_V128HImode:
          if (pattern504 (x2, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10871; /* pred_truncv128si */

        case E_V256HImode:
          if (pattern504 (x2, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10872; /* pred_truncv256si */

        case E_V512HImode:
          if (pattern504 (x2, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10873; /* pred_truncv512si */

        case E_V1024HImode:
          if (pattern504 (x2, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10874; /* pred_truncv1024si */

        case E_V1SImode:
          if (pattern504 (x2, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10875; /* pred_truncv1di */

        case E_V2SImode:
          if (pattern504 (x2, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10876; /* pred_truncv2di */

        case E_V4SImode:
          if (pattern504 (x2, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10877; /* pred_truncv4di */

        case E_V8SImode:
          if (pattern504 (x2, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10878; /* pred_truncv8di */

        case E_V16SImode:
          if (pattern504 (x2, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10879; /* pred_truncv16di */

        case E_V32SImode:
          if (pattern504 (x2, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10880; /* pred_truncv32di */

        case E_V64SImode:
          if (pattern504 (x2, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10881; /* pred_truncv64di */

        case E_V128SImode:
          if (pattern504 (x2, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10882; /* pred_truncv128di */

        case E_V256SImode:
          if (pattern504 (x2, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10883; /* pred_truncv256di */

        case E_V512SImode:
          if (pattern504 (x2, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 4290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10884; /* pred_truncv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_920 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return recog_886 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      switch (pattern605 (x2))
        {
        case 0:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11265; /* pred_sssubrvvm8qi_scalar */

        case 1:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11267; /* pred_sssubrvvm4qi_scalar */

        case 2:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11269; /* pred_sssubrvvm2qi_scalar */

        case 3:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11271; /* pred_sssubrvvm1qi_scalar */

        case 4:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11273; /* pred_sssubrvvmf2qi_scalar */

        case 5:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11275; /* pred_sssubrvvmf4qi_scalar */

        case 6:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11277; /* pred_sssubrvvmf8qi_scalar */

        case 7:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11279; /* pred_sssubrvvm8hi_scalar */

        case 8:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11281; /* pred_sssubrvvm4hi_scalar */

        case 9:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11283; /* pred_sssubrvvm2hi_scalar */

        case 10:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11285; /* pred_sssubrvvm1hi_scalar */

        case 11:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11287; /* pred_sssubrvvmf2hi_scalar */

        case 12:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11289; /* pred_sssubrvvmf4hi_scalar */

        case 13:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11291; /* pred_sssubrvvm8si_scalar */

        case 14:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11293; /* pred_sssubrvvm4si_scalar */

        case 15:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11295; /* pred_sssubrvvm2si_scalar */

        case 16:
          if (!
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 11297; /* pred_sssubrvvm1si_scalar */

        case 17:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 11299; /* pred_sssubrvvmf2si_scalar */

        case 18:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 11301; /* pred_sssubv1qi_scalar */

        case 19:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 11303; /* pred_sssubv2qi_scalar */

        case 20:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 11305; /* pred_sssubv4qi_scalar */

        case 21:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 11307; /* pred_sssubv8qi_scalar */

        case 22:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 11309; /* pred_sssubv16qi_scalar */

        case 23:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 11311; /* pred_sssubv32qi_scalar */

        case 24:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11313; /* pred_sssubv64qi_scalar */

        case 25:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11315; /* pred_sssubv128qi_scalar */

        case 26:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11317; /* pred_sssubv256qi_scalar */

        case 27:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11319; /* pred_sssubv512qi_scalar */

        case 28:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11321; /* pred_sssubv1024qi_scalar */

        case 29:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11323; /* pred_sssubv2048qi_scalar */

        case 30:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11325; /* pred_sssubv4096qi_scalar */

        case 31:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 11327; /* pred_sssubv1hi_scalar */

        case 32:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 11329; /* pred_sssubv2hi_scalar */

        case 33:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 11331; /* pred_sssubv4hi_scalar */

        case 34:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 11333; /* pred_sssubv8hi_scalar */

        case 35:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 11335; /* pred_sssubv16hi_scalar */

        case 36:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11337; /* pred_sssubv32hi_scalar */

        case 37:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11339; /* pred_sssubv64hi_scalar */

        case 38:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11341; /* pred_sssubv128hi_scalar */

        case 39:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11343; /* pred_sssubv256hi_scalar */

        case 40:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11345; /* pred_sssubv512hi_scalar */

        case 41:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11347; /* pred_sssubv1024hi_scalar */

        case 42:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11349; /* pred_sssubv2048hi_scalar */

        case 43:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 11351; /* pred_sssubv1si_scalar */

        case 44:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 11353; /* pred_sssubv2si_scalar */

        case 45:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 11355; /* pred_sssubv4si_scalar */

        case 46:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 11357; /* pred_sssubv8si_scalar */

        case 47:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 11359; /* pred_sssubv16si_scalar */

        case 48:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 11361; /* pred_sssubv32si_scalar */

        case 49:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 11363; /* pred_sssubv64si_scalar */

        case 50:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 11365; /* pred_sssubv128si_scalar */

        case 51:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 11367; /* pred_sssubv256si_scalar */

        case 52:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 11369; /* pred_sssubv512si_scalar */

        case 53:
          if (!(
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 11371; /* pred_sssubv1024si_scalar */

        case 54:
          if (!(
#line 4509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11389; /* *pred_sssubrvvm8di_scalar */

        case 55:
          if (!(
#line 4509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11391; /* *pred_sssubrvvm4di_scalar */

        case 56:
          if (!(
#line 4509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11393; /* *pred_sssubrvvm2di_scalar */

        case 57:
          if (!(
#line 4509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11395; /* *pred_sssubrvvm1di_scalar */

        case 58:
          if (!(
#line 4531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11397; /* *pred_sssubrvvm8di_extended_scalar */

        case 59:
          if (!(
#line 4531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11399; /* *pred_sssubrvvm4di_extended_scalar */

        case 60:
          if (!(
#line 4531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11401; /* *pred_sssubrvvm2di_extended_scalar */

        case 61:
          if (!(
#line 4531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 11403; /* *pred_sssubrvvm1di_extended_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_932 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern722 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11408; /* pred_asubrvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11884; /* pred_asubrvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11415; /* pred_asubrvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11889; /* pred_asubrvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11422; /* pred_asubrvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11894; /* pred_asubrvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11429; /* pred_asubrvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11899; /* pred_asubrvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11436; /* pred_asubrvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11919; /* pred_asubrvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11443; /* pred_asubrvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11924; /* pred_asubrvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11450; /* pred_asubrvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11929; /* pred_asubrvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11457; /* pred_asubrvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11934; /* pred_asubrvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11464; /* pred_asubrvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11949; /* pred_asubrvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11471; /* pred_asubrvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11954; /* pred_asubrvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11478; /* pred_asubrvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11959; /* pred_asubrvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11485; /* pred_asubrvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11964; /* pred_asubrvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11492; /* pred_asubrvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12198; /* *pred_asubrvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11499; /* pred_asubrvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12203; /* *pred_asubrvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11506; /* pred_asubrvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12208; /* *pred_asubrvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11513; /* pred_asubrvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12213; /* *pred_asubrvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11520; /* pred_asubrvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11904; /* pred_asubrvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11527; /* pred_asubrvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11909; /* pred_asubrvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11534; /* pred_asubrvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11914; /* pred_asubrvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11541; /* pred_asubrvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11939; /* pred_asubrvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11548; /* pred_asubrvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11944; /* pred_asubrvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11555; /* pred_asubrvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 11969; /* pred_asubrvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11562; /* pred_asubv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11974; /* pred_asubv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11569; /* pred_asubv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11979; /* pred_asubv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11576; /* pred_asubv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11984; /* pred_asubv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11583; /* pred_asubv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11989; /* pred_asubv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11590; /* pred_asubv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11994; /* pred_asubv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11597; /* pred_asubv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11999; /* pred_asubv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11604; /* pred_asubv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12004; /* pred_asubv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11611; /* pred_asubv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12009; /* pred_asubv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11618; /* pred_asubv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12014; /* pred_asubv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11625; /* pred_asubv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12019; /* pred_asubv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11632; /* pred_asubv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12024; /* pred_asubv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11639; /* pred_asubv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12029; /* pred_asubv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11646; /* pred_asubv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12034; /* pred_asubv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11653; /* pred_asubv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12039; /* pred_asubv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11660; /* pred_asubv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12044; /* pred_asubv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11667; /* pred_asubv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12049; /* pred_asubv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11674; /* pred_asubv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12054; /* pred_asubv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11681; /* pred_asubv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12059; /* pred_asubv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11688; /* pred_asubv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12064; /* pred_asubv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11695; /* pred_asubv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12069; /* pred_asubv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11702; /* pred_asubv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12074; /* pred_asubv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11709; /* pred_asubv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12079; /* pred_asubv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11716; /* pred_asubv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12084; /* pred_asubv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11723; /* pred_asubv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12089; /* pred_asubv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11730; /* pred_asubv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12094; /* pred_asubv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11737; /* pred_asubv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12099; /* pred_asubv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11744; /* pred_asubv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12104; /* pred_asubv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11751; /* pred_asubv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12109; /* pred_asubv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11758; /* pred_asubv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12114; /* pred_asubv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11765; /* pred_asubv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12119; /* pred_asubv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11772; /* pred_asubv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12124; /* pred_asubv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11779; /* pred_asubv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12129; /* pred_asubv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11786; /* pred_asubv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12134; /* pred_asubv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11793; /* pred_asubv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12139; /* pred_asubv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11800; /* pred_asubv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12144; /* pred_asubv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11807; /* pred_asubv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12149; /* pred_asubv1024si_scalar */

    case 58:
      if (!(
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11814; /* pred_asubv1di */

    case 59:
      if (!(
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11821; /* pred_asubv2di */

    case 60:
      if (!(
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11828; /* pred_asubv4di */

    case 61:
      if (!(
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11835; /* pred_asubv8di */

    case 62:
      if (!(
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11842; /* pred_asubv16di */

    case 63:
      if (!(
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11849; /* pred_asubv32di */

    case 64:
      if (!(
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11856; /* pred_asubv64di */

    case 65:
      if (!(
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11863; /* pred_asubv128di */

    case 66:
      if (!(
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11870; /* pred_asubv256di */

    case 67:
      if (!(
#line 4553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11877; /* pred_asubv512di */

    case 68:
      if (!(
#line 4679 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12218; /* *pred_asubrvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4679 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12223; /* *pred_asubrvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4679 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12228; /* *pred_asubrvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4679 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12233; /* *pred_asubrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_945 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15266; /* *pred_mul_addrvvm8sf_undef */
}

 int
recog_950 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15276; /* *pred_mul_addrvvm8df_undef */
}

 int
recog_955 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15286; /* *pred_mul_addv2hf_undef */
}

 int
recog_960 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15296; /* *pred_mul_addv64hf_undef */
}

 int
recog_965 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2048HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2048HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15306; /* *pred_mul_addv2048hf_undef */
}

 int
recog_970 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15316; /* *pred_mul_addv16sf_undef */
}

 int
recog_975 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15326; /* *pred_mul_addv512sf_undef */
}

 int
recog_980 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15336; /* *pred_mul_addv8df_undef */
}

 int
recog_985 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15346; /* *pred_mul_addv256df_undef */
}

 int
recog_990 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern731 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_HFmode)
          || !register_operand (operands[4], E_RVVM2HFmode)
          || !(
#line 7205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16765; /* pred_widen_mul_addrvvm4sf_scalar */

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_BFmode)
          || !register_operand (operands[4], E_RVVM2BFmode)
          || !(
#line 130 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 22 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33778; /* pred_widen_bf16_mul_rvvm4sf_scalar */

    default:
      return -1;
    }
}

 int
recog_995 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern731 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode)
          || !register_operand (operands[4], E_RVVM2HFmode)
          || !(
#line 7176 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16705; /* pred_widen_mul_addrvvm4sf */

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_RVVM2BFmode)
          || !register_operand (operands[4], E_RVVM2BFmode)
          || !(
#line 101 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 22 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33773; /* pred_widen_bf16_mul_rvvm4sf */

    default:
      return -1;
    }
}

 int
recog_1000 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_983 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15438; /* *pred_maddv64df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15534; /* *pred_maccv64df */
}

 int
recog_1005 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_978 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15428; /* *pred_maddv2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15524; /* *pred_maccv2df */
}

 int
recog_1010 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_973 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15418; /* *pred_maddv128sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15514; /* *pred_maccv128sf */
}

 int
recog_1015 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_968 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15408; /* *pred_maddv4sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15504; /* *pred_maccv4sf */
}

 int
recog_1020 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_963 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15398; /* *pred_maddv512hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15494; /* *pred_maccv512hf */
}

 int
recog_1025 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_958 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return 15388; /* *pred_maddv16hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15484; /* *pred_maccv16hf */
}

 int
recog_1030 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_953 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15378; /* *pred_maddrvvm1df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15474; /* *pred_maccrvvm1df */
}

 int
recog_1035 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_948 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15368; /* *pred_maddrvvm1sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15464; /* *pred_maccrvvm1sf */
}

 int
recog_1041 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_942 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15356; /* *pred_maddrvvm1hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15452; /* *pred_maccrvvm1hf */
}

 int
recog_1048 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15740; /* *pred_mul_neg_addrvvm1hf_undef */
}

 int
recog_1056 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15756; /* *pred_mul_neg_addrvvm8df_undef */
}

 int
recog_1064 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15772; /* *pred_mul_neg_addv16hf_undef */
}

 int
recog_1072 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15788; /* *pred_mul_neg_addv1sf_undef */
}

 int
recog_1079 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15802; /* *pred_mul_neg_addv128sf_undef */
}

 int
recog_1087 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15818; /* *pred_mul_neg_addv16df_undef */
}

 int
recog_1097 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1088 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15916; /* *pred_nmsubv32df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 16012; /* *pred_nmsacv32df */
}

 int
recog_1107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1078 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 15896; /* *pred_nmsubv64sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15992; /* *pred_nmsacv64sf */
}

 int
recog_1117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1068 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15876; /* *pred_nmsubv256hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15972; /* *pred_nmsacv256hf */
}

 int
recog_1127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1058 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15856; /* *pred_nmsubrvvm2df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15952; /* *pred_nmsacrvvm2df */
}

 int
recog_1137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1048 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15836; /* *pred_nmsubrvvm1hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15932; /* *pred_nmsacrvvm1hf */
}

 int
recog_1146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15259; /* *pred_mul_subrvvm2hf_undef */
}

 int
recog_1153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15273; /* *pred_mul_subrvvm1sf_undef */
}

 int
recog_1160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15287; /* *pred_mul_subv2hf_undef */
}

 int
recog_1167 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15301; /* *pred_mul_subv256hf_undef */
}

 int
recog_1174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15315; /* *pred_mul_subv8sf_undef */
}

 int
recog_1181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15329; /* *pred_mul_subv1024sf_undef */
}

 int
recog_1188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15343; /* *pred_mul_subv64df_undef */
}

 int
recog_1195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1188 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15439; /* *pred_msubv64df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15535; /* *pred_msacv64df */
}

 int
recog_1202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1181 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1024SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 15425; /* *pred_msubv1024sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15521; /* *pred_msacv1024sf */
}

 int
recog_1209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1174 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15411; /* *pred_msubv8sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15507; /* *pred_msacv8sf */
}

 int
recog_1216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1167 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15397; /* *pred_msubv256hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15493; /* *pred_msacv256hf */
}

 int
recog_1223 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1160 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15383; /* *pred_msubv2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15479; /* *pred_msacv2hf */
}

 int
recog_1231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1152 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15367; /* *pred_msubrvvm2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15463; /* *pred_msacrvvm2sf */
}

 int
recog_1237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1146 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15355; /* *pred_msubrvvm2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15451; /* *pred_msacrvvm2hf */
}

 int
recog_1244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15743; /* *pred_mul_neg_subrvvmf2hf_undef */
}

 int
recog_1251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15757; /* *pred_mul_neg_subrvvm8df_undef */
}

 int
recog_1257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15769; /* *pred_mul_neg_subv4hf_undef */
}

 int
recog_1264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512HFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15783; /* *pred_mul_neg_subv512hf_undef */
}

 int
recog_1271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15797; /* *pred_mul_neg_subv16sf_undef */
}

 int
recog_1278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15811; /* *pred_mul_neg_subv1df_undef */
}

 int
recog_1285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128DFmode)
      || !(
#line 6715 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15825; /* *pred_mul_neg_subv128df_undef */
}

 int
recog_1292 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1283 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15917; /* *pred_nmaddv32df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 16013; /* *pred_nmaccv32df */
}

 int
recog_1299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1276 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15903; /* *pred_nmaddv512sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15999; /* *pred_nmaccv512sf */
}

 int
recog_1306 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1269 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15889; /* *pred_nmaddv4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15985; /* *pred_nmaccv4sf */
}

 int
recog_1313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1262 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return 15875; /* *pred_nmaddv128hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15971; /* *pred_nmaccv128hf */
}

 int
recog_1320 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1255 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return 15861; /* *pred_nmaddv1hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15957; /* *pred_nmaccv1hf */
}

 int
recog_1330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1245 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return 15841; /* *pred_nmaddrvvmf4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15937; /* *pred_nmaccrvvmf4hf */
}

 int
recog_1338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XVECEXP (x5, 0, 5);
  operands[9] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  x12 = XEXP (x3, 1);
  switch (GET_CODE (x12))
    {
    case REG:
    case SUBREG:
      switch (pattern713 (x2))
        {
        case 0:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14500; /* pred_subrvvm8hf */

        case 1:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14504; /* pred_subrvvm4hf */

        case 2:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14508; /* pred_subrvvm2hf */

        case 3:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14512; /* pred_subrvvm1hf */

        case 4:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14516; /* pred_subrvvmf2hf */

        case 5:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14520; /* pred_subrvvmf4hf */

        case 6:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14524; /* pred_subrvvm8sf */

        case 7:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14528; /* pred_subrvvm4sf */

        case 8:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14532; /* pred_subrvvm2sf */

        case 9:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14536; /* pred_subrvvm1sf */

        case 10:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14540; /* pred_subrvvmf2sf */

        case 11:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14544; /* pred_subrvvm8df */

        case 12:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14548; /* pred_subrvvm4df */

        case 13:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14552; /* pred_subrvvm2df */

        case 14:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14556; /* pred_subrvvm1df */

        case 15:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 14560; /* pred_subv1hf */

        case 16:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 14564; /* pred_subv2hf */

        case 17:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 14568; /* pred_subv4hf */

        case 18:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 14572; /* pred_subv8hf */

        case 19:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 14576; /* pred_subv16hf */

        case 20:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14580; /* pred_subv32hf */

        case 21:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14584; /* pred_subv64hf */

        case 22:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14588; /* pred_subv128hf */

        case 23:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14592; /* pred_subv256hf */

        case 24:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14596; /* pred_subv512hf */

        case 25:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14600; /* pred_subv1024hf */

        case 26:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14604; /* pred_subv2048hf */

        case 27:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14608; /* pred_subv1sf */

        case 28:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14612; /* pred_subv2sf */

        case 29:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14616; /* pred_subv4sf */

        case 30:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14620; /* pred_subv8sf */

        case 31:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14624; /* pred_subv16sf */

        case 32:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14628; /* pred_subv32sf */

        case 33:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14632; /* pred_subv64sf */

        case 34:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14636; /* pred_subv128sf */

        case 35:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14640; /* pred_subv256sf */

        case 36:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14644; /* pred_subv512sf */

        case 37:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14648; /* pred_subv1024sf */

        case 38:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14652; /* pred_subv1df */

        case 39:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14656; /* pred_subv2df */

        case 40:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14660; /* pred_subv4df */

        case 41:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14664; /* pred_subv8df */

        case 42:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14668; /* pred_subv16df */

        case 43:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14672; /* pred_subv32df */

        case 44:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14676; /* pred_subv64df */

        case 45:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14680; /* pred_subv128df */

        case 46:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14684; /* pred_subv256df */

        case 47:
          if (!(
#line 6202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14688; /* pred_subv512df */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern728 (x2))
        {
        case 0:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14972; /* pred_subrvvm8hf_scalar */

        case 1:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14974; /* pred_subrvvm4hf_scalar */

        case 2:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14976; /* pred_subrvvm2hf_scalar */

        case 3:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14978; /* pred_subrvvm1hf_scalar */

        case 4:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14980; /* pred_subrvvmf2hf_scalar */

        case 5:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14982; /* pred_subrvvmf4hf_scalar */

        case 6:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14984; /* pred_subrvvm8sf_scalar */

        case 7:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14986; /* pred_subrvvm4sf_scalar */

        case 8:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14988; /* pred_subrvvm2sf_scalar */

        case 9:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14990; /* pred_subrvvm1sf_scalar */

        case 10:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 14992; /* pred_subrvvmf2sf_scalar */

        case 11:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14994; /* pred_subrvvm8df_scalar */

        case 12:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14996; /* pred_subrvvm4df_scalar */

        case 13:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14998; /* pred_subrvvm2df_scalar */

        case 14:
          if (!(
#line 6336 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15000; /* pred_subrvvm1df_scalar */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern542 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16613; /* pred_single_widen_subrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern542 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16614; /* pred_single_widen_subrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern542 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16615; /* pred_single_widen_subrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern542 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16616; /* pred_single_widen_subrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern542 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 16617; /* pred_single_widen_subrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern542 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16618; /* pred_single_widen_subrvvm8df */

            case E_RVVM4DFmode:
              if (pattern542 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16619; /* pred_single_widen_subrvvm4df */

            case E_RVVM2DFmode:
              if (pattern542 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16620; /* pred_single_widen_subrvvm2df */

            case E_RVVM1DFmode:
              if (pattern542 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16621; /* pred_single_widen_subrvvm1df */

            case E_V1SFmode:
              if (pattern542 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16622; /* pred_single_widen_subv1sf */

            case E_V2SFmode:
              if (pattern542 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16623; /* pred_single_widen_subv2sf */

            case E_V4SFmode:
              if (pattern542 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16624; /* pred_single_widen_subv4sf */

            case E_V8SFmode:
              if (pattern542 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16625; /* pred_single_widen_subv8sf */

            case E_V16SFmode:
              if (pattern542 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16626; /* pred_single_widen_subv16sf */

            case E_V32SFmode:
              if (pattern542 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16627; /* pred_single_widen_subv32sf */

            case E_V64SFmode:
              if (pattern542 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16628; /* pred_single_widen_subv64sf */

            case E_V128SFmode:
              if (pattern542 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16629; /* pred_single_widen_subv128sf */

            case E_V256SFmode:
              if (pattern542 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16630; /* pred_single_widen_subv256sf */

            case E_V512SFmode:
              if (pattern542 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16631; /* pred_single_widen_subv512sf */

            case E_V1024SFmode:
              if (pattern542 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16632; /* pred_single_widen_subv1024sf */

            case E_V1DFmode:
              if (pattern542 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16633; /* pred_single_widen_subv1df */

            case E_V2DFmode:
              if (pattern542 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16634; /* pred_single_widen_subv2df */

            case E_V4DFmode:
              if (pattern542 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16635; /* pred_single_widen_subv4df */

            case E_V8DFmode:
              if (pattern542 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16636; /* pred_single_widen_subv8df */

            case E_V16DFmode:
              if (pattern542 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16637; /* pred_single_widen_subv16df */

            case E_V32DFmode:
              if (pattern542 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16638; /* pred_single_widen_subv32df */

            case E_V64DFmode:
              if (pattern542 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16639; /* pred_single_widen_subv64df */

            case E_V128DFmode:
              if (pattern542 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16640; /* pred_single_widen_subv128df */

            case E_V256DFmode:
              if (pattern542 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16641; /* pred_single_widen_subv256df */

            case E_V512DFmode:
              if (pattern542 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
                  || !(
#line 7115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16642; /* pred_single_widen_subv512df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern734 (x2))
            {
            case 0:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16644; /* pred_single_widen_subrvvm8sf_scalar */

            case 1:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16646; /* pred_single_widen_subrvvm4sf_scalar */

            case 2:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16648; /* pred_single_widen_subrvvm2sf_scalar */

            case 3:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16650; /* pred_single_widen_subrvvm1sf_scalar */

            case 4:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 16652; /* pred_single_widen_subrvvmf2sf_scalar */

            case 5:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16654; /* pred_single_widen_subrvvm8df_scalar */

            case 6:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16656; /* pred_single_widen_subrvvm4df_scalar */

            case 7:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16658; /* pred_single_widen_subrvvm2df_scalar */

            case 8:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16660; /* pred_single_widen_subrvvm1df_scalar */

            case 9:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16662; /* pred_single_widen_subv1sf_scalar */

            case 10:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16664; /* pred_single_widen_subv2sf_scalar */

            case 11:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16666; /* pred_single_widen_subv4sf_scalar */

            case 12:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16668; /* pred_single_widen_subv8sf_scalar */

            case 13:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16670; /* pred_single_widen_subv16sf_scalar */

            case 14:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16672; /* pred_single_widen_subv32sf_scalar */

            case 15:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16674; /* pred_single_widen_subv64sf_scalar */

            case 16:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16676; /* pred_single_widen_subv128sf_scalar */

            case 17:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16678; /* pred_single_widen_subv256sf_scalar */

            case 18:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16680; /* pred_single_widen_subv512sf_scalar */

            case 19:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16682; /* pred_single_widen_subv1024sf_scalar */

            case 20:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16684; /* pred_single_widen_subv1df_scalar */

            case 21:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16686; /* pred_single_widen_subv2df_scalar */

            case 22:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16688; /* pred_single_widen_subv4df_scalar */

            case 23:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16690; /* pred_single_widen_subv8df_scalar */

            case 24:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16692; /* pred_single_widen_subv16df_scalar */

            case 25:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16694; /* pred_single_widen_subv32df_scalar */

            case 26:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16696; /* pred_single_widen_subv64df_scalar */

            case 27:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16698; /* pred_single_widen_subv128df_scalar */

            case 28:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16700; /* pred_single_widen_subv256df_scalar */

            case 29:
              if (!(
#line 7141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16702; /* pred_single_widen_subv512df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V128QImode:
      if (!register_operand (operands[3], E_V128QImode)
          || !vector_arith_operand (operands[4], E_V128QImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12456; /* *pred_cmpv128qi_merge_tie_mask */

    case E_V128HImode:
      if (!register_operand (operands[3], E_V128HImode)
          || !vector_arith_operand (operands[4], E_V128HImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12469; /* *pred_cmpv128hi_merge_tie_mask */

    case E_V128SImode:
      if (!register_operand (operands[3], E_V128SImode)
          || !vector_arith_operand (operands[4], E_V128SImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12481; /* *pred_cmpv128si_merge_tie_mask */

    case E_V128DImode:
      if (!register_operand (operands[3], E_V128DImode)
          || !vector_arith_operand (operands[4], E_V128DImode)
          || !(
#line 4769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12492; /* *pred_cmpv128di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1366 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern536 (x2, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V256BImode))
    {
      res = recog_1361 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V256BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V256BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V256QImode:
      if (!register_operand (operands[4], E_V256QImode)
          || !vector_arith_operand (operands[5], E_V256QImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256QImode)) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 12525; /* *pred_cmpv256qi */
      if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256QImode)) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12593; /* *pred_cmpv256qi_narrow */

    case E_V256HImode:
      if (!register_operand (operands[4], E_V256HImode)
          || !vector_arith_operand (operands[5], E_V256HImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256HImode)) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 12538; /* *pred_cmpv256hi */
      if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256HImode)) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12606; /* *pred_cmpv256hi_narrow */

    case E_V256SImode:
      if (!register_operand (operands[4], E_V256SImode)
          || !vector_arith_operand (operands[5], E_V256SImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256SImode)) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 12550; /* *pred_cmpv256si */
      if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256SImode)) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12618; /* *pred_cmpv256si_narrow */

    case E_V256DImode:
      if (!register_operand (operands[4], E_V256DImode)
          || !vector_arith_operand (operands[5], E_V256DImode))
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V256DImode)) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 12561; /* *pred_cmpv256di */
      if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V256DImode)) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12629; /* *pred_cmpv256di_narrow */

    default:
      return -1;
    }
}

 int
recog_1373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern591 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) == 0
          && 
#line 4769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12427; /* *pred_cmprvvm8qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern592 (x2, 
E_RVVM1BImode, 
E_RVVM8QImode) != 0)
        return -1;
      if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8QImode)))
        return 12495; /* *pred_cmprvvm8qi */
      if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8QImode)))
        return -1;
      return 12563; /* *pred_cmprvvm8qi_narrow */

    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF2BImode))
        {
          res = recog_1347 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4QImode:
          if (!register_operand (operands[4], E_RVVM4QImode)
              || !vector_arith_operand (operands[5], E_RVVM4QImode))
            return -1;
          if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4QImode)))
            return 12496; /* *pred_cmprvvm4qi */
          if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4QImode)))
            return -1;
          return 12564; /* *pred_cmprvvm4qi_narrow */

        case E_RVVM8HImode:
          if (!register_operand (operands[4], E_RVVM8HImode)
              || !vector_arith_operand (operands[5], E_RVVM8HImode))
            return -1;
          if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HImode)))
            return 12499; /* *pred_cmprvvm8hi */
          if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HImode)))
            return -1;
          return 12567; /* *pred_cmprvvm8hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1348 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2QImode:
          if (!register_operand (operands[4], E_RVVM2QImode)
              || !vector_arith_operand (operands[5], E_RVVM2QImode))
            return -1;
          if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2QImode)))
            return 12497; /* *pred_cmprvvm2qi */
          if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2QImode)))
            return -1;
          return 12565; /* *pred_cmprvvm2qi_narrow */

        case E_RVVM4HImode:
          if (!register_operand (operands[4], E_RVVM4HImode)
              || !vector_arith_operand (operands[5], E_RVVM4HImode))
            return -1;
          if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HImode)))
            return 12500; /* *pred_cmprvvm4hi */
          if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HImode)))
            return -1;
          return 12568; /* *pred_cmprvvm4hi_narrow */

        case E_RVVM8SImode:
          if (!register_operand (operands[4], E_RVVM8SImode)
              || !vector_arith_operand (operands[5], E_RVVM8SImode))
            return -1;
          if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SImode)))
            return 12503; /* *pred_cmprvvm8si */
          if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SImode)))
            return -1;
          return 12571; /* *pred_cmprvvm8si_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1349 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1QImode:
          if (!register_operand (operands[4], E_RVVM1QImode)
              || !vector_arith_operand (operands[5], E_RVVM1QImode))
            return -1;
          if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1QImode)))
            return 12498; /* *pred_cmprvvm1qi */
          if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1QImode)))
            return -1;
          return 12566; /* *pred_cmprvvm1qi_narrow */

        case E_RVVM2HImode:
          if (!register_operand (operands[4], E_RVVM2HImode)
              || !vector_arith_operand (operands[5], E_RVVM2HImode))
            return -1;
          if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HImode)))
            return 12501; /* *pred_cmprvvm2hi */
          if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HImode)))
            return -1;
          return 12569; /* *pred_cmprvvm2hi_narrow */

        case E_RVVM4SImode:
          if (!register_operand (operands[4], E_RVVM4SImode)
              || !vector_arith_operand (operands[5], E_RVVM4SImode))
            return -1;
          if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SImode)))
            return 12504; /* *pred_cmprvvm4si */
          if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SImode)))
            return -1;
          return 12572; /* *pred_cmprvvm4si_narrow */

        case E_RVVM8DImode:
          if (!register_operand (operands[4], E_RVVM8DImode)
              || !vector_arith_operand (operands[5], E_RVVM8DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DImode)) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12507; /* *pred_cmprvvm8di */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DImode)) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12575; /* *pred_cmprvvm8di_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1350 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[4], E_RVVM1HImode)
              || !vector_arith_operand (operands[5], E_RVVM1HImode))
            return -1;
          if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HImode)))
            return 12502; /* *pred_cmprvvm1hi */
          if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HImode)))
            return -1;
          return 12570; /* *pred_cmprvvm1hi_narrow */

        case E_RVVM2SImode:
          if (!register_operand (operands[4], E_RVVM2SImode)
              || !vector_arith_operand (operands[5], E_RVVM2SImode))
            return -1;
          if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SImode)))
            return 12505; /* *pred_cmprvvm2si */
          if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SImode)))
            return -1;
          return 12573; /* *pred_cmprvvm2si_narrow */

        case E_RVVM4DImode:
          if (!register_operand (operands[4], E_RVVM4DImode)
              || !vector_arith_operand (operands[5], E_RVVM4DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DImode)) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12508; /* *pred_cmprvvm4di */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DImode)) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12576; /* *pred_cmprvvm4di_narrow */

        case E_RVVMF2QImode:
          if (!register_operand (operands[4], E_RVVMF2QImode)
              || !vector_arith_operand (operands[5], E_RVVMF2QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2QImode)) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12511; /* *pred_cmprvvmf2qi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2QImode)) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12579; /* *pred_cmprvvmf2qi_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1351 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[4], E_RVVM1SImode)
              || !vector_arith_operand (operands[5], E_RVVM1SImode))
            return -1;
          if (
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SImode)))
            return 12506; /* *pred_cmprvvm1si */
          if (!
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SImode)))
            return -1;
          return 12574; /* *pred_cmprvvm1si_narrow */

        case E_RVVM2DImode:
          if (!register_operand (operands[4], E_RVVM2DImode)
              || !vector_arith_operand (operands[5], E_RVVM2DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DImode)) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12509; /* *pred_cmprvvm2di */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DImode)) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12577; /* *pred_cmprvvm2di_narrow */

        case E_RVVMF4QImode:
          if (!register_operand (operands[4], E_RVVMF4QImode)
              || !vector_arith_operand (operands[5], E_RVVMF4QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4QImode)) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12512; /* *pred_cmprvvmf4qi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4QImode)) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12580; /* *pred_cmprvvmf4qi_narrow */

        case E_RVVMF2HImode:
          if (!register_operand (operands[4], E_RVVMF2HImode)
              || !vector_arith_operand (operands[5], E_RVVMF2HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HImode)) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 12514; /* *pred_cmprvvmf2hi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HImode)) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 12582; /* *pred_cmprvvmf2hi_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1352 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1DImode:
          if (!register_operand (operands[4], E_RVVM1DImode)
              || !vector_arith_operand (operands[5], E_RVVM1DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DImode)) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12510; /* *pred_cmprvvm1di */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DImode)) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12578; /* *pred_cmprvvm1di_narrow */

        case E_RVVMF8QImode:
          if (!register_operand (operands[4], E_RVVMF8QImode)
              || !vector_arith_operand (operands[5], E_RVVMF8QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF8QImode)) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12513; /* *pred_cmprvvmf8qi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF8QImode)) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12581; /* *pred_cmprvvmf8qi_narrow */

        case E_RVVMF4HImode:
          if (!register_operand (operands[4], E_RVVMF4HImode)
              || !vector_arith_operand (operands[5], E_RVVMF4HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HImode)) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12515; /* *pred_cmprvvmf4hi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HImode)) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12583; /* *pred_cmprvvmf4hi_narrow */

        case E_RVVMF2SImode:
          if (!register_operand (operands[4], E_RVVMF2SImode)
              || !vector_arith_operand (operands[5], E_RVVMF2SImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SImode)) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 12516; /* *pred_cmprvvmf2si */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SImode)) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 12584; /* *pred_cmprvvmf2si_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1BImode))
        {
          res = recog_1353 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1QImode:
          if (!register_operand (operands[4], E_V1QImode)
              || !vector_arith_operand (operands[5], E_V1QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1QImode)) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return 12517; /* *pred_cmpv1qi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1QImode)) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 12585; /* *pred_cmpv1qi_narrow */

        case E_V1HImode:
          if (!register_operand (operands[4], E_V1HImode)
              || !vector_arith_operand (operands[5], E_V1HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HImode)) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return 12530; /* *pred_cmpv1hi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HImode)) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 12598; /* *pred_cmpv1hi_narrow */

        case E_V1SImode:
          if (!register_operand (operands[4], E_V1SImode)
              || !vector_arith_operand (operands[5], E_V1SImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SImode)) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return 12542; /* *pred_cmpv1si */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SImode)) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 12610; /* *pred_cmpv1si_narrow */

        case E_V1DImode:
          if (!register_operand (operands[4], E_V1DImode)
              || !vector_arith_operand (operands[5], E_V1DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DImode)) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return 12553; /* *pred_cmpv1di */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DImode)) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12621; /* *pred_cmpv1di_narrow */

        default:
          return -1;
        }

    case E_V2BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2BImode))
        {
          res = recog_1354 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2QImode:
          if (!register_operand (operands[4], E_V2QImode)
              || !vector_arith_operand (operands[5], E_V2QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2QImode)) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return 12518; /* *pred_cmpv2qi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2QImode)) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 12586; /* *pred_cmpv2qi_narrow */

        case E_V2HImode:
          if (!register_operand (operands[4], E_V2HImode)
              || !vector_arith_operand (operands[5], E_V2HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HImode)) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return 12531; /* *pred_cmpv2hi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HImode)) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 12599; /* *pred_cmpv2hi_narrow */

        case E_V2SImode:
          if (!register_operand (operands[4], E_V2SImode)
              || !vector_arith_operand (operands[5], E_V2SImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SImode)) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return 12543; /* *pred_cmpv2si */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SImode)) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 12611; /* *pred_cmpv2si_narrow */

        case E_V2DImode:
          if (!register_operand (operands[4], E_V2DImode)
              || !vector_arith_operand (operands[5], E_V2DImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DImode)) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return 12554; /* *pred_cmpv2di */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DImode)) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12622; /* *pred_cmpv2di_narrow */

        default:
          return -1;
        }

    case E_V4BImode:
      return recog_1372 (x1, insn, pnum_clobbers);

    case E_V8BImode:
      return recog_1371 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1370 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1369 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1368 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1367 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1366 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1365 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1363 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024QImode:
          if (!register_operand (operands[4], E_V1024QImode)
              || !vector_arith_operand (operands[5], E_V1024QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024QImode)) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return 12527; /* *pred_cmpv1024qi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024QImode)) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 12595; /* *pred_cmpv1024qi_narrow */

        case E_V1024HImode:
          if (!register_operand (operands[4], E_V1024HImode)
              || !vector_arith_operand (operands[5], E_V1024HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HImode)) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return 12540; /* *pred_cmpv1024hi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HImode)) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12608; /* *pred_cmpv1024hi_narrow */

        case E_V1024SImode:
          if (!register_operand (operands[4], E_V1024SImode)
              || !vector_arith_operand (operands[5], E_V1024SImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SImode)) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return 12552; /* *pred_cmpv1024si */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SImode)) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12620; /* *pred_cmpv1024si_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2048BImode))
        {
          res = recog_1364 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2048BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      operands[5] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!vector_merge_operand (operands[2], E_V2048BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2048QImode:
          if (!register_operand (operands[4], E_V2048QImode)
              || !vector_arith_operand (operands[5], E_V2048QImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048QImode)) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return 12528; /* *pred_cmpv2048qi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048QImode)) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12596; /* *pred_cmpv2048qi_narrow */

        case E_V2048HImode:
          if (!register_operand (operands[4], E_V2048HImode)
              || !vector_arith_operand (operands[5], E_V2048HImode))
            return -1;
          if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HImode)) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return 12541; /* *pred_cmpv2048hi */
          if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HImode)) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12609; /* *pred_cmpv2048hi_narrow */

        default:
          return -1;
        }

    case E_V4096BImode:
      x2 = XEXP (x1, 1);
      if (pattern536 (x2, 
E_V4096BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern591 (x2, 
E_V4096QImode, 
E_V4096BImode) == 0
          && (
#line 4769 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12461; /* *pred_cmpv4096qi_merge_tie_mask */
      operands[3] = x3;
      if (pattern592 (x2, 
E_V4096BImode, 
E_V4096QImode) != 0)
        return -1;
      if ((
#line 4793 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4096QImode)) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12529; /* *pred_cmpv4096qi */
      if (!(
#line 4814 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4096QImode)) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12597; /* *pred_cmpv4096qi_narrow */

    default:
      return -1;
    }
}

 int
recog_1468 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern548 (x2, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V16BImode))
    {
      res = recog_1456 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[4], E_V16HFmode)
          || GET_MODE (x9) != E_V16HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16HFmode)) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 17154; /* *pred_cmpv16hf_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16HFmode)) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17202; /* *pred_cmpv16hf_scalar_narrow */

    case E_V16SFmode:
      if (!register_operand (operands[4], E_V16SFmode)
          || GET_MODE (x9) != E_V16SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16SFmode)) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 17166; /* *pred_cmpv16sf_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16SFmode)) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17214; /* *pred_cmpv16sf_scalar_narrow */

    case E_V16DFmode:
      if (!register_operand (operands[4], E_V16DFmode)
          || GET_MODE (x9) != E_V16DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7418 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DFmode)) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 17177; /* *pred_cmpv16df_scalar */
      if (!(
#line 7440 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DFmode)) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17225; /* *pred_cmpv16df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1475 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x5;
          operands[1] = x4;
          return recog_3 (x1, insn, pnum_clobbers);

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
              || !register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 2724 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && !TARGET_64BIT && TARGET_ZFA))
            return -1;
          return 292; /* movdfsisi3_rv32 */

        default:
          return -1;
        }

    case AND:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x8;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern229 (x3, 
E_SImode) != 0
                  || !(
#line 883 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 10; /* *lui_constraintsi_and_to_or */

            case E_DImode:
              if (pattern229 (x3, 
E_DImode) != 0
                  || !(
#line 883 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 11; /* *lui_constraintdi_and_to_or */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x8) != E_DImode
              || pattern283 (x3, 
E_DImode) != 0)
            return -1;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          if (!imm123_operand (operands[2], E_QImode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[3] = x9;
          if (pnum_clobbers != NULL
              && consecutive_bits_operand (operands[3], E_DImode))
            {
              x5 = XEXP (x3, 1);
              operands[4] = x5;
              if (register_operand (operands[4], E_DImode)
                  && 
#line 96 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && riscv_shamt_matches_mask_p (INTVAL (operands[2]), INTVAL (operands[3]))
   && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))))
                {
                  *pnum_clobbers = 1;
                  return 511; /* *andi_add.uw */
                }
            }
          if (!immediate_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[4] = x5;
          if (!register_operand (operands[4], E_DImode)
              || !
#line 116 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && (INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff))
            return -1;
          return 512; /* *shNadduw */

        default:
          return -1;
        }

    case ASHIFT:
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_CODE (operands[3]))
        {
        case CONST_INT:
          if (pnum_clobbers == NULL
              || !const_int_operand (operands[3], E_VOIDmode)
              || pattern229 (x3, 
E_DImode) != 0
              || !const_int_operand (operands[2], E_VOIDmode)
              || !
#line 4694 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)))
            return -1;
          *pnum_clobbers = 1;
          return 492; /* *riscv.md:4688 */

        case REG:
        case SUBREG:
          if (!imm123_operand (operands[2], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern399 (x3, 
E_SImode) != 0)
                return -1;
              if ((
#line 37 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_ZBA) && 
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 509; /* *shNadd */
              if (!(
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADBA) && 
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 868; /* *th_addslsi4 */

            case E_DImode:
              if (pattern399 (x3, 
E_DImode) != 0)
                return -1;
              if ((
#line 37 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_ZBA) && 
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 510; /* *shNadd */
              if (!(
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead.md"
(TARGET_XTHEADBA) && 
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 869; /* *th_addsldi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_8 (x1, insn, pnum_clobbers);

    case MULT:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          return recog_4 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          return recog_6 (x1, insn, pnum_clobbers);

        case ZERO_EXTEND:
          return recog_7 (x1, insn, pnum_clobbers);

        case FLOAT_EXTEND:
          switch (pattern139 (x3))
            {
            case 0:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31598; /* *dual_widen_fmarvvm8sf */

            case 1:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31599; /* *dual_widen_fmarvvm4sf */

            case 2:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31600; /* *dual_widen_fmarvvm2sf */

            case 3:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31601; /* *dual_widen_fmarvvm1sf */

            case 4:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 31602; /* *dual_widen_fmarvvmf2sf */

            case 5:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31603; /* *dual_widen_fmarvvm8df */

            case 6:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31604; /* *dual_widen_fmarvvm4df */

            case 7:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31605; /* *dual_widen_fmarvvm2df */

            case 8:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31606; /* *dual_widen_fmarvvm1df */

            case 9:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31607; /* *dual_widen_fmav1sf */

            case 10:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31608; /* *dual_widen_fmav2sf */

            case 11:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31609; /* *dual_widen_fmav4sf */

            case 12:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31610; /* *dual_widen_fmav8sf */

            case 13:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31611; /* *dual_widen_fmav16sf */

            case 14:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31612; /* *dual_widen_fmav32sf */

            case 15:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31613; /* *dual_widen_fmav64sf */

            case 16:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31614; /* *dual_widen_fmav128sf */

            case 17:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31615; /* *dual_widen_fmav256sf */

            case 18:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31616; /* *dual_widen_fmav512sf */

            case 19:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 31617; /* *dual_widen_fmav1024sf */

            case 20:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31618; /* *dual_widen_fmav1df */

            case 21:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31619; /* *dual_widen_fmav2df */

            case 22:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31620; /* *dual_widen_fmav4df */

            case 23:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31621; /* *dual_widen_fmav8df */

            case 24:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31622; /* *dual_widen_fmav16df */

            case 25:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31623; /* *dual_widen_fmav32df */

            case 26:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31624; /* *dual_widen_fmav64df */

            case 27:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31625; /* *dual_widen_fmav128df */

            case 28:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31626; /* *dual_widen_fmav256df */

            case 29:
              if (!(
#line 1058 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 31627; /* *dual_widen_fmav512df */

            case 30:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31628; /* *single_widen_fmarvvm8sf */

            case 31:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31629; /* *single_widen_fmarvvm4sf */

            case 32:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31630; /* *single_widen_fmarvvm2sf */

            case 33:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31631; /* *single_widen_fmarvvm1sf */

            case 34:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
                return -1;
              return 31632; /* *single_widen_fmarvvmf2sf */

            case 35:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31633; /* *single_widen_fmarvvm8df */

            case 36:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31634; /* *single_widen_fmarvvm4df */

            case 37:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31635; /* *single_widen_fmarvvm2df */

            case 38:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31636; /* *single_widen_fmarvvm1df */

            case 39:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31637; /* *single_widen_fmav1sf */

            case 40:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31638; /* *single_widen_fmav2sf */

            case 41:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31639; /* *single_widen_fmav4sf */

            case 42:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 31640; /* *single_widen_fmav8sf */

            case 43:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31641; /* *single_widen_fmav16sf */

            case 44:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31642; /* *single_widen_fmav32sf */

            case 45:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31643; /* *single_widen_fmav64sf */

            case 46:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31644; /* *single_widen_fmav128sf */

            case 47:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31645; /* *single_widen_fmav256sf */

            case 48:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31646; /* *single_widen_fmav512sf */

            case 49:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 31647; /* *single_widen_fmav1024sf */

            case 50:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31648; /* *single_widen_fmav1df */

            case 51:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31649; /* *single_widen_fmav2df */

            case 52:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 31650; /* *single_widen_fmav4df */

            case 53:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 31651; /* *single_widen_fmav8df */

            case 54:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 31652; /* *single_widen_fmav16df */

            case 55:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 31653; /* *single_widen_fmav32df */

            case 56:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 31654; /* *single_widen_fmav64df */

            case 57:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 31655; /* *single_widen_fmav128df */

            case 58:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 31656; /* *single_widen_fmav256df */

            case 59:
              if (!(
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 31657; /* *single_widen_fmav512df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FFS:
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 5
          || XINT (x8, 1) != 93)
        return -1;
      x11 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x11) != AND)
        return -1;
      x12 = XVECEXP (x8, 0, 3);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 66
          || GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XVECEXP (x8, 0, 4);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 67
          || GET_MODE (x13) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x14 = XEXP (x11, 0);
      operands[1] = x14;
      x15 = XEXP (x11, 1);
      operands[2] = x15;
      x16 = XVECEXP (x8, 0, 1);
      operands[3] = x16;
      if (!vector_length_operand (operands[3], E_VOIDmode))
        return -1;
      x17 = XVECEXP (x8, 0, 2);
      operands[4] = x17;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern572 (x3, 
E_SImode))
            {
            case 0:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                return -1;
              return 14373; /* pred_ffsrvvmf64bisi */

            case 1:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14375; /* pred_ffsrvvmf32bisi */

            case 2:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14377; /* pred_ffsrvvmf16bisi */

            case 3:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14379; /* pred_ffsrvvmf8bisi */

            case 4:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14381; /* pred_ffsrvvmf4bisi */

            case 5:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14383; /* pred_ffsrvvmf2bisi */

            case 6:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 14385; /* pred_ffsrvvm1bisi */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern572 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((((
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32))))
                return -1;
              return 14374; /* pred_ffsrvvmf64bidi */

            case 1:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14376; /* pred_ffsrvvmf32bidi */

            case 2:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14378; /* pred_ffsrvvmf16bidi */

            case 3:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14380; /* pred_ffsrvvmf8bidi */

            case 4:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14382; /* pred_ffsrvvmf4bidi */

            case 5:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14384; /* pred_ffsrvvmf2bidi */

            case 6:
              if (!(
#line 6115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 14386; /* pred_ffsrvvm1bidi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_9 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      switch (pattern131 (x3))
        {
        case 0:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30914; /* *dual_widen_addrvvm8sf */

        case 1:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30917; /* *dual_widen_addrvvm4sf */

        case 2:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30920; /* *dual_widen_addrvvm2sf */

        case 3:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30923; /* *dual_widen_addrvvm1sf */

        case 4:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 30926; /* *dual_widen_addrvvmf2sf */

        case 5:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30929; /* *dual_widen_addrvvm8df */

        case 6:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30932; /* *dual_widen_addrvvm4df */

        case 7:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30935; /* *dual_widen_addrvvm2df */

        case 8:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30938; /* *dual_widen_addrvvm1df */

        case 9:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30941; /* *dual_widen_addv1sf */

        case 10:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30944; /* *dual_widen_addv2sf */

        case 11:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30947; /* *dual_widen_addv4sf */

        case 12:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30950; /* *dual_widen_addv8sf */

        case 13:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30953; /* *dual_widen_addv16sf */

        case 14:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30956; /* *dual_widen_addv32sf */

        case 15:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30959; /* *dual_widen_addv64sf */

        case 16:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30962; /* *dual_widen_addv128sf */

        case 17:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30965; /* *dual_widen_addv256sf */

        case 18:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30968; /* *dual_widen_addv512sf */

        case 19:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30971; /* *dual_widen_addv1024sf */

        case 20:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30974; /* *dual_widen_addv1df */

        case 21:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30977; /* *dual_widen_addv2df */

        case 22:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30980; /* *dual_widen_addv4df */

        case 23:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30983; /* *dual_widen_addv8df */

        case 24:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30986; /* *dual_widen_addv16df */

        case 25:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30989; /* *dual_widen_addv32df */

        case 26:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30992; /* *dual_widen_addv64df */

        case 27:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30995; /* *dual_widen_addv128df */

        case 28:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30998; /* *dual_widen_addv256df */

        case 29:
          if (!(
#line 758 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31001; /* *dual_widen_addv512df */

        case 30:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31004; /* *single_widen_addrvvm8sf */

        case 31:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31005; /* *single_widen_addrvvm4sf */

        case 32:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31006; /* *single_widen_addrvvm2sf */

        case 33:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31007; /* *single_widen_addrvvm1sf */

        case 34:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 31008; /* *single_widen_addrvvmf2sf */

        case 35:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31009; /* *single_widen_addrvvm8df */

        case 36:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31010; /* *single_widen_addrvvm4df */

        case 37:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31011; /* *single_widen_addrvvm2df */

        case 38:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31012; /* *single_widen_addrvvm1df */

        case 39:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31013; /* *single_widen_addv1sf */

        case 40:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31014; /* *single_widen_addv2sf */

        case 41:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31015; /* *single_widen_addv4sf */

        case 42:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31016; /* *single_widen_addv8sf */

        case 43:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31017; /* *single_widen_addv16sf */

        case 44:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31018; /* *single_widen_addv32sf */

        case 45:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31019; /* *single_widen_addv64sf */

        case 46:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31020; /* *single_widen_addv128sf */

        case 47:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31021; /* *single_widen_addv256sf */

        case 48:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31022; /* *single_widen_addv512sf */

        case 49:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31023; /* *single_widen_addv1024sf */

        case 50:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31024; /* *single_widen_addv1df */

        case 51:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31025; /* *single_widen_addv2df */

        case 52:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31026; /* *single_widen_addv4df */

        case 53:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31027; /* *single_widen_addv8df */

        case 54:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31028; /* *single_widen_addv16df */

        case 55:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31029; /* *single_widen_addv32df */

        case 56:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31030; /* *single_widen_addv64df */

        case 57:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31031; /* *single_widen_addv128df */

        case 58:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31032; /* *single_widen_addv256df */

        case 59:
          if (!(
#line 775 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31033; /* *single_widen_addv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1489 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 2:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 4102 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 463; /* riscv_frcsr */

        case 4:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 4115 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
            return -1;
          return 465; /* riscv_frflags */

        case 21:
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !(
#line 4767 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 498; /* ssrdpsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 4767 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 499; /* ssrdpdi */

            default:
              return -1;
            }

        case 24:
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 7)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[0] = x3;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!immediate_operand (operands[0], E_SImode)
                  || !
#line 4790 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_ZICFILP))
                return -1;
              return 503; /* set_lplsi */

            case E_DImode:
              if (!immediate_operand (operands[0], E_DImode)
                  || !(
#line 4790 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_ZICFILP) && 
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 504; /* set_lpldi */

            default:
              return -1;
            }

        case 26:
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 7)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[0] = x3;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 4804 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_ZICFILP))
                return -1;
              return 506; /* set_guardedsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 4804 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_ZICFILP) && 
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 507; /* set_guardeddi */

            default:
              return -1;
            }

        case 29:
          if (pattern184 (x1, 
69) != 0
              || !register_operand (operands[0], E_SImode)
              || !
#line 1126 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 2724; /* fsrmsi_restore_volatile */

        case 233:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!move_operand (operands[1], E_SImode)
              || !
#line 862 "../../gcc-15.0.1-20250329/gcc/config/riscv/corev.md"
(TARGET_XCVELW && !TARGET_64BIT))
            return -1;
          return 33943; /* riscv_cv_elw_elw_si */

        default:
          return -1;
        }

    case 2:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (XINT (x2, 1))
        {
        case 84:
          x3 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x3))
            {
            case PLUS:
              switch (pattern367 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 720; /* atomic_addqi */

                case 1:
                  if (!
#line 100 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 724; /* atomic_addhi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern367 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 721; /* atomic_orqi */

                case 1:
                  if (!
#line 100 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 725; /* atomic_orhi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern367 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 722; /* atomic_xorqi */

                case 1:
                  if (!
#line 100 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 726; /* atomic_xorhi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern367 (x2))
                {
                case 0:
                  if (!
#line 100 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 723; /* atomic_andqi */

                case 1:
                  if (!
#line 100 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZABHA))
                    return -1;
                  return 727; /* atomic_andhi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 82:
          x3 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x3))
            {
            case PLUS:
              switch (pattern368 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 728; /* amo_atomic_addsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 736; /* lrsc_atomic_addsi */

                case 1:
                  if ((
#line 127 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 732; /* amo_atomic_adddi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 740; /* lrsc_atomic_adddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern368 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 729; /* amo_atomic_orsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 737; /* lrsc_atomic_orsi */

                case 1:
                  if ((
#line 127 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 733; /* amo_atomic_ordi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 741; /* lrsc_atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern368 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 730; /* amo_atomic_xorsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 738; /* lrsc_atomic_xorsi */

                case 1:
                  if ((
#line 127 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 734; /* amo_atomic_xordi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 742; /* lrsc_atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern368 (x2))
                {
                case 0:
                  if (
#line 127 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZAAMO))
                    return 731; /* amo_atomic_andsi */
                  if (pnum_clobbers == NULL
                      || !
#line 140 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 739; /* lrsc_atomic_andsi */

                case 1:
                  if ((
#line 127 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(TARGET_ZAAMO) && 
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 735; /* amo_atomic_anddi */
                  if (pnum_clobbers == NULL
                      || !(
#line 140 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 743; /* lrsc_atomic_anddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 88:
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !memory_operand (operands[1], E_QImode))
                return -1;
              if (
#line 55 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 788; /* atomic_load_rvwmoqi */
              if (!
#line 49 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 797; /* atomic_load_ztsoqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !memory_operand (operands[1], E_HImode))
                return -1;
              if (
#line 55 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 789; /* atomic_load_rvwmohi */
              if (!
#line 49 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 798; /* atomic_load_ztsohi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !memory_operand (operands[1], E_SImode))
                return -1;
              if (
#line 55 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 790; /* atomic_load_rvwmosi */
              if (!
#line 49 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 799; /* atomic_load_ztsosi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !memory_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 55 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO) && 
#line 69 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 791; /* atomic_load_rvwmodi */
              if (!(
#line 49 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO) && 
#line 69 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 800; /* atomic_load_ztsodi */

            default:
              return -1;
            }

        case 89:
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!memory_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !reg_or_0_operand (operands[1], E_QImode))
                return -1;
              if (
#line 84 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 792; /* atomic_store_rvwmoqi */
              if (!
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 801; /* atomic_store_ztsoqi */

            case E_HImode:
              if (!memory_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !reg_or_0_operand (operands[1], E_HImode))
                return -1;
              if (
#line 84 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 793; /* atomic_store_rvwmohi */
              if (!
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 802; /* atomic_store_ztsohi */

            case E_SImode:
              if (!memory_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !reg_or_0_operand (operands[1], E_SImode))
                return -1;
              if (
#line 84 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
                return 794; /* atomic_store_rvwmosi */
              if (!
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
                return -1;
              return 803; /* atomic_store_ztsosi */

            case E_DImode:
              if (!memory_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !reg_or_0_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 84 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO) && 
#line 69 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 795; /* atomic_store_rvwmodi */
              if (!(
#line 72 "../../gcc-15.0.1-20250329/gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO) && 
#line 69 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 804; /* atomic_store_ztsodi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1492 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return recog_112 (x1, insn, pnum_clobbers);

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern200 (x3, 
E_SImode) != 0
              || !(
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 523; /* *xor_notsi */

        case E_DImode:
          if (pattern200 (x3, 
E_DImode) != 0
              || !(
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 524; /* *xor_notdi */

        case E_RVVMF64BImode:
          if (pattern200 (x3, 
E_RVVMF64BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32147; /* *nxorrvvmf64bi */

        case E_RVVMF32BImode:
          if (pattern200 (x3, 
E_RVVMF32BImode) != 0
              || !
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32150; /* *nxorrvvmf32bi */

        case E_RVVMF16BImode:
          if (pattern200 (x3, 
E_RVVMF16BImode) != 0
              || !
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32153; /* *nxorrvvmf16bi */

        case E_RVVMF8BImode:
          if (pattern200 (x3, 
E_RVVMF8BImode) != 0
              || !
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32156; /* *nxorrvvmf8bi */

        case E_RVVMF4BImode:
          if (pattern200 (x3, 
E_RVVMF4BImode) != 0
              || !
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32159; /* *nxorrvvmf4bi */

        case E_RVVMF2BImode:
          if (pattern200 (x3, 
E_RVVMF2BImode) != 0
              || !
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32162; /* *nxorrvvmf2bi */

        case E_RVVM1BImode:
          if (pattern200 (x3, 
E_RVVM1BImode) != 0
              || !
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32165; /* *nxorrvvm1bi */

        case E_V1BImode:
          if (pattern200 (x3, 
E_V1BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32168; /* *nxorv1bi */

        case E_V2BImode:
          if (pattern200 (x3, 
E_V2BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32171; /* *nxorv2bi */

        case E_V4BImode:
          if (pattern200 (x3, 
E_V4BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32174; /* *nxorv4bi */

        case E_V8BImode:
          if (pattern200 (x3, 
E_V8BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32177; /* *nxorv8bi */

        case E_V16BImode:
          if (pattern200 (x3, 
E_V16BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32180; /* *nxorv16bi */

        case E_V32BImode:
          if (pattern200 (x3, 
E_V32BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32183; /* *nxorv32bi */

        case E_V64BImode:
          if (pattern200 (x3, 
E_V64BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32186; /* *nxorv64bi */

        case E_V128BImode:
          if (pattern200 (x3, 
E_V128BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32189; /* *nxorv128bi */

        case E_V256BImode:
          if (pattern200 (x3, 
E_V256BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32192; /* *nxorv256bi */

        case E_V512BImode:
          if (pattern200 (x3, 
E_V512BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32195; /* *nxorv512bi */

        case E_V1024BImode:
          if (pattern200 (x3, 
E_V1024BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32198; /* *nxorv1024bi */

        case E_V2048BImode:
          if (pattern200 (x3, 
E_V2048BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32201; /* *nxorv2048bi */

        case E_V4096BImode:
          if (pattern200 (x3, 
E_V4096BImode) != 0
              || !(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32204; /* *nxorv4096bi */

        default:
          return -1;
        }

    case AND:
      switch (pattern201 (x3))
        {
        case 0:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32145; /* *nandrvvmf64bi */

        case 1:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32148; /* *nandrvvmf32bi */

        case 2:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32151; /* *nandrvvmf16bi */

        case 3:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32154; /* *nandrvvmf8bi */

        case 4:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32157; /* *nandrvvmf4bi */

        case 5:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32160; /* *nandrvvmf2bi */

        case 6:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32163; /* *nandrvvm1bi */

        case 7:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32166; /* *nandv1bi */

        case 8:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32169; /* *nandv2bi */

        case 9:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32172; /* *nandv4bi */

        case 10:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32175; /* *nandv8bi */

        case 11:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32178; /* *nandv16bi */

        case 12:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32181; /* *nandv32bi */

        case 13:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32184; /* *nandv64bi */

        case 14:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32187; /* *nandv128bi */

        case 15:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32190; /* *nandv256bi */

        case 16:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32193; /* *nandv512bi */

        case 17:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32196; /* *nandv1024bi */

        case 18:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32199; /* *nandv2048bi */

        case 19:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32202; /* *nandv4096bi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern201 (x3))
        {
        case 0:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 32146; /* *niorrvvmf64bi */

        case 1:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32149; /* *niorrvvmf32bi */

        case 2:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32152; /* *niorrvvmf16bi */

        case 3:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32155; /* *niorrvvmf8bi */

        case 4:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32158; /* *niorrvvmf4bi */

        case 5:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32161; /* *niorrvvmf2bi */

        case 6:
          if (!
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 32164; /* *niorrvvm1bi */

        case 7:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 32167; /* *niorv1bi */

        case 8:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 32170; /* *niorv2bi */

        case 9:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 32173; /* *niorv4bi */

        case 10:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 32176; /* *niorv8bi */

        case 11:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 32179; /* *niorv16bi */

        case 12:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 32182; /* *niorv32bi */

        case 13:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 32185; /* *niorv64bi */

        case 14:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 32188; /* *niorv128bi */

        case 15:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 32191; /* *niorv256bi */

        case 16:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 32194; /* *niorv512bi */

        case 17:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 32197; /* *niorv1024bi */

        case 18:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 32200; /* *niorv2048bi */

        case 19:
          if (!(
#line 1491 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 32203; /* *niorv4096bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1500 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1))
    {
    case 0:
      if (!
#line 1416 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_DIV))
        return -1;
      return 37; /* *udivsi3 */

    case 1:
      if (!
#line 1443 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 41; /* udivdi3 */

    case 2:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24552; /* udivrvvm8qi3 */

    case 3:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24566; /* udivrvvm4qi3 */

    case 4:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24580; /* udivrvvm2qi3 */

    case 5:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24594; /* udivrvvm1qi3 */

    case 6:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24608; /* udivrvvm8hi3 */

    case 7:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24622; /* udivrvvm4hi3 */

    case 8:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24636; /* udivrvvm2hi3 */

    case 9:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24650; /* udivrvvm1hi3 */

    case 10:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24664; /* udivrvvm8si3 */

    case 11:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24678; /* udivrvvm4si3 */

    case 12:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24692; /* udivrvvm2si3 */

    case 13:
      if (!
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24706; /* udivrvvm1si3 */

    case 14:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24720; /* udivrvvm8di3 */

    case 15:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24734; /* udivrvvm4di3 */

    case 16:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24748; /* udivrvvm2di3 */

    case 17:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24762; /* udivrvvm1di3 */

    case 18:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24776; /* udivrvvmf2qi3 */

    case 19:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24790; /* udivrvvmf4qi3 */

    case 20:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24804; /* udivrvvmf8qi3 */

    case 21:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24818; /* udivrvvmf2hi3 */

    case 22:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24832; /* udivrvvmf4hi3 */

    case 23:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24846; /* udivrvvmf2si3 */

    case 24:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24860; /* udivv1qi3 */

    case 25:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24874; /* udivv2qi3 */

    case 26:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24888; /* udivv4qi3 */

    case 27:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24902; /* udivv8qi3 */

    case 28:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24916; /* udivv16qi3 */

    case 29:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24930; /* udivv32qi3 */

    case 30:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24944; /* udivv64qi3 */

    case 31:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24958; /* udivv128qi3 */

    case 32:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24972; /* udivv256qi3 */

    case 33:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24986; /* udivv512qi3 */

    case 34:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25000; /* udivv1024qi3 */

    case 35:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25014; /* udivv2048qi3 */

    case 36:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25028; /* udivv4096qi3 */

    case 37:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25042; /* udivv1hi3 */

    case 38:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25056; /* udivv2hi3 */

    case 39:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25070; /* udivv4hi3 */

    case 40:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25084; /* udivv8hi3 */

    case 41:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25098; /* udivv16hi3 */

    case 42:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25112; /* udivv32hi3 */

    case 43:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25126; /* udivv64hi3 */

    case 44:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25140; /* udivv128hi3 */

    case 45:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25154; /* udivv256hi3 */

    case 46:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25168; /* udivv512hi3 */

    case 47:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25182; /* udivv1024hi3 */

    case 48:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25196; /* udivv2048hi3 */

    case 49:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25210; /* udivv1si3 */

    case 50:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25224; /* udivv2si3 */

    case 51:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25238; /* udivv4si3 */

    case 52:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25252; /* udivv8si3 */

    case 53:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25266; /* udivv16si3 */

    case 54:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25280; /* udivv32si3 */

    case 55:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25294; /* udivv64si3 */

    case 56:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25308; /* udivv128si3 */

    case 57:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25322; /* udivv256si3 */

    case 58:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25336; /* udivv512si3 */

    case 59:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25350; /* udivv1024si3 */

    case 60:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25364; /* udivv1di3 */

    case 61:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25378; /* udivv2di3 */

    case 62:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25392; /* udivv4di3 */

    case 63:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25406; /* udivv8di3 */

    case 64:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25420; /* udivv16di3 */

    case 65:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25434; /* udivv32di3 */

    case 66:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25448; /* udivv64di3 */

    case 67:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25462; /* udivv128di3 */

    case 68:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25476; /* udivv256di3 */

    case 69:
      if (!(
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25490; /* udivv512di3 */

    default:
      return -1;
    }
}

 int
recog_1509 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return recog_24 (x1, insn, pnum_clobbers);

    case FMA:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern403 (x3, 
E_SFmode) != 0
                      || !(
#line 1556 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 66; /* *fmasf4 */

                case E_DFmode:
                  if (pattern403 (x3, 
E_DFmode) != 0
                      || !(
#line 1556 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 67; /* *fmadf4 */

                case E_HFmode:
                  if (pattern403 (x3, 
E_HFmode) != 0
                      || !(
#line 1556 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 68; /* *fmahf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern404 (x3, 
E_SFmode) != 0
                      || !(
#line 1569 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 69; /* *fmssf4 */

                case E_DFmode:
                  if (pattern404 (x3, 
E_DFmode) != 0
                      || !(
#line 1569 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 70; /* *fmsdf4 */

                case E_HFmode:
                  if (pattern404 (x3, 
E_HFmode) != 0
                      || !(
#line 1569 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 71; /* *fmshf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern405 (x3, 
E_SFmode) != 0
                      || !(
#line 1582 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 72; /* *fnmssf4 */

                case E_DFmode:
                  if (pattern405 (x3, 
E_DFmode) != 0
                      || !(
#line 1582 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 73; /* *fnmsdf4 */

                case E_HFmode:
                  if (pattern405 (x3, 
E_HFmode) != 0
                      || !(
#line 1582 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 74; /* *fnmshf4 */

                default:
                  return -1;
                }

            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern406 (x3, 
E_SFmode) != 0
                      || !(
#line 1595 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 105 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                    return -1;
                  return 75; /* *fnmasf4 */

                case E_DFmode:
                  if (pattern406 (x3, 
E_DFmode) != 0
                      || !(
#line 1595 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 106 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 76; /* *fnmadf4 */

                case E_HFmode:
                  if (pattern406 (x3, 
E_HFmode) != 0
                      || !(
#line 1595 "../../gcc-15.0.1-20250329/gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && !HONOR_SIGNED_ZEROS (HFmode)) && 
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 77; /* *fnmahf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern152 (x3))
        {
        case 0:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 32090; /* *copysignrvvm8hf_neg */

        case 1:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 32091; /* *copysignrvvm4hf_neg */

        case 2:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 32092; /* *copysignrvvm2hf_neg */

        case 3:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 32093; /* *copysignrvvm1hf_neg */

        case 4:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 32094; /* *copysignrvvmf2hf_neg */

        case 5:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 32095; /* *copysignrvvmf4hf_neg */

        case 6:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32096; /* *copysignrvvm8sf_neg */

        case 7:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32097; /* *copysignrvvm4sf_neg */

        case 8:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32098; /* *copysignrvvm2sf_neg */

        case 9:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 32099; /* *copysignrvvm1sf_neg */

        case 10:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 32100; /* *copysignrvvmf2sf_neg */

        case 11:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 32101; /* *copysignrvvm8df_neg */

        case 12:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 32102; /* *copysignrvvm4df_neg */

        case 13:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 32103; /* *copysignrvvm2df_neg */

        case 14:
          if (!(
#line 1456 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 32104; /* *copysignrvvm1df_neg */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1519 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (pattern347 (x3))
    {
    case 0:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2826; /* *movrvvmf2qisi_lra */

    case 1:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2837; /* *movrvvmf2qidi_lra */

    case 2:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2827; /* *movrvvmf4qisi_lra */

    case 3:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2838; /* *movrvvmf4qidi_lra */

    case 4:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 932 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2828; /* *movrvvmf8qisi_lra */

    case 5:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 932 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2839; /* *movrvvmf8qidi_lra */

    case 6:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2829; /* *movrvvmf2hisi_lra */

    case 7:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2840; /* *movrvvmf2hidi_lra */

    case 8:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2830; /* *movrvvmf4hisi_lra */

    case 9:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2841; /* *movrvvmf4hidi_lra */

    case 10:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2831; /* *movrvvmf2bfsi_lra */

    case 11:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2842; /* *movrvvmf2bfdi_lra */

    case 12:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2832; /* *movrvvmf4bfsi_lra */

    case 13:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2843; /* *movrvvmf4bfdi_lra */

    case 14:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2833; /* *movrvvmf2hfsi_lra */

    case 15:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2844; /* *movrvvmf2hfdi_lra */

    case 16:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2834; /* *movrvvmf4hfsi_lra */

    case 17:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 938 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2845; /* *movrvvmf4hfdi_lra */

    case 18:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2835; /* *movrvvmf2sisi_lra */

    case 19:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2846; /* *movrvvmf2sidi_lra */

    case 20:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2836; /* *movrvvmf2sfsi_lra */

    case 21:
      if (!(
#line 1332 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 942 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2847; /* *movrvvmf2sfdi_lra */

    case 22:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 2848; /* *movrvvmf64bisi_lra */

    case 23:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 2849; /* *movrvvmf64bidi_lra */

    case 24:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2850; /* *movrvvmf32bisi_lra */

    case 25:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2851; /* *movrvvmf32bidi_lra */

    case 26:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2852; /* *movrvvmf16bisi_lra */

    case 27:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2853; /* *movrvvmf16bidi_lra */

    case 28:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2854; /* *movrvvmf8bisi_lra */

    case 29:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2855; /* *movrvvmf8bidi_lra */

    case 30:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2856; /* *movrvvmf4bisi_lra */

    case 31:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2857; /* *movrvvmf4bidi_lra */

    case 32:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2858; /* *movrvvmf2bisi_lra */

    case 33:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2859; /* *movrvvmf2bidi_lra */

    case 34:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      return 2860; /* *movrvvm1bisi_lra */

    case 35:
      if (!(
#line 1354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 2861; /* *movrvvm1bidi_lra */

    case 36:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4348 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3232; /* *movv32qisi_lra */

    case 37:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4348 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3233; /* *movv32qidi_lra */

    case 38:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3234; /* *movv64qisi_lra */

    case 39:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))) && (
#line 4349 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3235; /* *movv64qidi_lra */

    case 40:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4350 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3236; /* *movv128qisi_lra */

    case 41:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128QImode)
       || register_operand (operands[1], V128QImode))) && (
#line 4350 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3237; /* *movv128qidi_lra */

    case 42:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3238; /* *movv256qisi_lra */

    case 43:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3239; /* *movv256qidi_lra */

    case 44:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4352 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3240; /* *movv512qisi_lra */

    case 45:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512QImode)
       || register_operand (operands[1], V512QImode))) && (
#line 4352 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3241; /* *movv512qidi_lra */

    case 46:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4353 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3242; /* *movv1024qisi_lra */

    case 47:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024QImode)
       || register_operand (operands[1], V1024QImode))) && (
#line 4353 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3243; /* *movv1024qidi_lra */

    case 48:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3244; /* *movv2048qisi_lra */

    case 49:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4354 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3245; /* *movv2048qidi_lra */

    case 50:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3246; /* *movv4096qisi_lra */

    case 51:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096QImode)
       || register_operand (operands[1], V4096QImode))) && (
#line 4355 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3247; /* *movv4096qidi_lra */

    case 52:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4356 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3248; /* *movv32hisi_lra */

    case 53:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))) && (
#line 4356 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3249; /* *movv32hidi_lra */

    case 54:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3250; /* *movv64hisi_lra */

    case 55:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3251; /* *movv64hidi_lra */

    case 56:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4358 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3252; /* *movv128hisi_lra */

    case 57:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HImode)
       || register_operand (operands[1], V128HImode))) && (
#line 4358 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3253; /* *movv128hidi_lra */

    case 58:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4359 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3254; /* *movv256hisi_lra */

    case 59:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HImode)
       || register_operand (operands[1], V256HImode))) && (
#line 4359 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3255; /* *movv256hidi_lra */

    case 60:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4360 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3256; /* *movv512hisi_lra */

    case 61:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4360 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3257; /* *movv512hidi_lra */

    case 62:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3258; /* *movv1024hisi_lra */

    case 63:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HImode)
       || register_operand (operands[1], V1024HImode))) && (
#line 4361 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3259; /* *movv1024hidi_lra */

    case 64:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4362 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3260; /* *movv2048hisi_lra */

    case 65:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HImode)
       || register_operand (operands[1], V2048HImode))) && (
#line 4362 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3261; /* *movv2048hidi_lra */

    case 66:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3262; /* *movv32sisi_lra */

    case 67:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3263; /* *movv32sidi_lra */

    case 68:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4364 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3264; /* *movv64sisi_lra */

    case 69:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SImode)
       || register_operand (operands[1], V64SImode))) && (
#line 4364 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3265; /* *movv64sidi_lra */

    case 70:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4365 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3266; /* *movv128sisi_lra */

    case 71:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SImode)
       || register_operand (operands[1], V128SImode))) && (
#line 4365 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3267; /* *movv128sidi_lra */

    case 72:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4366 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3268; /* *movv256sisi_lra */

    case 73:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4366 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3269; /* *movv256sidi_lra */

    case 74:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3270; /* *movv512sisi_lra */

    case 75:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SImode)
       || register_operand (operands[1], V512SImode))) && (
#line 4367 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3271; /* *movv512sidi_lra */

    case 76:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4368 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3272; /* *movv1024sisi_lra */

    case 77:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SImode)
       || register_operand (operands[1], V1024SImode))) && (
#line 4368 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3273; /* *movv1024sidi_lra */

    case 78:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3274; /* *movv32disi_lra */

    case 79:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3275; /* *movv32didi_lra */

    case 80:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4370 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3276; /* *movv64disi_lra */

    case 81:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DImode)
       || register_operand (operands[1], V64DImode))) && (
#line 4370 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3277; /* *movv64didi_lra */

    case 82:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4371 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3278; /* *movv128disi_lra */

    case 83:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DImode)
       || register_operand (operands[1], V128DImode))) && (
#line 4371 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3279; /* *movv128didi_lra */

    case 84:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4372 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3280; /* *movv256disi_lra */

    case 85:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4372 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3281; /* *movv256didi_lra */

    case 86:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3282; /* *movv512disi_lra */

    case 87:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DImode)
       || register_operand (operands[1], V512DImode))) && (
#line 4373 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3283; /* *movv512didi_lra */

    case 88:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4374 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3284; /* *movv32hfsi_lra */

    case 89:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))) && (
#line 4374 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3285; /* *movv32hfdi_lra */

    case 90:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3286; /* *movv64hfsi_lra */

    case 91:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3287; /* *movv64hfdi_lra */

    case 92:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4376 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3288; /* *movv128hfsi_lra */

    case 93:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128HFmode)
       || register_operand (operands[1], V128HFmode))) && (
#line 4376 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3289; /* *movv128hfdi_lra */

    case 94:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4377 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3290; /* *movv256hfsi_lra */

    case 95:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256HFmode)
       || register_operand (operands[1], V256HFmode))) && (
#line 4377 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3291; /* *movv256hfdi_lra */

    case 96:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4378 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3292; /* *movv512hfsi_lra */

    case 97:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4378 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3293; /* *movv512hfdi_lra */

    case 98:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3294; /* *movv1024hfsi_lra */

    case 99:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024HFmode)
       || register_operand (operands[1], V1024HFmode))) && (
#line 4379 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3295; /* *movv1024hfdi_lra */

    case 100:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4380 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3296; /* *movv2048hfsi_lra */

    case 101:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048HFmode)
       || register_operand (operands[1], V2048HFmode))) && (
#line 4380 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3297; /* *movv2048hfdi_lra */

    case 102:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3298; /* *movv32sfsi_lra */

    case 103:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3299; /* *movv32sfdi_lra */

    case 104:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4382 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3300; /* *movv64sfsi_lra */

    case 105:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64SFmode)
       || register_operand (operands[1], V64SFmode))) && (
#line 4382 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3301; /* *movv64sfdi_lra */

    case 106:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SFmode)
       || register_operand (operands[1], V128SFmode))) && (
#line 4383 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3302; /* *movv128sfsi_lra */

    case 107:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128SFmode)
       || register_operand (operands[1], V128SFmode))) && (
#line 4383 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3303; /* *movv128sfdi_lra */

    case 108:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4384 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3304; /* *movv256sfsi_lra */

    case 109:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4384 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3305; /* *movv256sfdi_lra */

    case 110:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3306; /* *movv512sfsi_lra */

    case 111:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512SFmode)
       || register_operand (operands[1], V512SFmode))) && (
#line 4385 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3307; /* *movv512sfdi_lra */

    case 112:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4386 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3308; /* *movv1024sfsi_lra */

    case 113:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024SFmode)
       || register_operand (operands[1], V1024SFmode))) && (
#line 4386 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3309; /* *movv1024sfdi_lra */

    case 114:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4387 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3310; /* *movv32dfsi_lra */

    case 115:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4387 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3311; /* *movv32dfdi_lra */

    case 116:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4388 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3312; /* *movv64dfsi_lra */

    case 117:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4388 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3313; /* *movv64dfdi_lra */

    case 118:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4389 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3314; /* *movv128dfsi_lra */

    case 119:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128DFmode)
       || register_operand (operands[1], V128DFmode))) && (
#line 4389 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3315; /* *movv128dfdi_lra */

    case 120:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3316; /* *movv256dfsi_lra */

    case 121:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DFmode)
       || register_operand (operands[1], V256DFmode))) && (
#line 4390 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3317; /* *movv256dfdi_lra */

    case 122:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DFmode)
       || register_operand (operands[1], V512DFmode))) && (
#line 4391 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3318; /* *movv512dfsi_lra */

    case 123:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512DFmode)
       || register_operand (operands[1], V512DFmode))) && (
#line 4391 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3319; /* *movv512dfdi_lra */

    case 124:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3320; /* *movv32bisi_lra */

    case 125:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32BImode)
       || register_operand (operands[1], V32BImode))) && (
#line 4393 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3321; /* *movv32bidi_lra */

    case 126:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4394 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3322; /* *movv64bisi_lra */

    case 127:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64BImode)
       || register_operand (operands[1], V64BImode))) && (
#line 4394 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3323; /* *movv64bidi_lra */

    case 128:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3324; /* *movv128bisi_lra */

    case 129:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V128BImode)
       || register_operand (operands[1], V128BImode))) && (
#line 4395 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3325; /* *movv128bidi_lra */

    case 130:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4396 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3326; /* *movv256bisi_lra */

    case 131:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256BImode)
       || register_operand (operands[1], V256BImode))) && (
#line 4396 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3327; /* *movv256bidi_lra */

    case 132:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3328; /* *movv512bisi_lra */

    case 133:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512BImode)
       || register_operand (operands[1], V512BImode))) && (
#line 4397 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3329; /* *movv512bidi_lra */

    case 134:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4398 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3330; /* *movv1024bisi_lra */

    case 135:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V1024BImode)
       || register_operand (operands[1], V1024BImode))) && (
#line 4398 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3331; /* *movv1024bidi_lra */

    case 136:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3332; /* *movv2048bisi_lra */

    case 137:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048BImode)
       || register_operand (operands[1], V2048BImode))) && (
#line 4399 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3333; /* *movv2048bidi_lra */

    case 138:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4400 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        return -1;
      return 3334; /* *movv4096bisi_lra */

    case 139:
      if (!(
#line 1478 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V4096BImode)
       || register_operand (operands[1], V4096BImode))) && (
#line 4400 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096) && 
#line 35 "../../gcc-15.0.1-20250329/gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        return -1;
      return 3335; /* *movv4096bidi_lra */

    default:
      return -1;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern145 (x2))
        {
        case 0:
          if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8132 (insn, operands);

        case 1:
          if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8138 (insn, operands);

        case 2:
          if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8144 (insn, operands);

        case 3:
          if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8150 (insn, operands);

        case 4:
          if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8156 (insn, operands);

        case 5:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8162 (insn, operands);

        case 6:
          if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8168 (insn, operands);

        case 7:
          if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8174 (insn, operands);

        case 8:
          if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8180 (insn, operands);

        case 9:
          if (!(
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8186 (insn, operands);

        case 10:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8192 (insn, operands);

        case 11:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8198 (insn, operands);

        case 12:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8204 (insn, operands);

        case 13:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8210 (insn, operands);

        case 14:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8216 (insn, operands);

        case 15:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8222 (insn, operands);

        case 16:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8228 (insn, operands);

        case 17:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8234 (insn, operands);

        case 18:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8240 (insn, operands);

        case 19:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8246 (insn, operands);

        case 20:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8252 (insn, operands);

        case 21:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8258 (insn, operands);

        case 22:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8264 (insn, operands);

        case 23:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8270 (insn, operands);

        case 24:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8276 (insn, operands);

        case 25:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8282 (insn, operands);

        case 26:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8288 (insn, operands);

        case 27:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8294 (insn, operands);

        case 28:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8300 (insn, operands);

        case 29:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8306 (insn, operands);

        case 30:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8312 (insn, operands);

        case 31:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8318 (insn, operands);

        case 32:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8324 (insn, operands);

        case 33:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8330 (insn, operands);

        case 34:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8336 (insn, operands);

        case 35:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8342 (insn, operands);

        case 36:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8348 (insn, operands);

        case 37:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8354 (insn, operands);

        case 38:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8360 (insn, operands);

        case 39:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8366 (insn, operands);

        case 40:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8372 (insn, operands);

        case 41:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8378 (insn, operands);

        case 42:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8384 (insn, operands);

        case 43:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8390 (insn, operands);

        case 44:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8396 (insn, operands);

        case 45:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8402 (insn, operands);

        case 46:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8408 (insn, operands);

        case 47:
          if (!((
#line 610 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8414 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (pattern153 (x2))
        {
        case 0:
          if (!(
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8612 (insn, operands);

        case 1:
          if (!(
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8614 (insn, operands);

        case 2:
          if (!(
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8616 (insn, operands);

        case 3:
          if (!(
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8618 (insn, operands);

        case 4:
          if (!(
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8620 (insn, operands);

        case 5:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8622 (insn, operands);

        case 6:
          if (!(
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8624 (insn, operands);

        case 7:
          if (!(
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8626 (insn, operands);

        case 8:
          if (!(
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8628 (insn, operands);

        case 9:
          if (!(
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8630 (insn, operands);

        case 10:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8632 (insn, operands);

        case 11:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8634 (insn, operands);

        case 12:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8636 (insn, operands);

        case 13:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8638 (insn, operands);

        case 14:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8640 (insn, operands);

        case 15:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8642 (insn, operands);

        case 16:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8644 (insn, operands);

        case 17:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8646 (insn, operands);

        case 18:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8648 (insn, operands);

        case 19:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8650 (insn, operands);

        case 20:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8652 (insn, operands);

        case 21:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8654 (insn, operands);

        case 22:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8656 (insn, operands);

        case 23:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8658 (insn, operands);

        case 24:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8660 (insn, operands);

        case 25:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8662 (insn, operands);

        case 26:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8664 (insn, operands);

        case 27:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8666 (insn, operands);

        case 28:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8668 (insn, operands);

        case 29:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8670 (insn, operands);

        case 30:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8672 (insn, operands);

        case 31:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8674 (insn, operands);

        case 32:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8676 (insn, operands);

        case 33:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8678 (insn, operands);

        case 34:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8680 (insn, operands);

        case 35:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8682 (insn, operands);

        case 36:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8684 (insn, operands);

        case 37:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8686 (insn, operands);

        case 38:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8688 (insn, operands);

        case 39:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8690 (insn, operands);

        case 40:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8692 (insn, operands);

        case 41:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8694 (insn, operands);

        case 42:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8696 (insn, operands);

        case 43:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8698 (insn, operands);

        case 44:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8700 (insn, operands);

        case 45:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8702 (insn, operands);

        case 46:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8704 (insn, operands);

        case 47:
          if (!((
#line 675 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 677 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8706 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_39 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HImode)
      && reg_or_mem_operand (operands[1], E_V1HImode))
    {
      if ((
#line 99 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return gen_split_257 (insn, operands);
      if (((
#line 1434 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HImode)
       || register_operand (operands[1], V1HImode))) && 
#line 4309 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1441 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1HImode)
       || !register_operand (operands[1], V1HImode)))))
        return gen_split_1952 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1HImode)
      || !register_operand (operands[1], E_V1HImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1511 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2104 (insn, operands);
}

 rtx_insn *
split_45 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16BImode)
      && reg_or_mem_operand (operands[1], E_V16BImode)
      && ((
#line 1434 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))) && 
#line 4344 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1441 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16BImode)
       || !register_operand (operands[1], V16BImode)))))
    return gen_split_1986 (insn, operands);
  if (!register_operand (operands[0], E_V16BImode)
      || !register_operand (operands[1], E_V16BImode)
      || !((
#line 1530 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2174 (insn, operands);
}

 rtx_insn *
split_50 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512DFmode)
      && reg_or_mem_operand (operands[1], E_V512DFmode)
      && (
#line 99 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 304 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return gen_split_322 (insn, operands);
  if (!register_operand (operands[0], E_V512DFmode)
      || !register_operand (operands[1], E_V512DFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2169 (insn, operands);
}

 rtx_insn *
split_55 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1024SFmode)
      && reg_or_mem_operand (operands[1], E_V1024SFmode)
      && (
#line 99 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 294 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return gen_split_312 (insn, operands);
  if (!register_operand (operands[0], E_V1024SFmode)
      || !register_operand (operands[1], E_V1024SFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2159 (insn, operands);
}

 rtx_insn *
split_61 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2048HFmode)
      && reg_or_mem_operand (operands[1], E_V2048HFmode)
      && (
#line 99 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return gen_split_301 (insn, operands);
  if (!register_operand (operands[0], E_V2048HFmode)
      || !register_operand (operands[1], E_V2048HFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2148 (insn, operands);
}

 rtx_insn *
split_67 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32HFmode)
      && reg_or_mem_operand (operands[1], E_V32HFmode)
      && (
#line 99 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return gen_split_295 (insn, operands);
  if (!register_operand (operands[0], E_V32HFmode)
      || !register_operand (operands[1], E_V32HFmode)
      || !((
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2142 (insn, operands);
}

 rtx_insn *
split_73 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1024SImode)
      && reg_or_mem_operand (operands[1], E_V1024SImode)
      && (
#line 99 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return gen_split_279 (insn, operands);
  if (!register_operand (operands[0], E_V1024SImode)
      || !register_operand (operands[1], E_V1024SImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2126 (insn, operands);
}

 rtx_insn *
split_80 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1024HImode)
      && reg_or_mem_operand (operands[1], E_V1024HImode)
      && (
#line 99 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return gen_split_267 (insn, operands);
  if (!register_operand (operands[0], E_V1024HImode)
      || !register_operand (operands[1], E_V1024HImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1511 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2114 (insn, operands);
}

 rtx_insn *
split_87 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2048QImode)
      && reg_or_mem_operand (operands[1], E_V2048QImode)
      && (
#line 99 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return gen_split_255 (insn, operands);
  if (!register_operand (operands[0], E_V2048QImode)
      || !register_operand (operands[1], E_V2048QImode)
      || !((
#line 1509 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1511 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2102 (insn, operands);
}

 rtx_insn *
split_94 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVM1BImode)
      && reg_or_mem_operand (operands[1], E_RVVM1BImode)
      && 
#line 99 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_243 (insn, operands);
  if (!register_operand (operands[0], E_RVVM1BImode)
      || !register_operand (operands[1], E_RVVM1BImode)
      || !(
#line 1294 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1580 (insn, operands);
}

 rtx_insn *
split_101 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2SFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF2SFmode)
      && (
#line 99 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return gen_split_232 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2SFmode)
      || !register_operand (operands[1], E_RVVMF2SFmode)
      || !((
#line 1257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1573 (insn, operands);
}

 rtx_insn *
split_108 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF8QImode)
      && reg_or_mem_operand (operands[1], E_RVVMF8QImode)
      && (
#line 99 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return gen_split_213 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF8QImode)
      || !register_operand (operands[1], E_RVVMF8QImode)
      || !((
#line 1257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1565 (insn, operands);
}

 rtx_insn *
split_116 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4945 (insn, operands);

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4947 (insn, operands);

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4949 (insn, operands);

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4951 (insn, operands);

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4953 (insn, operands);

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4955 (insn, operands);

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4957 (insn, operands);

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4959 (insn, operands);

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4961 (insn, operands);

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4963 (insn, operands);

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4965 (insn, operands);

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !(
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4967 (insn, operands);

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4969 (insn, operands);

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4971 (insn, operands);

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4973 (insn, operands);

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4975 (insn, operands);

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4977 (insn, operands);

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4979 (insn, operands);

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4981 (insn, operands);

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4983 (insn, operands);

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4985 (insn, operands);

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4987 (insn, operands);

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4989 (insn, operands);

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4991 (insn, operands);

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4993 (insn, operands);

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4995 (insn, operands);

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4997 (insn, operands);

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4999 (insn, operands);

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5001 (insn, operands);

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5003 (insn, operands);

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5005 (insn, operands);

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5007 (insn, operands);

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5009 (insn, operands);

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5011 (insn, operands);

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5013 (insn, operands);

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5015 (insn, operands);

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5017 (insn, operands);

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5019 (insn, operands);

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5021 (insn, operands);

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5023 (insn, operands);

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5025 (insn, operands);

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5027 (insn, operands);

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5029 (insn, operands);

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5031 (insn, operands);

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5033 (insn, operands);

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5035 (insn, operands);

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5037 (insn, operands);

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5039 (insn, operands);

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5041 (insn, operands);

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5043 (insn, operands);

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5045 (insn, operands);

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5047 (insn, operands);

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5049 (insn, operands);

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5051 (insn, operands);

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5053 (insn, operands);

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5055 (insn, operands);

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5057 (insn, operands);

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5059 (insn, operands);

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5061 (insn, operands);

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5063 (insn, operands);

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5065 (insn, operands);

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5067 (insn, operands);

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5069 (insn, operands);

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5071 (insn, operands);

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5073 (insn, operands);

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5075 (insn, operands);

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5077 (insn, operands);

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !((
#line 1085 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1087 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5079 (insn, operands);

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5081 (insn, operands);

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5083 (insn, operands);

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5085 (insn, operands);

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5087 (insn, operands);

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5089 (insn, operands);

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5091 (insn, operands);

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5093 (insn, operands);

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5095 (insn, operands);

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5097 (insn, operands);

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5099 (insn, operands);

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5101 (insn, operands);

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5103 (insn, operands);

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5105 (insn, operands);

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5107 (insn, operands);

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5109 (insn, operands);

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5111 (insn, operands);

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5113 (insn, operands);

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5115 (insn, operands);

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5117 (insn, operands);

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5119 (insn, operands);

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5121 (insn, operands);

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5123 (insn, operands);

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5125 (insn, operands);

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5127 (insn, operands);

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5129 (insn, operands);

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5131 (insn, operands);

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5133 (insn, operands);

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5135 (insn, operands);

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5137 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5139 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5141 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5143 (insn, operands);

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5145 (insn, operands);

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5147 (insn, operands);

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5149 (insn, operands);

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5151 (insn, operands);

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5153 (insn, operands);

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5155 (insn, operands);

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5157 (insn, operands);

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5159 (insn, operands);

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5161 (insn, operands);

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5163 (insn, operands);

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5165 (insn, operands);

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5167 (insn, operands);

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5169 (insn, operands);

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5171 (insn, operands);

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5173 (insn, operands);

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !((
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5175 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_125 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_799 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_805 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_811 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_817 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_823 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_829 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_835 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_841 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_847 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_853 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_859 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_865 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_871 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_877 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_883 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_889 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_895 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_901 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_907 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_913 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_919 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_925 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_931 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_937 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_943 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_949 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_955 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_961 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_967 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_973 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_979 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_985 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_991 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_997 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1003 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1009 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1015 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1021 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1027 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1033 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1039 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1045 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1051 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1057 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1063 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1069 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1075 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1081 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1087 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1093 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1099 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1105 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1111 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1117 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1123 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1129 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1135 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1141 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1147 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1153 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1159 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1165 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1171 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1177 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1183 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1189 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1195 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1201 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1207 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1213 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1219 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1225 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1231 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1237 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1243 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1249 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1255 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1261 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1267 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1273 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1279 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1285 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1291 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1297 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1303 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1309 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1315 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1321 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1327 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1333 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1339 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1345 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1351 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1357 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1363 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1369 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1375 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1381 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1387 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1393 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1399 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1405 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1411 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1417 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1423 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1429 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1435 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1441 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1447 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1453 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1459 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1465 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1471 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1477 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1483 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1489 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1495 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1501 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1507 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1513 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1519 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1525 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_133 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern219 (x2))
    {
    case 0:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4027 (insn, operands);

    case 1:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4028 (insn, operands);

    case 2:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4029 (insn, operands);

    case 3:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4030 (insn, operands);

    case 4:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4031 (insn, operands);

    case 5:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4032 (insn, operands);

    case 6:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4033 (insn, operands);

    case 7:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4034 (insn, operands);

    case 8:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4035 (insn, operands);

    case 9:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4036 (insn, operands);

    case 10:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4037 (insn, operands);

    case 11:
      if (!(
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4038 (insn, operands);

    case 12:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4039 (insn, operands);

    case 13:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4040 (insn, operands);

    case 14:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4041 (insn, operands);

    case 15:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4042 (insn, operands);

    case 16:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4043 (insn, operands);

    case 17:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4044 (insn, operands);

    case 18:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4045 (insn, operands);

    case 19:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4046 (insn, operands);

    case 20:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4047 (insn, operands);

    case 21:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4048 (insn, operands);

    case 22:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4049 (insn, operands);

    case 23:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 168 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4050 (insn, operands);

    case 24:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4051 (insn, operands);

    case 25:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4052 (insn, operands);

    case 26:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 171 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4053 (insn, operands);

    case 27:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 172 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4054 (insn, operands);

    case 28:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4055 (insn, operands);

    case 29:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4056 (insn, operands);

    case 30:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4057 (insn, operands);

    case 31:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4058 (insn, operands);

    case 32:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4059 (insn, operands);

    case 33:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4060 (insn, operands);

    case 34:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4061 (insn, operands);

    case 35:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4062 (insn, operands);

    case 36:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4063 (insn, operands);

    case 37:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4064 (insn, operands);

    case 38:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4065 (insn, operands);

    case 39:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4066 (insn, operands);

    case 40:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4067 (insn, operands);

    case 41:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4068 (insn, operands);

    case 42:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4069 (insn, operands);

    case 43:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4070 (insn, operands);

    case 44:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4071 (insn, operands);

    case 45:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4072 (insn, operands);

    case 46:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4073 (insn, operands);

    case 47:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4074 (insn, operands);

    case 48:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4075 (insn, operands);

    case 49:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4076 (insn, operands);

    case 50:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4077 (insn, operands);

    case 51:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4078 (insn, operands);

    case 52:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4079 (insn, operands);

    case 53:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4080 (insn, operands);

    case 54:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4081 (insn, operands);

    case 55:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4082 (insn, operands);

    case 56:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4083 (insn, operands);

    case 57:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4084 (insn, operands);

    case 58:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4085 (insn, operands);

    case 59:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4086 (insn, operands);

    case 60:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4087 (insn, operands);

    case 61:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4088 (insn, operands);

    case 62:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4089 (insn, operands);

    case 63:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4090 (insn, operands);

    case 64:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4091 (insn, operands);

    case 65:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4092 (insn, operands);

    case 66:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4093 (insn, operands);

    case 67:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4094 (insn, operands);

    case 68:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4095 (insn, operands);

    case 69:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4096 (insn, operands);

    case 70:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4097 (insn, operands);

    case 71:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4098 (insn, operands);

    case 72:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4099 (insn, operands);

    case 73:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4100 (insn, operands);

    case 74:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4101 (insn, operands);

    case 75:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4102 (insn, operands);

    case 76:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4103 (insn, operands);

    case 77:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4104 (insn, operands);

    case 78:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4105 (insn, operands);

    case 79:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4106 (insn, operands);

    case 80:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4107 (insn, operands);

    case 81:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4108 (insn, operands);

    case 82:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4109 (insn, operands);

    case 83:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4110 (insn, operands);

    case 84:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4111 (insn, operands);

    case 85:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4112 (insn, operands);

    case 86:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4113 (insn, operands);

    case 87:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4114 (insn, operands);

    case 88:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4115 (insn, operands);

    case 89:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 272 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4116 (insn, operands);

    case 90:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 273 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4117 (insn, operands);

    case 91:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 274 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4118 (insn, operands);

    case 92:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 275 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4119 (insn, operands);

    case 93:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 276 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4120 (insn, operands);

    case 94:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 277 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4121 (insn, operands);

    case 95:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 278 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4122 (insn, operands);

    case 96:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 279 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4123 (insn, operands);

    case 97:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 280 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4124 (insn, operands);

    case 98:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 281 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4125 (insn, operands);

    case 99:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 282 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4126 (insn, operands);

    case 100:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4127 (insn, operands);

    case 101:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 284 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4128 (insn, operands);

    case 102:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4129 (insn, operands);

    case 103:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 286 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4130 (insn, operands);

    case 104:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 287 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4131 (insn, operands);

    case 105:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 288 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4132 (insn, operands);

    case 106:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 289 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4133 (insn, operands);

    case 107:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 290 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4134 (insn, operands);

    case 108:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 291 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4135 (insn, operands);

    case 109:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 292 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4136 (insn, operands);

    case 110:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 293 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4137 (insn, operands);

    case 111:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 294 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4138 (insn, operands);

    case 112:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 295 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4139 (insn, operands);

    case 113:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 296 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4140 (insn, operands);

    case 114:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 297 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4141 (insn, operands);

    case 115:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 298 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4142 (insn, operands);

    case 116:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 299 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4143 (insn, operands);

    case 117:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 300 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4144 (insn, operands);

    case 118:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 301 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4145 (insn, operands);

    case 119:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 302 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4146 (insn, operands);

    case 120:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4147 (insn, operands);

    case 121:
      if (!((
#line 603 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 304 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 605 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4148 (insn, operands);

    case 122:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6314 (insn, operands);

    case 123:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6315 (insn, operands);

    case 124:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6316 (insn, operands);

    case 125:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6317 (insn, operands);

    case 126:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6318 (insn, operands);

    case 127:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6319 (insn, operands);

    case 128:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6320 (insn, operands);

    case 129:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6321 (insn, operands);

    case 130:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6322 (insn, operands);

    case 131:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6323 (insn, operands);

    case 132:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6324 (insn, operands);

    case 133:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6325 (insn, operands);

    case 134:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6326 (insn, operands);

    case 135:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6327 (insn, operands);

    case 136:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6328 (insn, operands);

    case 137:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6329 (insn, operands);

    case 138:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6330 (insn, operands);

    case 139:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6331 (insn, operands);

    case 140:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6332 (insn, operands);

    case 141:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6333 (insn, operands);

    case 142:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6334 (insn, operands);

    case 143:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6335 (insn, operands);

    case 144:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6336 (insn, operands);

    case 145:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6337 (insn, operands);

    case 146:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6338 (insn, operands);

    case 147:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6339 (insn, operands);

    case 148:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6340 (insn, operands);

    case 149:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6341 (insn, operands);

    case 150:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6342 (insn, operands);

    case 151:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6343 (insn, operands);

    case 152:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6344 (insn, operands);

    case 153:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6345 (insn, operands);

    case 154:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6346 (insn, operands);

    case 155:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6347 (insn, operands);

    case 156:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6348 (insn, operands);

    case 157:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6349 (insn, operands);

    case 158:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6350 (insn, operands);

    case 159:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6351 (insn, operands);

    case 160:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6352 (insn, operands);

    case 161:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6353 (insn, operands);

    case 162:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6354 (insn, operands);

    case 163:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6355 (insn, operands);

    case 164:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6356 (insn, operands);

    case 165:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6357 (insn, operands);

    case 166:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6358 (insn, operands);

    case 167:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6359 (insn, operands);

    case 168:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6360 (insn, operands);

    case 169:
      if (!((
#line 107 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 109 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6361 (insn, operands);

    case 170:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6362 (insn, operands);

    case 171:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6363 (insn, operands);

    case 172:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6364 (insn, operands);

    case 173:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6365 (insn, operands);

    case 174:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6366 (insn, operands);

    case 175:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6367 (insn, operands);

    case 176:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6368 (insn, operands);

    case 177:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6369 (insn, operands);

    case 178:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6370 (insn, operands);

    case 179:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6371 (insn, operands);

    case 180:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6372 (insn, operands);

    case 181:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6373 (insn, operands);

    case 182:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6374 (insn, operands);

    case 183:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6375 (insn, operands);

    case 184:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6376 (insn, operands);

    case 185:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6377 (insn, operands);

    case 186:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6378 (insn, operands);

    case 187:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6379 (insn, operands);

    case 188:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6380 (insn, operands);

    case 189:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6381 (insn, operands);

    case 190:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6382 (insn, operands);

    case 191:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6383 (insn, operands);

    case 192:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6384 (insn, operands);

    case 193:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6385 (insn, operands);

    case 194:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6386 (insn, operands);

    case 195:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6387 (insn, operands);

    case 196:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6388 (insn, operands);

    case 197:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6389 (insn, operands);

    case 198:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6390 (insn, operands);

    case 199:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6391 (insn, operands);

    case 200:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6392 (insn, operands);

    case 201:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6393 (insn, operands);

    case 202:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6394 (insn, operands);

    case 203:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6395 (insn, operands);

    case 204:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6396 (insn, operands);

    case 205:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6397 (insn, operands);

    case 206:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6398 (insn, operands);

    case 207:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6399 (insn, operands);

    case 208:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6400 (insn, operands);

    case 209:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6401 (insn, operands);

    case 210:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6402 (insn, operands);

    case 211:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6403 (insn, operands);

    case 212:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6404 (insn, operands);

    case 213:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6405 (insn, operands);

    case 214:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6406 (insn, operands);

    case 215:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6407 (insn, operands);

    case 216:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6408 (insn, operands);

    case 217:
      if (!((
#line 126 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 128 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6409 (insn, operands);

    case 218:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6410 (insn, operands);

    case 219:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6412 (insn, operands);

    case 220:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6414 (insn, operands);

    case 221:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6416 (insn, operands);

    case 222:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6418 (insn, operands);

    case 223:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6420 (insn, operands);

    case 224:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6422 (insn, operands);

    case 225:
      if (!(
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6506 (insn, operands);

    case 226:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6424 (insn, operands);

    case 227:
      if (!(
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6508 (insn, operands);

    case 228:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6426 (insn, operands);

    case 229:
      if (!(
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6510 (insn, operands);

    case 230:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6428 (insn, operands);

    case 231:
      if (!(
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6512 (insn, operands);

    case 232:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6430 (insn, operands);

    case 233:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6514 (insn, operands);

    case 234:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6432 (insn, operands);

    case 235:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6516 (insn, operands);

    case 236:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6566 (insn, operands);

    case 237:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6434 (insn, operands);

    case 238:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6518 (insn, operands);

    case 239:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6568 (insn, operands);

    case 240:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6436 (insn, operands);

    case 241:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6520 (insn, operands);

    case 242:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6570 (insn, operands);

    case 243:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6438 (insn, operands);

    case 244:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6522 (insn, operands);

    case 245:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6572 (insn, operands);

    case 246:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6440 (insn, operands);

    case 247:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6442 (insn, operands);

    case 248:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6444 (insn, operands);

    case 249:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6446 (insn, operands);

    case 250:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6448 (insn, operands);

    case 251:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6450 (insn, operands);

    case 252:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6452 (insn, operands);

    case 253:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6454 (insn, operands);

    case 254:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6456 (insn, operands);

    case 255:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6458 (insn, operands);

    case 256:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6460 (insn, operands);

    case 257:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6462 (insn, operands);

    case 258:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6464 (insn, operands);

    case 259:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6524 (insn, operands);

    case 260:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6466 (insn, operands);

    case 261:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6526 (insn, operands);

    case 262:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6468 (insn, operands);

    case 263:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6528 (insn, operands);

    case 264:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6470 (insn, operands);

    case 265:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6530 (insn, operands);

    case 266:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6472 (insn, operands);

    case 267:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6532 (insn, operands);

    case 268:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6474 (insn, operands);

    case 269:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6534 (insn, operands);

    case 270:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6476 (insn, operands);

    case 271:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6536 (insn, operands);

    case 272:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6478 (insn, operands);

    case 273:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6538 (insn, operands);

    case 274:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6480 (insn, operands);

    case 275:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6540 (insn, operands);

    case 276:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6482 (insn, operands);

    case 277:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6542 (insn, operands);

    case 278:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6484 (insn, operands);

    case 279:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6544 (insn, operands);

    case 280:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6486 (insn, operands);

    case 281:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6546 (insn, operands);

    case 282:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6574 (insn, operands);

    case 283:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6488 (insn, operands);

    case 284:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6548 (insn, operands);

    case 285:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6576 (insn, operands);

    case 286:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6490 (insn, operands);

    case 287:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6550 (insn, operands);

    case 288:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6578 (insn, operands);

    case 289:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6492 (insn, operands);

    case 290:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6552 (insn, operands);

    case 291:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6580 (insn, operands);

    case 292:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6494 (insn, operands);

    case 293:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6554 (insn, operands);

    case 294:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6582 (insn, operands);

    case 295:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6496 (insn, operands);

    case 296:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6556 (insn, operands);

    case 297:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6584 (insn, operands);

    case 298:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6498 (insn, operands);

    case 299:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6558 (insn, operands);

    case 300:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6586 (insn, operands);

    case 301:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6500 (insn, operands);

    case 302:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6560 (insn, operands);

    case 303:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6588 (insn, operands);

    case 304:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6502 (insn, operands);

    case 305:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6562 (insn, operands);

    case 306:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6590 (insn, operands);

    case 307:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6504 (insn, operands);

    case 308:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6564 (insn, operands);

    case 309:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6592 (insn, operands);

    case 310:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6411 (insn, operands);

    case 311:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6413 (insn, operands);

    case 312:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6415 (insn, operands);

    case 313:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6417 (insn, operands);

    case 314:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6419 (insn, operands);

    case 315:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6421 (insn, operands);

    case 316:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6423 (insn, operands);

    case 317:
      if (!(
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6507 (insn, operands);

    case 318:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6425 (insn, operands);

    case 319:
      if (!(
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6509 (insn, operands);

    case 320:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6427 (insn, operands);

    case 321:
      if (!(
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6511 (insn, operands);

    case 322:
      if (!(
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6429 (insn, operands);

    case 323:
      if (!(
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6513 (insn, operands);

    case 324:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6431 (insn, operands);

    case 325:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1106 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6515 (insn, operands);

    case 326:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6433 (insn, operands);

    case 327:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6517 (insn, operands);

    case 328:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6567 (insn, operands);

    case 329:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6435 (insn, operands);

    case 330:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1108 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6519 (insn, operands);

    case 331:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1151 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6569 (insn, operands);

    case 332:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6437 (insn, operands);

    case 333:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6521 (insn, operands);

    case 334:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6571 (insn, operands);

    case 335:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6439 (insn, operands);

    case 336:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1109 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6523 (insn, operands);

    case 337:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1152 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6573 (insn, operands);

    case 338:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6441 (insn, operands);

    case 339:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6443 (insn, operands);

    case 340:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6445 (insn, operands);

    case 341:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6447 (insn, operands);

    case 342:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6449 (insn, operands);

    case 343:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6451 (insn, operands);

    case 344:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6453 (insn, operands);

    case 345:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6455 (insn, operands);

    case 346:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6457 (insn, operands);

    case 347:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6459 (insn, operands);

    case 348:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6461 (insn, operands);

    case 349:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6463 (insn, operands);

    case 350:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6465 (insn, operands);

    case 351:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1111 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6525 (insn, operands);

    case 352:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6467 (insn, operands);

    case 353:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1112 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6527 (insn, operands);

    case 354:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6469 (insn, operands);

    case 355:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1113 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6529 (insn, operands);

    case 356:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6471 (insn, operands);

    case 357:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1114 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6531 (insn, operands);

    case 358:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6473 (insn, operands);

    case 359:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1115 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6533 (insn, operands);

    case 360:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6475 (insn, operands);

    case 361:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1116 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6535 (insn, operands);

    case 362:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6477 (insn, operands);

    case 363:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1117 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6537 (insn, operands);

    case 364:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6479 (insn, operands);

    case 365:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1118 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6539 (insn, operands);

    case 366:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6481 (insn, operands);

    case 367:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1119 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6541 (insn, operands);

    case 368:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6483 (insn, operands);

    case 369:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1120 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6543 (insn, operands);

    case 370:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6485 (insn, operands);

    case 371:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1121 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6545 (insn, operands);

    case 372:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6487 (insn, operands);

    case 373:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1122 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6547 (insn, operands);

    case 374:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1154 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6575 (insn, operands);

    case 375:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6489 (insn, operands);

    case 376:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1123 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6549 (insn, operands);

    case 377:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6577 (insn, operands);

    case 378:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6491 (insn, operands);

    case 379:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1124 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6551 (insn, operands);

    case 380:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6579 (insn, operands);

    case 381:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6493 (insn, operands);

    case 382:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1125 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6553 (insn, operands);

    case 383:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6581 (insn, operands);

    case 384:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6495 (insn, operands);

    case 385:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1126 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6555 (insn, operands);

    case 386:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1158 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6583 (insn, operands);

    case 387:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6497 (insn, operands);

    case 388:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1127 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6557 (insn, operands);

    case 389:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6585 (insn, operands);

    case 390:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6499 (insn, operands);

    case 391:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1128 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6559 (insn, operands);

    case 392:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6587 (insn, operands);

    case 393:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6501 (insn, operands);

    case 394:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1129 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6561 (insn, operands);

    case 395:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1161 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6589 (insn, operands);

    case 396:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6503 (insn, operands);

    case 397:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1130 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6563 (insn, operands);

    case 398:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6591 (insn, operands);

    case 399:
      if (!((
#line 144 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 146 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6505 (insn, operands);

    case 400:
      if (!((
#line 164 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1131 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 166 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6565 (insn, operands);

    case 401:
      if (!((
#line 184 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 186 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6593 (insn, operands);

    case 402:
      if (!(
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6778 (insn, operands);

    case 403:
      if (!(
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6779 (insn, operands);

    case 404:
      if (!(
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6780 (insn, operands);

    case 405:
      if (!(
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6781 (insn, operands);

    case 406:
      if (!(
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6782 (insn, operands);

    case 407:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6783 (insn, operands);

    case 408:
      if (!(
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6784 (insn, operands);

    case 409:
      if (!(
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6785 (insn, operands);

    case 410:
      if (!(
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6786 (insn, operands);

    case 411:
      if (!(
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6787 (insn, operands);

    case 412:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6788 (insn, operands);

    case 413:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6789 (insn, operands);

    case 414:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6790 (insn, operands);

    case 415:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6791 (insn, operands);

    case 416:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6792 (insn, operands);

    case 417:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6793 (insn, operands);

    case 418:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6794 (insn, operands);

    case 419:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6795 (insn, operands);

    case 420:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6796 (insn, operands);

    case 421:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6797 (insn, operands);

    case 422:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6798 (insn, operands);

    case 423:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6799 (insn, operands);

    case 424:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6800 (insn, operands);

    case 425:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6801 (insn, operands);

    case 426:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6802 (insn, operands);

    case 427:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6803 (insn, operands);

    case 428:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6804 (insn, operands);

    case 429:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6805 (insn, operands);

    case 430:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6806 (insn, operands);

    case 431:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6807 (insn, operands);

    case 432:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6808 (insn, operands);

    case 433:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6809 (insn, operands);

    case 434:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6810 (insn, operands);

    case 435:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6811 (insn, operands);

    case 436:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6812 (insn, operands);

    case 437:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6813 (insn, operands);

    case 438:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6814 (insn, operands);

    case 439:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6815 (insn, operands);

    case 440:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6816 (insn, operands);

    case 441:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6817 (insn, operands);

    case 442:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6818 (insn, operands);

    case 443:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6819 (insn, operands);

    case 444:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6820 (insn, operands);

    case 445:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6821 (insn, operands);

    case 446:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6822 (insn, operands);

    case 447:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6823 (insn, operands);

    case 448:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6824 (insn, operands);

    case 449:
      if (!((
#line 283 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 285 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6825 (insn, operands);

    case 450:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7420 (insn, operands);

    case 451:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7424 (insn, operands);

    case 452:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7428 (insn, operands);

    case 453:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7432 (insn, operands);

    case 454:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7436 (insn, operands);

    case 455:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7440 (insn, operands);

    case 456:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7444 (insn, operands);

    case 457:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7448 (insn, operands);

    case 458:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7452 (insn, operands);

    case 459:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7456 (insn, operands);

    case 460:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7460 (insn, operands);

    case 461:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7464 (insn, operands);

    case 462:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7468 (insn, operands);

    case 463:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7472 (insn, operands);

    case 464:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7476 (insn, operands);

    case 465:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7480 (insn, operands);

    case 466:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7484 (insn, operands);

    case 467:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7488 (insn, operands);

    case 468:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7492 (insn, operands);

    case 469:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7496 (insn, operands);

    case 470:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7500 (insn, operands);

    case 471:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7504 (insn, operands);

    case 472:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7508 (insn, operands);

    case 473:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7512 (insn, operands);

    case 474:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7516 (insn, operands);

    case 475:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7520 (insn, operands);

    case 476:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7524 (insn, operands);

    case 477:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7528 (insn, operands);

    case 478:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7532 (insn, operands);

    case 479:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7536 (insn, operands);

    case 480:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7540 (insn, operands);

    case 481:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7544 (insn, operands);

    case 482:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7548 (insn, operands);

    case 483:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7552 (insn, operands);

    case 484:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7556 (insn, operands);

    case 485:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7560 (insn, operands);

    case 486:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7564 (insn, operands);

    case 487:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7568 (insn, operands);

    case 488:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7572 (insn, operands);

    case 489:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7576 (insn, operands);

    case 490:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7580 (insn, operands);

    case 491:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7584 (insn, operands);

    case 492:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7588 (insn, operands);

    case 493:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7592 (insn, operands);

    case 494:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7596 (insn, operands);

    case 495:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7600 (insn, operands);

    case 496:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7604 (insn, operands);

    case 497:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7608 (insn, operands);

    case 498:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7422 (insn, operands);

    case 499:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7426 (insn, operands);

    case 500:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7430 (insn, operands);

    case 501:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7434 (insn, operands);

    case 502:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7438 (insn, operands);

    case 503:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7442 (insn, operands);

    case 504:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7446 (insn, operands);

    case 505:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7450 (insn, operands);

    case 506:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7454 (insn, operands);

    case 507:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7458 (insn, operands);

    case 508:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7462 (insn, operands);

    case 509:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7466 (insn, operands);

    case 510:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7470 (insn, operands);

    case 511:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7474 (insn, operands);

    case 512:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7478 (insn, operands);

    case 513:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7482 (insn, operands);

    case 514:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7486 (insn, operands);

    case 515:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7490 (insn, operands);

    case 516:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7494 (insn, operands);

    case 517:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7498 (insn, operands);

    case 518:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7502 (insn, operands);

    case 519:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7506 (insn, operands);

    case 520:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7510 (insn, operands);

    case 521:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7514 (insn, operands);

    case 522:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7518 (insn, operands);

    case 523:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7522 (insn, operands);

    case 524:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7526 (insn, operands);

    case 525:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7530 (insn, operands);

    case 526:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7534 (insn, operands);

    case 527:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7538 (insn, operands);

    case 528:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7542 (insn, operands);

    case 529:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7546 (insn, operands);

    case 530:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7550 (insn, operands);

    case 531:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7554 (insn, operands);

    case 532:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7558 (insn, operands);

    case 533:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7562 (insn, operands);

    case 534:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7566 (insn, operands);

    case 535:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7570 (insn, operands);

    case 536:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7574 (insn, operands);

    case 537:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7578 (insn, operands);

    case 538:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7582 (insn, operands);

    case 539:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7586 (insn, operands);

    case 540:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7590 (insn, operands);

    case 541:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7594 (insn, operands);

    case 542:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7598 (insn, operands);

    case 543:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7602 (insn, operands);

    case 544:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7606 (insn, operands);

    case 545:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7610 (insn, operands);

    case 546:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7612 (insn, operands);

    case 547:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7614 (insn, operands);

    case 548:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7616 (insn, operands);

    case 549:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7618 (insn, operands);

    case 550:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7620 (insn, operands);

    case 551:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7622 (insn, operands);

    case 552:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7624 (insn, operands);

    case 553:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7626 (insn, operands);

    case 554:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7628 (insn, operands);

    case 555:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7630 (insn, operands);

    case 556:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7632 (insn, operands);

    case 557:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7634 (insn, operands);

    case 558:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7636 (insn, operands);

    case 559:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7638 (insn, operands);

    case 560:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7640 (insn, operands);

    case 561:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7642 (insn, operands);

    case 562:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7644 (insn, operands);

    case 563:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7646 (insn, operands);

    case 564:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7648 (insn, operands);

    case 565:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7650 (insn, operands);

    case 566:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7652 (insn, operands);

    case 567:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7654 (insn, operands);

    case 568:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7656 (insn, operands);

    case 569:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7658 (insn, operands);

    case 570:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7660 (insn, operands);

    case 571:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7662 (insn, operands);

    case 572:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7664 (insn, operands);

    case 573:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7666 (insn, operands);

    case 574:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7668 (insn, operands);

    case 575:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7670 (insn, operands);

    case 576:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7672 (insn, operands);

    case 577:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7674 (insn, operands);

    case 578:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7676 (insn, operands);

    case 579:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7678 (insn, operands);

    case 580:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7680 (insn, operands);

    case 581:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7682 (insn, operands);

    case 582:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7684 (insn, operands);

    case 583:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7686 (insn, operands);

    case 584:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7688 (insn, operands);

    case 585:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7690 (insn, operands);

    case 586:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7692 (insn, operands);

    case 587:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7694 (insn, operands);

    case 588:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7696 (insn, operands);

    case 589:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7698 (insn, operands);

    case 590:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7700 (insn, operands);

    case 591:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7702 (insn, operands);

    case 592:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7704 (insn, operands);

    case 593:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7706 (insn, operands);

    case 594:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7421 (insn, operands);

    case 595:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7425 (insn, operands);

    case 596:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7429 (insn, operands);

    case 597:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7433 (insn, operands);

    case 598:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7437 (insn, operands);

    case 599:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7441 (insn, operands);

    case 600:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7445 (insn, operands);

    case 601:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7449 (insn, operands);

    case 602:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7453 (insn, operands);

    case 603:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7457 (insn, operands);

    case 604:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7461 (insn, operands);

    case 605:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7465 (insn, operands);

    case 606:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7469 (insn, operands);

    case 607:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7473 (insn, operands);

    case 608:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7477 (insn, operands);

    case 609:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7481 (insn, operands);

    case 610:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7485 (insn, operands);

    case 611:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7489 (insn, operands);

    case 612:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7493 (insn, operands);

    case 613:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7497 (insn, operands);

    case 614:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7501 (insn, operands);

    case 615:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7505 (insn, operands);

    case 616:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7509 (insn, operands);

    case 617:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7513 (insn, operands);

    case 618:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7517 (insn, operands);

    case 619:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7521 (insn, operands);

    case 620:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7525 (insn, operands);

    case 621:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7529 (insn, operands);

    case 622:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7533 (insn, operands);

    case 623:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7537 (insn, operands);

    case 624:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7541 (insn, operands);

    case 625:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7545 (insn, operands);

    case 626:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7549 (insn, operands);

    case 627:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7553 (insn, operands);

    case 628:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7557 (insn, operands);

    case 629:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7561 (insn, operands);

    case 630:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7565 (insn, operands);

    case 631:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7569 (insn, operands);

    case 632:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7573 (insn, operands);

    case 633:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7577 (insn, operands);

    case 634:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7581 (insn, operands);

    case 635:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7585 (insn, operands);

    case 636:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7589 (insn, operands);

    case 637:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7593 (insn, operands);

    case 638:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7597 (insn, operands);

    case 639:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7601 (insn, operands);

    case 640:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7605 (insn, operands);

    case 641:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7609 (insn, operands);

    case 642:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7423 (insn, operands);

    case 643:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7427 (insn, operands);

    case 644:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7431 (insn, operands);

    case 645:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7435 (insn, operands);

    case 646:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7439 (insn, operands);

    case 647:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7443 (insn, operands);

    case 648:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7447 (insn, operands);

    case 649:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7451 (insn, operands);

    case 650:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7455 (insn, operands);

    case 651:
      if (!(
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7459 (insn, operands);

    case 652:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7463 (insn, operands);

    case 653:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7467 (insn, operands);

    case 654:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7471 (insn, operands);

    case 655:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7475 (insn, operands);

    case 656:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7479 (insn, operands);

    case 657:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7483 (insn, operands);

    case 658:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7487 (insn, operands);

    case 659:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7491 (insn, operands);

    case 660:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7495 (insn, operands);

    case 661:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7499 (insn, operands);

    case 662:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7503 (insn, operands);

    case 663:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7507 (insn, operands);

    case 664:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7511 (insn, operands);

    case 665:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7515 (insn, operands);

    case 666:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7519 (insn, operands);

    case 667:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7523 (insn, operands);

    case 668:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7527 (insn, operands);

    case 669:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7531 (insn, operands);

    case 670:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7535 (insn, operands);

    case 671:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7539 (insn, operands);

    case 672:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7543 (insn, operands);

    case 673:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7547 (insn, operands);

    case 674:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7551 (insn, operands);

    case 675:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7555 (insn, operands);

    case 676:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7559 (insn, operands);

    case 677:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7563 (insn, operands);

    case 678:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7567 (insn, operands);

    case 679:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7571 (insn, operands);

    case 680:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7575 (insn, operands);

    case 681:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7579 (insn, operands);

    case 682:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7583 (insn, operands);

    case 683:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7587 (insn, operands);

    case 684:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7591 (insn, operands);

    case 685:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7595 (insn, operands);

    case 686:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7599 (insn, operands);

    case 687:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7603 (insn, operands);

    case 688:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7607 (insn, operands);

    case 689:
      if (!((
#line 500 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7611 (insn, operands);

    case 690:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7613 (insn, operands);

    case 691:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7615 (insn, operands);

    case 692:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7617 (insn, operands);

    case 693:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7619 (insn, operands);

    case 694:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7621 (insn, operands);

    case 695:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7623 (insn, operands);

    case 696:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7625 (insn, operands);

    case 697:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7627 (insn, operands);

    case 698:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7629 (insn, operands);

    case 699:
      if (!(
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7631 (insn, operands);

    case 700:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7633 (insn, operands);

    case 701:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7635 (insn, operands);

    case 702:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7637 (insn, operands);

    case 703:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7639 (insn, operands);

    case 704:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7641 (insn, operands);

    case 705:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7643 (insn, operands);

    case 706:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7645 (insn, operands);

    case 707:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7647 (insn, operands);

    case 708:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7649 (insn, operands);

    case 709:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7651 (insn, operands);

    case 710:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7653 (insn, operands);

    case 711:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7655 (insn, operands);

    case 712:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7657 (insn, operands);

    case 713:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7659 (insn, operands);

    case 714:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7661 (insn, operands);

    case 715:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7663 (insn, operands);

    case 716:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7665 (insn, operands);

    case 717:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7667 (insn, operands);

    case 718:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7669 (insn, operands);

    case 719:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7671 (insn, operands);

    case 720:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7673 (insn, operands);

    case 721:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7675 (insn, operands);

    case 722:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7677 (insn, operands);

    case 723:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7679 (insn, operands);

    case 724:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7681 (insn, operands);

    case 725:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7683 (insn, operands);

    case 726:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7685 (insn, operands);

    case 727:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7687 (insn, operands);

    case 728:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7689 (insn, operands);

    case 729:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7691 (insn, operands);

    case 730:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7693 (insn, operands);

    case 731:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7695 (insn, operands);

    case 732:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7697 (insn, operands);

    case 733:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7699 (insn, operands);

    case 734:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7701 (insn, operands);

    case 735:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7703 (insn, operands);

    case 736:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7705 (insn, operands);

    case 737:
      if (!((
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7707 (insn, operands);

    case 738:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6826 (insn, operands);

    case 739:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6827 (insn, operands);

    case 740:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6828 (insn, operands);

    case 741:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6829 (insn, operands);

    case 742:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6830 (insn, operands);

    case 743:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6831 (insn, operands);

    case 744:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6832 (insn, operands);

    case 745:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6833 (insn, operands);

    case 746:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6834 (insn, operands);

    case 747:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6835 (insn, operands);

    case 748:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6836 (insn, operands);

    case 749:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6837 (insn, operands);

    case 750:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6838 (insn, operands);

    case 751:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6839 (insn, operands);

    case 752:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6840 (insn, operands);

    case 753:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6841 (insn, operands);

    case 754:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6842 (insn, operands);

    case 755:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6843 (insn, operands);

    case 756:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6844 (insn, operands);

    case 757:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6845 (insn, operands);

    case 758:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6846 (insn, operands);

    case 759:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6847 (insn, operands);

    case 760:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6848 (insn, operands);

    case 761:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6849 (insn, operands);

    case 762:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6850 (insn, operands);

    case 763:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6851 (insn, operands);

    case 764:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6852 (insn, operands);

    case 765:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6853 (insn, operands);

    case 766:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6854 (insn, operands);

    case 767:
      if (!((
#line 303 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 305 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6855 (insn, operands);

    case 768:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6886 (insn, operands);

    case 769:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6887 (insn, operands);

    case 770:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6888 (insn, operands);

    case 771:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6889 (insn, operands);

    case 772:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6890 (insn, operands);

    case 773:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6891 (insn, operands);

    case 774:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6892 (insn, operands);

    case 775:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6893 (insn, operands);

    case 776:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6894 (insn, operands);

    case 777:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6895 (insn, operands);

    case 778:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6896 (insn, operands);

    case 779:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6897 (insn, operands);

    case 780:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6898 (insn, operands);

    case 781:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6899 (insn, operands);

    case 782:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6900 (insn, operands);

    case 783:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6901 (insn, operands);

    case 784:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6902 (insn, operands);

    case 785:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6903 (insn, operands);

    case 786:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6904 (insn, operands);

    case 787:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6905 (insn, operands);

    case 788:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6906 (insn, operands);

    case 789:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6907 (insn, operands);

    case 790:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6908 (insn, operands);

    case 791:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6909 (insn, operands);

    case 792:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6910 (insn, operands);

    case 793:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6911 (insn, operands);

    case 794:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6912 (insn, operands);

    case 795:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6913 (insn, operands);

    case 796:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6914 (insn, operands);

    case 797:
      if (!((
#line 350 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 352 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6915 (insn, operands);

    case 798:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6916 (insn, operands);

    case 799:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6918 (insn, operands);

    case 800:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7276 (insn, operands);

    case 801:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6920 (insn, operands);

    case 802:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7278 (insn, operands);

    case 803:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6922 (insn, operands);

    case 804:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7280 (insn, operands);

    case 805:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6924 (insn, operands);

    case 806:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7282 (insn, operands);

    case 807:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6926 (insn, operands);

    case 808:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7284 (insn, operands);

    case 809:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6928 (insn, operands);

    case 810:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7108 (insn, operands);

    case 811:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6930 (insn, operands);

    case 812:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7110 (insn, operands);

    case 813:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7286 (insn, operands);

    case 814:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6932 (insn, operands);

    case 815:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7112 (insn, operands);

    case 816:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7288 (insn, operands);

    case 817:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6934 (insn, operands);

    case 818:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7114 (insn, operands);

    case 819:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7290 (insn, operands);

    case 820:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6936 (insn, operands);

    case 821:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7116 (insn, operands);

    case 822:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7292 (insn, operands);

    case 823:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6938 (insn, operands);

    case 824:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7118 (insn, operands);

    case 825:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6940 (insn, operands);

    case 826:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7120 (insn, operands);

    case 827:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6942 (insn, operands);

    case 828:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7122 (insn, operands);

    case 829:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6944 (insn, operands);

    case 830:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7124 (insn, operands);

    case 831:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6946 (insn, operands);

    case 832:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7318 (insn, operands);

    case 833:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6948 (insn, operands);

    case 834:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7320 (insn, operands);

    case 835:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6950 (insn, operands);

    case 836:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7322 (insn, operands);

    case 837:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6952 (insn, operands);

    case 838:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7324 (insn, operands);

    case 839:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6954 (insn, operands);

    case 840:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7326 (insn, operands);

    case 841:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6956 (insn, operands);

    case 842:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7328 (insn, operands);

    case 843:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6958 (insn, operands);

    case 844:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7330 (insn, operands);

    case 845:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6960 (insn, operands);

    case 846:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7332 (insn, operands);

    case 847:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6962 (insn, operands);

    case 848:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7334 (insn, operands);

    case 849:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6964 (insn, operands);

    case 850:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7336 (insn, operands);

    case 851:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6966 (insn, operands);

    case 852:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7338 (insn, operands);

    case 853:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6968 (insn, operands);

    case 854:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6970 (insn, operands);

    case 855:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7126 (insn, operands);

    case 856:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7340 (insn, operands);

    case 857:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6972 (insn, operands);

    case 858:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7128 (insn, operands);

    case 859:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7342 (insn, operands);

    case 860:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6974 (insn, operands);

    case 861:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7130 (insn, operands);

    case 862:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7344 (insn, operands);

    case 863:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6976 (insn, operands);

    case 864:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7132 (insn, operands);

    case 865:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7346 (insn, operands);

    case 866:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6978 (insn, operands);

    case 867:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7134 (insn, operands);

    case 868:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7348 (insn, operands);

    case 869:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6980 (insn, operands);

    case 870:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7136 (insn, operands);

    case 871:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7350 (insn, operands);

    case 872:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6982 (insn, operands);

    case 873:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7138 (insn, operands);

    case 874:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7352 (insn, operands);

    case 875:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6984 (insn, operands);

    case 876:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7140 (insn, operands);

    case 877:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7354 (insn, operands);

    case 878:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6986 (insn, operands);

    case 879:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7142 (insn, operands);

    case 880:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7356 (insn, operands);

    case 881:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6988 (insn, operands);

    case 882:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7144 (insn, operands);

    case 883:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7358 (insn, operands);

    case 884:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6990 (insn, operands);

    case 885:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7146 (insn, operands);

    case 886:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6992 (insn, operands);

    case 887:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7148 (insn, operands);

    case 888:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6994 (insn, operands);

    case 889:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7150 (insn, operands);

    case 890:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6996 (insn, operands);

    case 891:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7152 (insn, operands);

    case 892:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6998 (insn, operands);

    case 893:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7154 (insn, operands);

    case 894:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7000 (insn, operands);

    case 895:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7156 (insn, operands);

    case 896:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7002 (insn, operands);

    case 897:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7158 (insn, operands);

    case 898:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7004 (insn, operands);

    case 899:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7160 (insn, operands);

    case 900:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7006 (insn, operands);

    case 901:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7162 (insn, operands);

    case 902:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7008 (insn, operands);

    case 903:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7164 (insn, operands);

    case 904:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7010 (insn, operands);

    case 905:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7166 (insn, operands);

    case 906:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7264 (insn, operands);

    case 907:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7266 (insn, operands);

    case 908:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7268 (insn, operands);

    case 909:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7270 (insn, operands);

    case 910:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7272 (insn, operands);

    case 911:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7274 (insn, operands);

    case 912:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7294 (insn, operands);

    case 913:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7296 (insn, operands);

    case 914:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7298 (insn, operands);

    case 915:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7300 (insn, operands);

    case 916:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7302 (insn, operands);

    case 917:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7304 (insn, operands);

    case 918:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7306 (insn, operands);

    case 919:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7308 (insn, operands);

    case 920:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7310 (insn, operands);

    case 921:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7312 (insn, operands);

    case 922:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7314 (insn, operands);

    case 923:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7316 (insn, operands);

    case 924:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6917 (insn, operands);

    case 925:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6919 (insn, operands);

    case 926:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7277 (insn, operands);

    case 927:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6921 (insn, operands);

    case 928:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7279 (insn, operands);

    case 929:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6923 (insn, operands);

    case 930:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7281 (insn, operands);

    case 931:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6925 (insn, operands);

    case 932:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7283 (insn, operands);

    case 933:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6927 (insn, operands);

    case 934:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7285 (insn, operands);

    case 935:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6929 (insn, operands);

    case 936:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7109 (insn, operands);

    case 937:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6931 (insn, operands);

    case 938:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7111 (insn, operands);

    case 939:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7287 (insn, operands);

    case 940:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6933 (insn, operands);

    case 941:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7113 (insn, operands);

    case 942:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7289 (insn, operands);

    case 943:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6935 (insn, operands);

    case 944:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7115 (insn, operands);

    case 945:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7291 (insn, operands);

    case 946:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6937 (insn, operands);

    case 947:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7117 (insn, operands);

    case 948:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7293 (insn, operands);

    case 949:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6939 (insn, operands);

    case 950:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7119 (insn, operands);

    case 951:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6941 (insn, operands);

    case 952:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7121 (insn, operands);

    case 953:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6943 (insn, operands);

    case 954:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7123 (insn, operands);

    case 955:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6945 (insn, operands);

    case 956:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7125 (insn, operands);

    case 957:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6947 (insn, operands);

    case 958:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7319 (insn, operands);

    case 959:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6949 (insn, operands);

    case 960:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7321 (insn, operands);

    case 961:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6951 (insn, operands);

    case 962:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7323 (insn, operands);

    case 963:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6953 (insn, operands);

    case 964:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7325 (insn, operands);

    case 965:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6955 (insn, operands);

    case 966:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7327 (insn, operands);

    case 967:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6957 (insn, operands);

    case 968:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7329 (insn, operands);

    case 969:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6959 (insn, operands);

    case 970:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7331 (insn, operands);

    case 971:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6961 (insn, operands);

    case 972:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7333 (insn, operands);

    case 973:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6963 (insn, operands);

    case 974:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7335 (insn, operands);

    case 975:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6965 (insn, operands);

    case 976:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7337 (insn, operands);

    case 977:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6967 (insn, operands);

    case 978:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7339 (insn, operands);

    case 979:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6969 (insn, operands);

    case 980:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6971 (insn, operands);

    case 981:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7127 (insn, operands);

    case 982:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7341 (insn, operands);

    case 983:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6973 (insn, operands);

    case 984:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7129 (insn, operands);

    case 985:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7343 (insn, operands);

    case 986:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6975 (insn, operands);

    case 987:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7131 (insn, operands);

    case 988:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7345 (insn, operands);

    case 989:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6977 (insn, operands);

    case 990:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7133 (insn, operands);

    case 991:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7347 (insn, operands);

    case 992:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6979 (insn, operands);

    case 993:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7135 (insn, operands);

    case 994:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7349 (insn, operands);

    case 995:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6981 (insn, operands);

    case 996:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7137 (insn, operands);

    case 997:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7351 (insn, operands);

    case 998:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6983 (insn, operands);

    case 999:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7139 (insn, operands);

    case 1000:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7353 (insn, operands);

    case 1001:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6985 (insn, operands);

    case 1002:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7141 (insn, operands);

    case 1003:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7355 (insn, operands);

    case 1004:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6987 (insn, operands);

    case 1005:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7143 (insn, operands);

    case 1006:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7357 (insn, operands);

    case 1007:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6989 (insn, operands);

    case 1008:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7145 (insn, operands);

    case 1009:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7359 (insn, operands);

    case 1010:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6991 (insn, operands);

    case 1011:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7147 (insn, operands);

    case 1012:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6993 (insn, operands);

    case 1013:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7149 (insn, operands);

    case 1014:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6995 (insn, operands);

    case 1015:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7151 (insn, operands);

    case 1016:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6997 (insn, operands);

    case 1017:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7153 (insn, operands);

    case 1018:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6999 (insn, operands);

    case 1019:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7155 (insn, operands);

    case 1020:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7001 (insn, operands);

    case 1021:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7157 (insn, operands);

    case 1022:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7003 (insn, operands);

    case 1023:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7159 (insn, operands);

    case 1024:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7005 (insn, operands);

    case 1025:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7161 (insn, operands);

    case 1026:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7007 (insn, operands);

    case 1027:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7163 (insn, operands);

    case 1028:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7009 (insn, operands);

    case 1029:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7165 (insn, operands);

    case 1030:
      if (!((
#line 371 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 373 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7011 (insn, operands);

    case 1031:
      if (!((
#line 413 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 415 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7167 (insn, operands);

    case 1032:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7265 (insn, operands);

    case 1033:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7267 (insn, operands);

    case 1034:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7269 (insn, operands);

    case 1035:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7271 (insn, operands);

    case 1036:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7273 (insn, operands);

    case 1037:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7275 (insn, operands);

    case 1038:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7295 (insn, operands);

    case 1039:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7297 (insn, operands);

    case 1040:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7299 (insn, operands);

    case 1041:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7301 (insn, operands);

    case 1042:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7303 (insn, operands);

    case 1043:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7305 (insn, operands);

    case 1044:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7307 (insn, operands);

    case 1045:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7309 (insn, operands);

    case 1046:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7311 (insn, operands);

    case 1047:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7313 (insn, operands);

    case 1048:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7315 (insn, operands);

    case 1049:
      if (!((
#line 455 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 457 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7317 (insn, operands);

    case 1050:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7012 (insn, operands);

    case 1051:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7168 (insn, operands);

    case 1052:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7014 (insn, operands);

    case 1053:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7170 (insn, operands);

    case 1054:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7360 (insn, operands);

    case 1055:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7016 (insn, operands);

    case 1056:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7172 (insn, operands);

    case 1057:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7362 (insn, operands);

    case 1058:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7018 (insn, operands);

    case 1059:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7174 (insn, operands);

    case 1060:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7364 (insn, operands);

    case 1061:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7020 (insn, operands);

    case 1062:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7176 (insn, operands);

    case 1063:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7366 (insn, operands);

    case 1064:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7022 (insn, operands);

    case 1065:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7178 (insn, operands);

    case 1066:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7368 (insn, operands);

    case 1067:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7024 (insn, operands);

    case 1068:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7180 (insn, operands);

    case 1069:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7026 (insn, operands);

    case 1070:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7182 (insn, operands);

    case 1071:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7370 (insn, operands);

    case 1072:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7028 (insn, operands);

    case 1073:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7184 (insn, operands);

    case 1074:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7372 (insn, operands);

    case 1075:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7030 (insn, operands);

    case 1076:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7186 (insn, operands);

    case 1077:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7374 (insn, operands);

    case 1078:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7032 (insn, operands);

    case 1079:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7188 (insn, operands);

    case 1080:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7376 (insn, operands);

    case 1081:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7034 (insn, operands);

    case 1082:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7190 (insn, operands);

    case 1083:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7036 (insn, operands);

    case 1084:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7192 (insn, operands);

    case 1085:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7038 (insn, operands);

    case 1086:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7194 (insn, operands);

    case 1087:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7040 (insn, operands);

    case 1088:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7196 (insn, operands);

    case 1089:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7042 (insn, operands);

    case 1090:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7198 (insn, operands);

    case 1091:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7378 (insn, operands);

    case 1092:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7044 (insn, operands);

    case 1093:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7200 (insn, operands);

    case 1094:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7380 (insn, operands);

    case 1095:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7046 (insn, operands);

    case 1096:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7202 (insn, operands);

    case 1097:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7382 (insn, operands);

    case 1098:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7048 (insn, operands);

    case 1099:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7204 (insn, operands);

    case 1100:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7384 (insn, operands);

    case 1101:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7050 (insn, operands);

    case 1102:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7206 (insn, operands);

    case 1103:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7386 (insn, operands);

    case 1104:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7052 (insn, operands);

    case 1105:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7208 (insn, operands);

    case 1106:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7388 (insn, operands);

    case 1107:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7054 (insn, operands);

    case 1108:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7210 (insn, operands);

    case 1109:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7390 (insn, operands);

    case 1110:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7056 (insn, operands);

    case 1111:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7212 (insn, operands);

    case 1112:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7392 (insn, operands);

    case 1113:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7058 (insn, operands);

    case 1114:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7214 (insn, operands);

    case 1115:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7394 (insn, operands);

    case 1116:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7060 (insn, operands);

    case 1117:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7216 (insn, operands);

    case 1118:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7396 (insn, operands);

    case 1119:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7062 (insn, operands);

    case 1120:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7218 (insn, operands);

    case 1121:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7398 (insn, operands);

    case 1122:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7064 (insn, operands);

    case 1123:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7220 (insn, operands);

    case 1124:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7066 (insn, operands);

    case 1125:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7222 (insn, operands);

    case 1126:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7400 (insn, operands);

    case 1127:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7068 (insn, operands);

    case 1128:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7224 (insn, operands);

    case 1129:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7402 (insn, operands);

    case 1130:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7070 (insn, operands);

    case 1131:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7226 (insn, operands);

    case 1132:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7404 (insn, operands);

    case 1133:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7072 (insn, operands);

    case 1134:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7228 (insn, operands);

    case 1135:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7406 (insn, operands);

    case 1136:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7074 (insn, operands);

    case 1137:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7230 (insn, operands);

    case 1138:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7408 (insn, operands);

    case 1139:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7076 (insn, operands);

    case 1140:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7232 (insn, operands);

    case 1141:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7410 (insn, operands);

    case 1142:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7078 (insn, operands);

    case 1143:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7234 (insn, operands);

    case 1144:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7412 (insn, operands);

    case 1145:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7080 (insn, operands);

    case 1146:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7236 (insn, operands);

    case 1147:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7414 (insn, operands);

    case 1148:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7082 (insn, operands);

    case 1149:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7238 (insn, operands);

    case 1150:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7416 (insn, operands);

    case 1151:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7084 (insn, operands);

    case 1152:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7240 (insn, operands);

    case 1153:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7418 (insn, operands);

    case 1154:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7086 (insn, operands);

    case 1155:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7242 (insn, operands);

    case 1156:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7088 (insn, operands);

    case 1157:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7244 (insn, operands);

    case 1158:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7090 (insn, operands);

    case 1159:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7246 (insn, operands);

    case 1160:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7092 (insn, operands);

    case 1161:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7248 (insn, operands);

    case 1162:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7094 (insn, operands);

    case 1163:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7250 (insn, operands);

    case 1164:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7096 (insn, operands);

    case 1165:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7252 (insn, operands);

    case 1166:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7098 (insn, operands);

    case 1167:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7254 (insn, operands);

    case 1168:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7100 (insn, operands);

    case 1169:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7256 (insn, operands);

    case 1170:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7102 (insn, operands);

    case 1171:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7258 (insn, operands);

    case 1172:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7104 (insn, operands);

    case 1173:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7260 (insn, operands);

    case 1174:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7106 (insn, operands);

    case 1175:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7262 (insn, operands);

    case 1176:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7013 (insn, operands);

    case 1177:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7169 (insn, operands);

    case 1178:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7015 (insn, operands);

    case 1179:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7171 (insn, operands);

    case 1180:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7361 (insn, operands);

    case 1181:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7017 (insn, operands);

    case 1182:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7173 (insn, operands);

    case 1183:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7363 (insn, operands);

    case 1184:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7019 (insn, operands);

    case 1185:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7175 (insn, operands);

    case 1186:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7365 (insn, operands);

    case 1187:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7021 (insn, operands);

    case 1188:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7177 (insn, operands);

    case 1189:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7367 (insn, operands);

    case 1190:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7023 (insn, operands);

    case 1191:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7179 (insn, operands);

    case 1192:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7369 (insn, operands);

    case 1193:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7025 (insn, operands);

    case 1194:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7181 (insn, operands);

    case 1195:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7027 (insn, operands);

    case 1196:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7183 (insn, operands);

    case 1197:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7371 (insn, operands);

    case 1198:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7029 (insn, operands);

    case 1199:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7185 (insn, operands);

    case 1200:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7373 (insn, operands);

    case 1201:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7031 (insn, operands);

    case 1202:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7187 (insn, operands);

    case 1203:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7375 (insn, operands);

    case 1204:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7033 (insn, operands);

    case 1205:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7189 (insn, operands);

    case 1206:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7377 (insn, operands);

    case 1207:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7035 (insn, operands);

    case 1208:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7191 (insn, operands);

    case 1209:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7037 (insn, operands);

    case 1210:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7193 (insn, operands);

    case 1211:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7039 (insn, operands);

    case 1212:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7195 (insn, operands);

    case 1213:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7041 (insn, operands);

    case 1214:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7197 (insn, operands);

    case 1215:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7043 (insn, operands);

    case 1216:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7199 (insn, operands);

    case 1217:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7379 (insn, operands);

    case 1218:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7045 (insn, operands);

    case 1219:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7201 (insn, operands);

    case 1220:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7381 (insn, operands);

    case 1221:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7047 (insn, operands);

    case 1222:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7203 (insn, operands);

    case 1223:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7383 (insn, operands);

    case 1224:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7049 (insn, operands);

    case 1225:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7205 (insn, operands);

    case 1226:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7385 (insn, operands);

    case 1227:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7051 (insn, operands);

    case 1228:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7207 (insn, operands);

    case 1229:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7387 (insn, operands);

    case 1230:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7053 (insn, operands);

    case 1231:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7209 (insn, operands);

    case 1232:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7389 (insn, operands);

    case 1233:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7055 (insn, operands);

    case 1234:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7211 (insn, operands);

    case 1235:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7391 (insn, operands);

    case 1236:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7057 (insn, operands);

    case 1237:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7213 (insn, operands);

    case 1238:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7393 (insn, operands);

    case 1239:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7059 (insn, operands);

    case 1240:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7215 (insn, operands);

    case 1241:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7395 (insn, operands);

    case 1242:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7061 (insn, operands);

    case 1243:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7217 (insn, operands);

    case 1244:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7397 (insn, operands);

    case 1245:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7063 (insn, operands);

    case 1246:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7219 (insn, operands);

    case 1247:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7399 (insn, operands);

    case 1248:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7065 (insn, operands);

    case 1249:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7221 (insn, operands);

    case 1250:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7067 (insn, operands);

    case 1251:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7223 (insn, operands);

    case 1252:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7401 (insn, operands);

    case 1253:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7069 (insn, operands);

    case 1254:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7225 (insn, operands);

    case 1255:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7403 (insn, operands);

    case 1256:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7071 (insn, operands);

    case 1257:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7227 (insn, operands);

    case 1258:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7405 (insn, operands);

    case 1259:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7073 (insn, operands);

    case 1260:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7229 (insn, operands);

    case 1261:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7407 (insn, operands);

    case 1262:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7075 (insn, operands);

    case 1263:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7231 (insn, operands);

    case 1264:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7409 (insn, operands);

    case 1265:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7077 (insn, operands);

    case 1266:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7233 (insn, operands);

    case 1267:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7411 (insn, operands);

    case 1268:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7079 (insn, operands);

    case 1269:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7235 (insn, operands);

    case 1270:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7413 (insn, operands);

    case 1271:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7081 (insn, operands);

    case 1272:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7237 (insn, operands);

    case 1273:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7415 (insn, operands);

    case 1274:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7083 (insn, operands);

    case 1275:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7239 (insn, operands);

    case 1276:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7417 (insn, operands);

    case 1277:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7085 (insn, operands);

    case 1278:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7241 (insn, operands);

    case 1279:
      if (!((
#line 476 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 478 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7419 (insn, operands);

    case 1280:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7087 (insn, operands);

    case 1281:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7243 (insn, operands);

    case 1282:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7089 (insn, operands);

    case 1283:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7245 (insn, operands);

    case 1284:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7091 (insn, operands);

    case 1285:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7247 (insn, operands);

    case 1286:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7093 (insn, operands);

    case 1287:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7249 (insn, operands);

    case 1288:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7095 (insn, operands);

    case 1289:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7251 (insn, operands);

    case 1290:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7097 (insn, operands);

    case 1291:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7253 (insn, operands);

    case 1292:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7099 (insn, operands);

    case 1293:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7255 (insn, operands);

    case 1294:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7101 (insn, operands);

    case 1295:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7257 (insn, operands);

    case 1296:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7103 (insn, operands);

    case 1297:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7259 (insn, operands);

    case 1298:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7105 (insn, operands);

    case 1299:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7261 (insn, operands);

    case 1300:
      if (!((
#line 392 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 394 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7107 (insn, operands);

    case 1301:
      if (!((
#line 434 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 436 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7263 (insn, operands);

    case 1302:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7708 (insn, operands);

    case 1303:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7710 (insn, operands);

    case 1304:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7712 (insn, operands);

    case 1305:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7714 (insn, operands);

    case 1306:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7716 (insn, operands);

    case 1307:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7718 (insn, operands);

    case 1308:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7720 (insn, operands);

    case 1309:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7722 (insn, operands);

    case 1310:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7724 (insn, operands);

    case 1311:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7726 (insn, operands);

    case 1312:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7728 (insn, operands);

    case 1313:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7730 (insn, operands);

    case 1314:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7732 (insn, operands);

    case 1315:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7734 (insn, operands);

    case 1316:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7736 (insn, operands);

    case 1317:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7738 (insn, operands);

    case 1318:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7740 (insn, operands);

    case 1319:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7742 (insn, operands);

    case 1320:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7744 (insn, operands);

    case 1321:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7746 (insn, operands);

    case 1322:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7748 (insn, operands);

    case 1323:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7750 (insn, operands);

    case 1324:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7752 (insn, operands);

    case 1325:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7754 (insn, operands);

    case 1326:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7756 (insn, operands);

    case 1327:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7758 (insn, operands);

    case 1328:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7760 (insn, operands);

    case 1329:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7762 (insn, operands);

    case 1330:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7764 (insn, operands);

    case 1331:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7766 (insn, operands);

    case 1332:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7768 (insn, operands);

    case 1333:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7770 (insn, operands);

    case 1334:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7772 (insn, operands);

    case 1335:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7774 (insn, operands);

    case 1336:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7776 (insn, operands);

    case 1337:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7778 (insn, operands);

    case 1338:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7780 (insn, operands);

    case 1339:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7782 (insn, operands);

    case 1340:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7784 (insn, operands);

    case 1341:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7786 (insn, operands);

    case 1342:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7788 (insn, operands);

    case 1343:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7790 (insn, operands);

    case 1344:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7792 (insn, operands);

    case 1345:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7794 (insn, operands);

    case 1346:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7796 (insn, operands);

    case 1347:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7798 (insn, operands);

    case 1348:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7800 (insn, operands);

    case 1349:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7802 (insn, operands);

    case 1350:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7804 (insn, operands);

    case 1351:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7806 (insn, operands);

    case 1352:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7808 (insn, operands);

    case 1353:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7810 (insn, operands);

    case 1354:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7812 (insn, operands);

    case 1355:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7814 (insn, operands);

    case 1356:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7816 (insn, operands);

    case 1357:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7818 (insn, operands);

    case 1358:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7820 (insn, operands);

    case 1359:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7822 (insn, operands);

    case 1360:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7824 (insn, operands);

    case 1361:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7826 (insn, operands);

    case 1362:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7828 (insn, operands);

    case 1363:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7830 (insn, operands);

    case 1364:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7832 (insn, operands);

    case 1365:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7834 (insn, operands);

    case 1366:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7836 (insn, operands);

    case 1367:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7838 (insn, operands);

    case 1368:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7840 (insn, operands);

    case 1369:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7842 (insn, operands);

    case 1370:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7709 (insn, operands);

    case 1371:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7711 (insn, operands);

    case 1372:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7713 (insn, operands);

    case 1373:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7715 (insn, operands);

    case 1374:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7717 (insn, operands);

    case 1375:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7719 (insn, operands);

    case 1376:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7721 (insn, operands);

    case 1377:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7723 (insn, operands);

    case 1378:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7725 (insn, operands);

    case 1379:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7727 (insn, operands);

    case 1380:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7729 (insn, operands);

    case 1381:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7731 (insn, operands);

    case 1382:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7733 (insn, operands);

    case 1383:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7735 (insn, operands);

    case 1384:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7737 (insn, operands);

    case 1385:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7739 (insn, operands);

    case 1386:
      if (!(
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7741 (insn, operands);

    case 1387:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7743 (insn, operands);

    case 1388:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7745 (insn, operands);

    case 1389:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7747 (insn, operands);

    case 1390:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7749 (insn, operands);

    case 1391:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7751 (insn, operands);

    case 1392:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7753 (insn, operands);

    case 1393:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7755 (insn, operands);

    case 1394:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7757 (insn, operands);

    case 1395:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7759 (insn, operands);

    case 1396:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7761 (insn, operands);

    case 1397:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7763 (insn, operands);

    case 1398:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7765 (insn, operands);

    case 1399:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7767 (insn, operands);

    case 1400:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7769 (insn, operands);

    case 1401:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7771 (insn, operands);

    case 1402:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7773 (insn, operands);

    case 1403:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7775 (insn, operands);

    case 1404:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7777 (insn, operands);

    case 1405:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7779 (insn, operands);

    case 1406:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7781 (insn, operands);

    case 1407:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7783 (insn, operands);

    case 1408:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7785 (insn, operands);

    case 1409:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7787 (insn, operands);

    case 1410:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7789 (insn, operands);

    case 1411:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7791 (insn, operands);

    case 1412:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7793 (insn, operands);

    case 1413:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7795 (insn, operands);

    case 1414:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7797 (insn, operands);

    case 1415:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7799 (insn, operands);

    case 1416:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7801 (insn, operands);

    case 1417:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7803 (insn, operands);

    case 1418:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7805 (insn, operands);

    case 1419:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7807 (insn, operands);

    case 1420:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7809 (insn, operands);

    case 1421:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7811 (insn, operands);

    case 1422:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7813 (insn, operands);

    case 1423:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7815 (insn, operands);

    case 1424:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7817 (insn, operands);

    case 1425:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7819 (insn, operands);

    case 1426:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7821 (insn, operands);

    case 1427:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7823 (insn, operands);

    case 1428:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7825 (insn, operands);

    case 1429:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7827 (insn, operands);

    case 1430:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7829 (insn, operands);

    case 1431:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7831 (insn, operands);

    case 1432:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7833 (insn, operands);

    case 1433:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7835 (insn, operands);

    case 1434:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7837 (insn, operands);

    case 1435:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7839 (insn, operands);

    case 1436:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7841 (insn, operands);

    case 1437:
      if (!((
#line 544 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc-15.0.1-20250329/gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)) && 
#line 546 "../../gcc-15.0.1-20250329/gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7843 (insn, operands);

    default:
      return NULL;
    }
}
